1999-10-13  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.3s1

1999-10-12  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (main): On AIX you must lower the stack size using
	ulimit() before calling plock.  Otherwise plock will reserve a lot
	of memory space based on your maximum stack size limit.  Since it
	is not easily possible to tell what should the limit be, I print a
	warning before calling plock(). See the manual pages for
	ulimit(1,3,4) on your AIX system.

	* include/am_defs.h: define default extern for vsnprintf()

	* aux/configure.in: check for extern definition for vsnprintf()

1999-10-08  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amfs_auto.c (amfs_auto_bgmount): patch from Nick Williams
	<njw@ms.com>.  SYMPTOMS: 'occasionally' sublinks do not point to
	the correct location, but to the top level of the mountpoint and
	an (error-hook) is seen being mounted in the log file. This causes
	things to Go Wrong(TM).
	CAUSE: When evaluating two locations which are requested
	'practically simultaneously', and the two locations resolve to the
	same NFS mountpoint (but different sublinks), the later request
	will be "deferred" and retried after wakeup when the first mount
	succeeds. To do this, it rewinds the options location string to
	re-evaluate the location when the mount is retried. However, it
	shouldn't rewind the options for two reasons: (a) the semantics of
	the map language say you shouldn't and (b) the NFS mount reference
	is not reset at the same time, meaning that on the retry it will
	have an options structure out-of-sync with the mount
	structure. The "shortcut" code when retrying the mount sees the
	mount structure is already filled in and does not fully evaluate
	the options structure.... so if the first location is not the one
	which ties in with the mountpoint (see ordering in the
	recreate-by), you're now well messed up.

	* BUGS: mention aix4.3 plock() bug (memory usage blows up and
	plock fails)

1999-10-07  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/GNUmakefile: certain files should be copied if they are
	newer, not also if they are bigger: install-sh, ltconfig,
	ltmain.sh, mdate-sh, missing, mkinstalldirs, and texinfo.tex.

	* minor new port: i586-pc-linux-gnu-rh6.1 (RedHat Linux 6.1)

1999-10-05  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_nfs_prot_headers.m4: prepare for OSF-5.

	* aux/macros/check_nfs_fh_dref.m4: prepare for Tru64, aka OSF-5.

1999-09-30  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0.2					***
	*******************************************************************

1999-09-27  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_linux.c (mount_linux): print the updated mount
	flags.

	* doc/am-utils.texi: document $full_os and $vendor.

	* scripts/amd.conf-sample: examples of $full_os and $vendor.

	* scripts/amd.conf.5: document $full_os and $vendor.

	* amd/conf.c: add support for $full_os and $vendor.

1999-09-26  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (netgrp Selector Function): don't give
	examples with old single '=' assignment variable.  Use foo:=bar.

	* amd/amfs_auto.c (amfs_auto_bgmount): corectly indent long
	comment describing this complex function.

	* doc/Makefile.am (alldocs): do install-ps last (because distiller
	is slow) and install-html next to last (because texi2html is also
	slow).

	* amd/amd.8: Major fixes to the description of the option -t
	timeout.retransmit.

	* doc/am-utils.texi: better description of "trace" debug option.
	amd -H (not -v) shows log_options and debug_options.  Major fixes
	to the description of amd -t timeout.retransmit, and the amd.conf
	parameters nfs_retransmit_counter and nfs_retry_interval.

	* scripts/amd.conf.5: better description of "trace" debug option.
	amd -H (not -v) shows log_options and debug_options.  Major fixes
	to the description of the parameters nfs_retransmit_counter and
	nfs_retry_interval.

1999-09-25  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Automount Filesystem): cache:= is not a mount
	option, but a mount map option.

	* libamu/xutil.c (switch_to_logfile): log the name of the log file
	we switched into, after the log file had been [re]opened.

1999-09-24  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/mapc.c (mapc_reload_map): count and show the number of times
	a map was reloaded.  Only reload a map if its modify-time was
	updated.  But amq -f forced a reload no matter what.

	* amd/amd.h: new flag to struct mnt_map to count number of times a
	map was reloaded.

	* amd/mapc.c (mapc_reload_map): attempt to reload the map without
	losing current data by reloading into a temp copy, and switching
	the hashes round only if the reload was successful.  Patch from Jon
	Peatfield <J.S.Peatfield@damtp.cam.ac.uk>.
	(mapc_sync): mapc_reload_map() always succeeds.

1999-09-22  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_ldap.c (amu_ldap_rebind): don't busy-loop trying to
	rebind to an LDAP server forever.  Try up to 10 times.

	* fsinfo/fsi_lex.l (yyerror): rework code that will never happen

	* released snapshot am-utils-6.0.2s2

	* aux/configure.in: bumped library version-info to 3:2:1, since
	some libamu code got changed.

	* libamu/xutil.c (real_plog): use vsnprintf, not vsprintf, which
	is better and more secure.  Fix from "David O'Brien"
	<obrien@NUXI.com>.

	* aux/configure.in: check for vsnprintf.

1999-09-21  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/linux_headers.m4: use AC_MSG_ERROR.

	* aux/macros/opt_{cppflags,ldflags,libs,amu_cflags}.m4: the ARG is
	not optional.  Make sure ARG is supplied else flag an error.

1999-09-18  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor port i386-unknown-freebsdelf3.3

	* released snapshot am-utils-6.0.2s1

1999-09-17  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in (AC_CHECK_FUNCS): check for getitimer().

	* include/am_defs.h: extern definition for getitimer().

	* aux/configure.in: use AC_CHECK_EXTERNS.  Look for getitimer()
	extern.

	* aux/macros/check_extern.m4: define a simple AC_CHECK_EXTERNS
	that calls AC_CHECK_EXTERN in a loop.  This saves repeated code in
	configure.

	* aux/macros/type_auth_create_gidlist.m4: AIX 4.x systems use
	'int' as the 5th arg to authunix_create().

	* aux/macros/type_recvfrom_fromlen.m4: all AIX 4.x systems use a
	size_t for the 6th arg of recvfrom().

	* aux/macros/os_cflags.m4: define _XOPEN_EXTENDED_SOURCE for
	aix4.x systems.

	* libamu/mount_fs.c (print_nfs_args): cast some values to int, to
	avoid gcc -Wall errors.

	* scripts/expn.in: use sockaddr_in(), not pack() to correctly fill
	in a struct sockaddr_in.  On Solaris x86 hosts, using pack()
	results in byte-misaligned values.   Bug fix from Jeffrey C Honig
	<jch@BSDI.COM>.

	* libamu/mount_fs.c (compute_automounter_mount_flags): turn on
	automntfs (ignore on bsdi-4.1) flag.
	(compute_automounter_nfs_args): ditto.

	* aux/acconfig.h: add new flag for automntfs (ignore)

	* aux/configure.in: check for new automntfs flag (bsdi-4.1).

1999-09-14  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* MIRRORS: added new site in Germany.  Updated status of umn.edu
	and ferginc.com, who may no longer be mirroring am-utils.

1999-09-08  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0.1					***
	*******************************************************************

1999-09-08  Erez Zadok  <ezk@cs.columbia.edu>

	* aux/macros/mount_headers.m4: bsdi-2.1 needs MAXQUOTAS and struct
	netexport defined.

	* aux/macros/try_compile_anyfs.m4: bsdi-2.1 needs MAXQUOTAS and
	struct netexport defined.

1999-09-07  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_field.m4 (ac_upcase_var_name): include
	<ifaddrs.h> so we can detect fields within struct ifaddrs.

	* libamu/wire.c (getwire): bsdi-2.1 uses a second arg to
	getifaddrs() and struct ifaddrs has no ifa_next field.

	* aux/configure.in: check if 'struct ifaddrs' has a field
	ifa_next.

	* include/amq_defs.h (AMQ_STRLEN): double size of amq string
	length to 2048 bytes.

	* conf/nfs_prot/nfs_prot_netbsd1_4.h: include several more nfs
	header files and ufs/ufs/ufsmount.h.  Bug reported by <Christos
	Zoulas> christos@zoulas.com.

	* aux/macros/try_compile_anyfs.m4: include <ufs/ufs/ufsmount.h>.
	Bug reported by <Christos Zoulas> christos@zoulas.com.

	* aux/macros/mount_headers.m4: include <ufs/ufs/ufsmount.h>

1999-09-06  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/xutil.c (expand_error): use strerror if available instead
	of sys_errlist.  Bug reported by <Christos Zoulas>
	christos@zoulas.com.

	* hlfsd/hlfsd.c (fatal): use strerror if available instead of
	sys_errlist.

	* amq/amq.c (show_mi): use strerror if available instead of
	sys_errlist.

	* aux/macros/check_nfs_prot_headers.m4: make sure netbsd1.4
	nfs_prot header is used for any future (1.5 etc.) netbsd systems.

	* amq/pawd.c (find_mt): check for type nfsl as well.  Fix from
	"Andrew J. Korty" <ajk@purdue.edu>

1999-08-29  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): updates for redhat
	systems.

	* INSTALL: updates for redhat systems.

	* libamu/wire.c (getwire_lookup): spell "succeeded" correctly

1999-08-28  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-amd.in: sleep 1 second between killing amd and
	restarting it, because amq may respond that amd is down, where in
	fact it is still trying to unmount itself after unmapping itself
	from the portmapper.

	* aux/config.guess.long: new script to print long version of
	config.guess output.

	* buildall (host_alias): use long version of config.guess.

1999-08-27  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-{amd,hlfsd}.in: update RH tags for start/stop
	scripts.

1999-08-24  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s11

	* libamu/xutil.c (expand_error): make sure expanding the string
	with textual version of errno doesn't overrun the 1024 bytes
	buffer.
	(real_plog): null terminate msg, just in case.

	* amq/amq.c (main): don't getopt -M option and don't process it
	unless ENABLE_AMQ_MOUNT is on.

	* amd/amq_svc.c (amq_program_1): all code that relates to amq -M
	is conditional on #ifdef ENABLE_AMQ_MOUNT.

	* amd/amq_subr.c: remove amqproc_mount_1_svc() function invoked
	when amq -M code is disabled.  Not taking any chances.

1999-08-23  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s10

Sun Aug 22 16:18:59 1999  Erez Zadok  <ezk@subzero.cs.columbia.edu>

	* libamu/wire.c (getwire_lookup): if getnetbyaddr failed (e.g., on
	128.59.16.0), try to shift the network out of zeros (e.g.,
	128.59.16) and try again.  Irix 6.4 requires short network
	numbers.

1999-08-22  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/wire.c (getwire_lookup): correctly compute subnet using
	netmask.

	* libamu/mount_fs.c (compute_automounter_nfs_args): require that
	Amd's own NFS mounts use reserved ports (if possible).  IP packet
	security fix from Jeffrey C Honig <jch@BSDI.COM>.

	* conf/transp/transp_tli.c (create_autofs_service): use correct
	autofs_port.  IP packet security fix from Jeffrey C Honig
	<jch@BSDI.COM>.

	* conf/transp/transp_sockets.c (bindnfs_port): remove unnecessary
	function.  IP packet security fix from Jeffrey C Honig
	<jch@BSDI.COM>.
	(create_nfs_service): use bind_resv_port() directly.  ensure that
	privileged ports are used.  IP packet security fix from Jeffrey C
	Honig <jch@BSDI.COM>.

	* amd/nfs_prot_svc.c (nfs_program_2): verify that requests come
	from reserved ports and from a local IP address.  IP packet
	security fix from Jeffrey C Honig <jch@BSDI.COM>.

	* amd/amq_subr.c (ok_security): use IPPORT_RESERVED, instead of
	hard-coded 1024.  IP packet security fix from Jeffrey C Honig
	<jch@BSDI.COM>.
	(amqproc_mount_1_svc): provide information on the caller making an
	amq -M request.  IP packet security fix from Jeffrey C Honig
	<jch@BSDI.COM>.

	* amd/map.c (free_map_if_success): If the program doing an unmount
	of a program filesystem fails, amd tries to interpret the return
	code as an errno.  Fix from Jeffrey C Honig <jch@BSDI.COM>.

	* amd/info_nis.c (determine_nis_domain): don't always print
	warning about NIS domain name not being set, even if NIS is not in
	use.

1999-08-21  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_ldap.c (get_ldap_timestamp): initialize variable err.
	(amu_ldap_search): initialize variable err.

1999-08-16  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/wire.c: written using getifaddrs() for BSD systems,
	contributed by BSDI, Jeffrey C Honig <jch@BSDI.COM>).

1999-08-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_utils.h (SALLOC): a simple macro to allocate N bytes.

	* aux/configure.in: check for irs.h and ifaddrs.h.
	Increase libamu.so --version-info to 3:1:1 since we've changed the
	source code for the library.
	Check for getifaddrs() function.

1999-08-14  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (print_nfs_args): print fields namlen and
	bsize if they exist.

	* conf/mount/mount_linux.c (mount_linux): set nfs_args_t->namlen
	and ->bsize fields correctly, if those fields exist.  This is a
	bug in that amd neglected to set these fields, but told the
	kernel it is mounting the nfs_args_t structure using mount version
	3 (which requires both bsize and namlen fields).

	* aux/configure.in: test for two new nfs_args_t fields (used on
	newer linux with mount versions 2 and 3): bsize and namlen.

	* doc/am-utils.texi (netgrpd Selector Function): document new
	selector function.

	* amd/opts.c (f_netgrpd): new amd map function netgrpd(ARG) to
	test if the current host (fully-qualified name) is in the ARG host
	netgroup.  The netgrp() function uses the short form of a host
	name.  Patch from Christophe Kalt <Christophe-Kalt@deshaw.com>.

	* doc/am-utils.texi (automount2amd): document new script.

	* scripts/Makefile.am: create, install, and distribute
	automount2amd perl script and its man page.

	* scripts/automount2amd.8: new man page for automount2amd.

	* scripts/automount2amd.in: new file, contributed a in 1993 by
	Mike Walker <mike@tab00.larc.nasa.gov>.  Fixed to use addopts for
	any automount map options specified.

1999-08-09  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s9

1999-08-09  Erez Zadok  <ezk@beetle.mcl.cs.columbia.edu>

	* amd/amfs_auto.c (DOT_DOT_COOKIE): set the NFS cookie of '..' to
	1.
	(amfs_auto_readdir): use DOT_DOT_COOKIE instead of (u_int)~0.
	(amfs_auto_readdir_browsable): use DOT_DOT_COOKIE instead of
	(u_int)~0.

	* amd/mapc.c (make_entry_chain): NFS cookies should be
	monotonically increasing, because Linux 2.3 expects that, even
	though it is not in the spec (RFC-1094) for NFS V2.

1999-08-06  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_lib_funcs.m4: removed unused macro.

	* aux/macros/linux_headers.m4: new macro to ensure that linux
	kernel headers match running kernel version.

	* aux/acconfig.h: define HOST_HEADER_VERSION so we can check if
	amd is configured on linux hosts that run one kernel but have
	headers for a different version.

	* amd/info_nis.c (nis_isup, nis_search, nis_init): fixes for the
	logic which uses nis_isup and has_yp_order.  Make sure it is used
	correctly , esp. for NIS+ in NIS-compatibility mode.  Bug fix from
	Peter Breitenlohner <peb@mppmu.mpg.de>.

	* include/am_defs.h: fix conflicts on linux 2.2 systems with older
	libc5.  Bug fix from Peter Breitenlohner <peb@mppmu.mpg.de>.

	* scripts/lostaltmail.in: use sockaddr_in(), not pack() to
	correctly fill in a struct sockaddr_in.  On Solaris x86 hosts,
	using pack() results in byte-misaligned values.

1999-08-02  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mtab/mtab_aix.c (mnt_dup): add support for nfs3
	mounting, as per Dale Talcott <aeh@quest.cc.purdue.edu>.  Also use
	better macros for case statement.

	* conf/nfs_prot/nfs_prot_sunos5_7.h: don't include ldap structures
	unless ldap is actually available.

	* use updated config.guess and config.sub.  Use newer automake
	that fixes problems with distributing optional libamu files
	(clnt_sperrno.c, hasmntopt.c, strcasecmp.c, strdup.c, strstr.c,
	and ualarm.c)

1999-07-19  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor port i386-unknown-openbsd2.5

1999-07-17  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor ports to freebsdelf 3.[0-2] and 4.0 completed

	* aux/macros/check_nfs_prot_headers.m4: support freebsdelf

	* aux/macros/check_nfs_socket_connection.m4: support freebsdelf

1999-06-24  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s8

1999-06-23  Erez Zadok  <ezk@beetle.mcl.cs.columbia.edu>

	* include/am_defs.h: avoid various header conflicts on
	RedHat/Linux 6.0 and kernels 2.2.10 or newer.

	* aux/configure.in: look for <db1/ndbm.h> (RedHat/Linux 6.0 and
	kernel 2.2.10)

	* amd/amfs_program.c (amfs_program_exec): make sure logfp is
	initialized dynamically to stderr if needed.

	* libamu/xutil.c (dplog): make sure logfp is initialized
	dynamically to stderr if needed.
	(plog): ditto.

	* amd/amfs_program.c (amfs_program_exec): set logfp to stderr if
	not initialized.

	* libamu/xutil.c: don't initialize logfp statically to stderr,
	because on RedHat/Linux 6.0 (kernel 2.2.10) stderr can no longer
	be manipulated like a variable.

	* include/am_defs.h: avoid more conflicts between <linux/fs.h> and
	<sys/mount.h> on 2.2 linux kernels.
	include <db1/ndbm.h> as needed (RedHat/Linux 6.0)

1999-04-20  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* all Makefile.am: use AMU_NFS_PROT_HEADER (not *_HEADERS)

	* aux/macros/check_nfs_prot_headers.m4 (AMU_NFS_PROT_HEADER):
	renamed AC_SUBST name from *_HEADERS to *_HEADER so that automake
	won't attempt to add it to the header files to distribute.

1999-04-19  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/GNUmakefile: invoke aclocal with new --altdir flag.

1999-04-16  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor new port: i386-unknown-netbsd1.4 (ALPHA)

	* aux/macros/check_field.m4: no need to include <cdfs/cdfsmount.h>
	and <isofs/cd9660/cd9660_mount.h> because they are also included
	from MOUNT_HEADERS.  Causes multiple inclusion of unprotected
	headers on netbsd-1.4_ALPHA.

1999-04-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/extern_sys_errlist.m4 (pattern): netbsd-1.4_ALPHA's
	sys_errlist extern doesn't end with [].

	* aux/macros/check_nfs_prot_headers.m4: netbsd 1.4 support.

1999-04-11  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* newer automake wants texinfo.tex to be in aux/ not doc/

1999-03-30  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf_parse.y: alloca support.

	* fsinfo/fsi_gram.y: alloca support.

	* libamu/Makefile.am (libamu_la_LIBADD): compile alloca.o if
	needed.

	* aux/configure.in: test for alloca support.  Needed because bison
	generates parsers that use alloca, and hpux9 does have alloca and
	its /bin/cc doesn't support it builtin (the way gcc does).

	* libamu/alloca.c: new file, needed on hpux9 with /bin/cc.  Taken
	verbatim from bison-1.25.

	* include/am_defs.h: fixed typo #errir -> #error

	* released snapshot am-utils-6.0.1s7

	* README.y2k: more information about am-utils' compatibility, from
	Paul Balyoz <pbalyoz@sedona.ch.intel.com>.

	* scripts/lostaltmail.in (Splice_in_resent_headers): ensure Y2K
	compliant format.  Patch from Paul Balyoz
	<pbalyoz@sedona.ch.intel.com>

	* doc/am-utils.texi (Supported Platforms): hpux10.20 could have
	nfs v.3 support (with some vendor patches), but it is turned off.

	* aux/macros/os_cflags.m4: use ansi compiler options on hpux.

	* conf/nfs_prot/nfs_prot_hpux.h: Turn off NFS V.3 support to avoid
	confusing am-utils.  10.20 with some patches has incomplete
	support.  Patch from Jon Peatfield
	<J.S.Peatfield@damtp.cam.ac.uk>.

1999-03-24  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor port i386-pc-bsdi4.0.1

1999-03-20  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): add forgotten listing
	for powerpc-linux.

1999-03-18  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/amd.conf.5: fix typo.  From Jeffrey C Honig
	<jch@BSDI.COM>.

	* doc/am-utils.texi: document iso9660 options norrip, gens, and
	extatt.
	(opts Option): documented dumbtimr and noauto options.  From
	Jeffrey C Honig <jch@BSDI.COM>.

	* include/am_compat.h: define default strings for options norrip,
	gens, and extatt.

	* amd/ops_cdfs.c (mount_cdfs): support options norrip, gens, and
	extatt.

	* aux/macros/mount_headers.m4: also include
	<isofs/cd9660/cd9660_mount.h> as needed.

	* aux/configure.in: check for isofs mount options for bsdi4:
	norrip, gens, and extatt.  Reported by Jeffrey C Honig
	<jch@BSDI.COM>.

	* aux/macros/check_mnt2_cdfs_opt.m4: check for ISOFSMNT_* flags
	(bsdi4).

1999-03-17  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_freebsd3.h: ditto.

	* conf/nfs_prot/nfs_prot_bsdi3.h: include <ufs/ufs/ufsmount.h>,
	for bsdi4, as per Jeffrey C Honig <jch@BSDI.COM>.

1999-03-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* get latest copies of config.guess, config.sub, ltconfig, and
	ltmain.sh from libtool-1.2f.

	* all Makefile.am: don't use continuation lines (using \) for
	short lists of files.

	* libamu/Makefile.am (DISTCLEANFILES): make distclean should
	remove mountutil.c, mtabutil.c, transputil.c, and umount_fs.c.
	Reported by Jeffrey C Honig <jch@BSDI.COM>.

	* fixmount/Makefile.am (DISTCLEANFILES): make distclean should
	remove checkmount.c.  Reported by Jeffrey C Honig <jch@BSDI.COM>.

	* Makefile.am (DISTCLEANFILES): make distclean should remove
	amu_nfs_prot.h, config.cache.old, and dbgcf.h.  Reported by
	Jeffrey C Honig <jch@BSDI.COM>.

1999-03-13  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s6

1999-03-12  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* INSTALL: document freebsdelf.

	* doc/am-utils.texi (Supported Platforms): document freebsdelf.

1999-03-08  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor new ports: i386-unknown-freebsdelf3.1 and
	i386-unknown-freebsdelf4.0

	* aux/macros/check_nfs_prot_headers.m4: freebsd4 support.

	* aux/macros/check_nfs_socket_connection.m4: freebsd4 support.

	* aux/macros/check_nfs_fh_dref.m4: freebsd4 support.

	* amd/opts.c (eval_opts): changed log level of "executing
	negated..." message from USER to INFO, as per Guntram Wolski
	<gwolsk@sei.com>.

1999-02-17  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* */Makefile.am (LDADD): force linking against an installed
	libamu.{a,so}.

	* doc/am-utils.texi (addopts Option): document remopts interaction
	with addopts.

	* amd/am_ops.c (ops_match): if addopts are specified, apply them
	to the value of remopts as well as opts.

	* amd/ops_nfs.c (mount_nfs_fh): tell users when remopts are used.

1999-02-05  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s5

	* conf/mount/mount_linux.c (mount_linux): set default nfs_args
	options for ac{reg,dir}{min,man} as per the mount-2.8a package,
	but only if noac option was not used.

1999-02-05  Erez Zadok  <ezk@retro.cs.columbia.edu>

	* conf/mount/mount_linux.c (mount_linux): print nfs_args again
	since it was updated.
	(mount_linux): use 4KB for NFS rsize/wsize on 2.1.0 linux kernels
	and newer.  Bug was found by Neil Conway
	<nconway.list@ukaea.org.uk>

1999-02-04  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s4

1999-02-03  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c (main): don't list -M as a valid amq option unless
	configure'd with --enable-amq-mount.

Wed Feb  3 18:11:18 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* amd/nfs_start.c (amd_use_autofs): Define.
	(mount_automounter): Create autofs service listener only if
	necessary to avoid unnecessary clashes with e.g. automountd.

	* amd/amd.h (amd_use_autofs): Declare.

	* amd/conf.c (gopt_mount_type): Set amd_use_autofs.
	(ropt_mount_type): Likewise.

1999-02-02  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_mnt2_nfs_opt.m4:: ditto

	* aux/macros/check_mnt2_cdfs_opt.m4: ditto

	* aux/macros/check_mnt2_gen_opt.m4: ditto

	* aux/macros/check_mnttab_opt.m4: new macro in this file to loop
	over AC_CHECK_MNTTAB_OPT.  Reduces size of configure script a lot.

	* conf/nfs_prot/nfs_prot_netbsd1_3.h: include nfs/rpcv2.h,
	nfs/nfs.h and nfs/nfsmount.h if they exist.  Patch from
	christos@zoulas.com (Christos Zoulas).

	* amd/info_hesiod.c: some forward declarations.  Patch from
	christos@zoulas.com (Christos Zoulas).

1999-01-28  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (compute_nfs_args): don't turn on/off noconn
	option if it was already in that state.  Patch from David
	Wolfskill <dhw@whistle.com>.

1999-01-20  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: automake nowadays supports LTLIBOBJS (but not
	LTALLOCA yet).  Substitute value of LIBTOOL_DEPS for libtool
	rebuild make rules.

	* Makefile.am: new rules to remake libtool (maintainers only)

	* amd/amfs_toplvl.c (mount_amfs_toplvl): print generic mount flags
	if -D trace was used.

1999-01-18  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* buildall: all if statements should have an else clause because
	of Ultrix's /bin/sh.

1999-01-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c: removed dummy variables.

	* amq/pawd.c: removed dummy variable.s

	* fixmount/fixmount.c (usage): removed dummy variables.

	* fsinfo/fsinfo.c: removed dummy variables.

	* hlfsd/hlfsd.c: removed dummy variables.

	* wire-test/wire-test.c: removed dummy variables.

	* mk-amd-map/mk-amd-map.c: removed dummy variables.

	* doc/texinfo.tex: updates from GNU mirror.

	* aux/GNUmakefile (../doc/texinfo.tex): new rule to update
	doc/texinfo.tex from GNU mirror.

	* released snapshot am-utils-6.0.1s3

	* Makefile.am (install-snapshot): better snapshot and new
	install-snapshot and test-snapshot rules (maintainer).

	* amd/info_ldap.c (amu_ldap_init): don't run STREQ if one of the
	args may be NULL.
	Some dlog() entries were not enclosed in #ifdef DEBUG.  Fix from
	Bill Paul <wpaul@ctr.columbia.edu>

1999-01-13  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* check for experimental generic 'ignore' mount flag on freebsd3.

	* Update library -version-info to 3:0:1 (will result in 2.1.0 .so
	version, which is backwards compatible with older versions.)  Only
	one new interface was added to libamu.

	* amd/amfs_toplvl.c (mount_amfs_toplvl): add generic mount flags
	that are specific to automounter mounts.

	* aux/configure.in: update libamu.so age and revision since a new
	interface was added to libamu/mount_fs.c
	(compute_automounter_mount_flags).

	* libamu/mount_fs.c (compute_automounter_mount_flags): new
	function to compute generic mount flags that are specific to mount
	points only.

	* aux/{configure.in,acconfig.h}: add support for generic mount
	entry ignore option.

	* released snapshot am-utils-6.0.1s2

	* amd/info_ldap.c (get_ldap_timestamp): dlog format fixes.

	* libamu/mount_fs.c (print_nfs_args): solaris 2.7 changed format
	of knc_semantics from u_long to u_int.

	* aux/macros/check_mount_style.m4: freebsd3 no longer needs a
	special mount helper.

1999-01-12  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_nfs_prot_headers.m4 (AMU_NFS_PROT_HEADERS):
	amu_nfs_conf.h should always be found in $top_builddir.

Tue Jan 12 00:05:42 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* conf/nfs_prot/nfs_prot_sunos5_7.h (MNTTAB_TYPE_AUTOFS): Undefine
	to avoid wrong reports from show_fstypes.

	* conf/nfs_prot/nfs_prot_irix5.h (MNTTAB_TYPE_XFS): Likewise.

	* conf/nfs_prot/nfs_prot_hpux11.h (MNTTAB_TYPE_NFS3): Likewise.

Tue Jan 12 00:05:42 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* BUGS (mips-dec-ultrix4.3): Update Ultrix caveats.

Tue Jan 12 00:05:42 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* hlfsd/homedir.c (delay): Cast child to long, adapt format.
	(hlfsd_getpwent): Likewise for pw_uid.

	* amd/info_nis.c (nis_init): Cast order to unsigned long, adapt
	format. 

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): Cast
	tv_sec to int to match format.
	(get_nfs_version): Cast nfs_version, NFS_VERSION to int to match
	formats. 

	* amd/amfs_program.c (amfs_program_exec): Cast ptr difference to
	long, adapt format.

	* include/am_defs.h: Handle __attribute__ if available.  From
	GNU fileutils 4.0 lib/errors.h.

Mon Jan 11 13:46:44 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* libamu/mount_fs.c (print_nfs_args): Cast sizeof() to int to
	match format.

	* hlfsd/stubs.c (nfsproc_getattr_2_svc): Cast uid, gid to long,
	adapt format.
	(nfsproc_lookup_2_svc): Likewise.
	(nfsproc_readlink_2_svc): Likewise for userid, groupid.

	* hlfsd/nfs_prot_svc.c (nfs_program_2): Cast args to int to match
	format.

	* hlfsd/homedir.c (homedir): Cast uid, child to long, adapt
	format. 

	* amd/info_hesiod.c (hesiod_search): Cast m, pval, tp to unsigned
	long, adapt format.

	* amd/ops_nfs.c (find_nfs_fhandle_cache): Cast fh_wchan to
	unsigned long, adapt format.
	(got_nfs_fh): Likewise.
	(prime_nfs_fhandle_cache): Cast fh_nfs_version to int to match
	format. 
	(call_mountd): Likewise, mnt_version also.
	(mount_nfs_fh): Likewise.

	* amd/ops_autofs.c (autofs_program_1): Cast args to int to match
	format.
	(autofs_unmount_1_svc): Cast ur->devid, ur_rdevid, ur->next to
	unsigned long, adapt formats.
	(autofs_bgmount): Cast opt_fs to unsigned to, adapt format.
	(autofs_bgmount): Use long format to match arg.
	(autofs_lookuppn): Removed superfluous arg.

	* amd/srvr_nfs.c (start_ping): Cast nfs_version to int to match
	format. 
	(got_portmap): Likewise for port.
	(recompute_portmap): Likewise for fs->fs_version, mnt_version.
	(find_nfs_srvr): Likewise for nfs_version.

	* amd/sched.c (sched_task): Cast wchan to unsigned long, adapt
	format. 

	* amd/nfs_start.c (checkup): Cast ptr difference to long, next_mem
	to unsigned long, adapt format.
	Cast tvv.tv_sec to int to match format.

	* amd/nfs_prot_svc.c (nfs_program_2): Cast args to int to match
	format.

	* amd/map.c (root_fh): Cast pid to long, adapt format.
	(timeout_mp): Cast time_t to long, adapt format.

	* amd/clock.c (reschedule_timeouts): Use long format, cast time_t
	arg.

	* amd/amfs_host.c (fetch_fhandle): Cast nfs_version to int to
	match format.
	(amfs_host_fmount): Likewise.
	(amfs_host_umounted): Likewise.  Removed superfluous arg.

	* amd/amfs_auto.c (amfs_auto_bgmount): Cast pointer to unsigned
	long, adapt format.
	(amfs_auto_bgmount): Use long format, cast time_t arg.
	(amfs_auto_lookuppn): Removed superfluous arg.

	* amd/amd.c (main): Cast geteuid() result to long, adapt format.

	* conf/transp/transp_sockets.c (get_nfs_version): Cast nfs_version
	to int to match format.

	* include/am_utils.h: Declare plog, dplog as printf-like.

	* conf/mount/mount_irix6.c (mount_irix): Print type as char *.

Mon Jan 11 13:46:44 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* amd/info_hesiod.c (hesiod_isup): New function.
	* amd/mapc.c (maptypes): Add it.

1999-01-10  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0.1s1

1999-01-09  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* ALL: bump copyright year to 1999.

Fri Jan  8 15:24:15 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* aux/macros/check_mtype_type.m4: Ultrix uses an int mount type,
	too. 

	* aux/macros/check_mtype_printf_type.m4: Adapt corresponding
	printf type.

Fri Jan  8 15:24:15 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* aux/acconfig.h: Removed HAVE_AM_FS_AUTOFS, unused.

	* conf/nfs_prot/nfs_prot_irix6.h: Likewise.

	* conf/nfs_prot/nfs_prot_sunos5_6.h: Likewise.

	* conf/nfs_prot/nfs_prot_sunos5_7.h: Likewise.

	* Makefile.am (EXTRA_DIST_DIRS): Removed, not needed by current
	automake.

Thu Jan  7 02:55:18 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* aux/configure.in (AM_PROG_YACC): Replaced by AC_PROG_YACC, not
	in current automake.

Thu Jan  7 02:55:18 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* doc/am-utils.texi: Added some missing inter-punctation after
	@xref, or use @pxref/@ref as appropriate.  Spotted by makeinfo
	from texinfo 3.12b.

1999-01-07  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/texinfo.tex: updated off of latest GNU mirror.

1999-01-04  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): update platforms that
	support NFS v.3.  Nicer postscript printing on double-sided pages.

	* amd/info_hesiod.c: add extern definition for hesiod_init()

1999-01-01  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0					***
	*******************************************************************

1998-12-28  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5_7.h: support ldap in solaris 2.7.

1998-12-27  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_bsdi3.h: don't use reserved ports on
	bsdi4 for NFS V3/nfs mounts.

1998-12-26  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* using latest libtool (1.2e + patches), now supporting shared
	libraries on many more systems.  Also using latest autoconf and
	automake (unreleased GNU CVS'd versions.)

	* minor new ports: hppa2.0w-hp-hpux11.00,
	i386-unknown-netbsd1.3.3, mips-sgi-irix6.5.

	* fsinfo/fsinfo.h (yywrap): define it for systems (osf4) that
	have /usr/bin/flex but not libfl.

1998-12-24  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* lots of code cleanup, to make sure libamu.so does not use
	undefined symbols.  Some system's shared libraries cannot handle
	that.

1998-12-23  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_defs.h: only defined seteuid extern if function also
	exists and is not superceded by setresuid (hpux).

	* amd/ops_autofs.c (autofs_bgmount, autofs_lookuppn): put explicit
	braces to avoid confusion with nested if-then-else clauses.

	* aux/config.{sub,status}, aux/{ltmain.sh,ltconfig,mkinstalldirs:
	updated from latest versions.

1998-12-22  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor new port: i386-pc-bsdi4.0

	* conf/nfs_prot/nfs_prot_bsdi3.h: add missing hesiod header
	definitions for bsdi4.

	* {amd,fsinfo}/Makefile.am: force path to .y/.l files, because
	some make programs (bsdi4) do not support VPATH correctly.

1998-12-16  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_aix.c: minor code cleanup

	* aux/configure.in: check for extern definition to xdr_groups.

1998-12-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor new port: powerpc-ibm-aix4.3.1.0

	* aux/macros/*.m4: updates for aix 4.3

1998-12-14  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* minor new port: i386-unknown-openbsd2.4

	* aux/configure.in: don't check for xfs on openbsd because
	openbsd-2.4 introduces a new file system named xfs, but different
	than Irix's XFS.  Sigh.

	* minor new port: i386-unknown-freebsd2.2.8

1998-12-03  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amfs_nfsl.c (amfs_nfsl_ffserver): use case insensitive host
	name match.  Bug fix from Douglas K. Rand" <rand@aero.und.edu>.

1998-11-20  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-amd.in: wait4amd2die runs in the stop action, to
	avoid race conditions when shutting down systems running amd.

	* Makefile.am: add a dist-hook to change modes of the directories
	in the tar file so they are not world writable.

	* conf/nfs_prot/nfs_prot_freebsd3.h: turned on NFSv3 support,
	since it is now finally defined in the header files and
	(hopefully) stable.

	* amd/srvr_nfs.c (find_nfs_srvr): allow overriding if nfsv2 option
	is specified in mount options.  freebsd patches from David
	O'Brien.

	* amq/amq.c (main), fixmount/fixmount.c (main), hlfsd/hlfsd.c
	(main), fsinfo/fsinfo.c (fsi_get_args), hlfsd/hlfsd.c (main),
	amd/get_args.c (get_args): posix: use -1 to check for return from
	getopt() (not EOF), as per posix.

	* amd/amq_subr.c (xdr_amq_mount_tree_node): patches from "David
	O'Brien" <obrien@NUXI.com>, from the FreeBSD source tree.  Use
	real variable whose pointer is on the stack for decoding a long
	int.

1998-11-11  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-{amd,hlfsd}.in: include comments useful for redhat's
	chkconfig utility.

1998-11-10  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0b2s3

	* conf/transp/transp_sockets.c (create_nfs_service): remove C++
	style comments.

1998-11-04  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0b2s2

	* created CVS package

	* amd/nfs_subr.c (nfsproc_lookup_2_svc): try to avoid a race
	condition between unmounting and re-mounting an entry, by
	increasing the ttl of a looked up entry before unmounting it.
	Patch from Mike Mitchell <mcm@unx.sas.com>.

	* All files: spell comments and strings.

1998-11-03  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: look for yp_all in libnsl only if yp_all not
	already found elsewhere (in libc or other default libraries).
	This is so RedHat 5.1 systems could find yp functions in libnsl,
	but also so AIX 4.2.1 will NOT include libnsl, because the latter
	has broken nis functionality that also exists and works ok in libc.

1998-10-29  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (main): bug fix: swapped arguments to kill(2).  Fix
	from Danny Rathjens <dkr@cs.fiu.edu>.

1998-10-28  Erez Zadok  <ezk@spruce.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0b2s1

1998-10-27  Erez Zadok  <ezk@spruce.mcl.cs.columbia.edu>

	* aux/macros/*.m4: support bsdi4 as bsdi3.

	* aux/macros/os_ldflags.m4: enable detection of LDAP on solaris
	2.7 (libraries located in /usr/lib/fn).  This is off until Sun
	includes LDAP header information.

1998-10-20  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0b1					***
	*******************************************************************

1998-10-18  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* mk-amd-map/mk-amd-map.c (main): use perror not strerror.
	(main): set return type to int if no ndbm maps.

	* include/am_defs.h: avoid conflicts with <sys/mount.h> in 2.1
	kernels.

1998-10-18  Erez Zadok  <ezk@london.mcl.cs.columbia.edu>

	* A.i386-unknown-netbsd1.3.2/amu_nfs_prot.h: trim down and cleanup
	for netbsd 1.3.2.

1998-10-17  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: check for yp_all in libnsl, b/c redhat 5.1
	systems put NIS functions there.

	* mk-amd-map/mk-amd-map.c: patch from "David O'Brien"
	<obrien@NUXI.com> merged in.  Use POSIX -1 return code from
	getopt(), not EOF.  Use .db extentions for systems that use it,
	instead of .{pag,dir}.

1998-10-15  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* wire-test/wire-test.c, hlfsd/hlfsd.c, fixmount/fixmount.c,
	amd/amd.c (main): avoid overrunning hostname buffer.  Bug fix from
	"David O'Brien" <obrien@NUXI.com>.

	* scripts/amd.conf.5: minor typo reported by "David O'Brien"
	<obrien@NUXI.com> in .TH section of man page.

	* amd/info_nis.c (am_yp_all): don't leak key-val entries.  Patch
	from Thomas Richter <richter@chemie.fu-berlin.de>.

1998-10-12  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Program Filesystem): minor typo fixed as per
	Andreas Stolcke <stolcke@speech.sri.com>.

	* minor new ports: sparc64-unknown-linux-gnu, i386-pc-solaris2.7,
	and sparc-sun-solaris2.7.

	* conf/mount/mount_freebsd3.c (mount_freebsd3): freebsd 3.0 is now
	a 4.4lite kernel, and somethings were removed, such as
	INITMOUNTNAMES.

	* amd/ops_autofs.c (autofs_lookuppn): don't leak memory while
	processing /defaults.  Free temporary opts.  Patch from
	dsr@mail.lns.cornell.edu (Daniel S. Riley)

	* amd/amfs_auto.c (amfs_auto_lookuppn): don't leak memory while
	processing /defaults.  Free temporary opts.  Patch from
	dsr@mail.lns.cornell.edu (Daniel S. Riley)

	* conf/mtab/mtab_osf.c (read_mtab): patch from
	 dsr@mail.lns.cornell.edu (Daniel S. Riley) not to access
	 uninitialized memory on Digital Unix.

1998-10-09  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/{check_mtype_type,check_mtype_printf_type}.m4: most
	systems now use "char *" as their mount type.

1998-10-08  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (gopt_map_type, ropt_map_type): check if map type
	exists.

	* amd/mapc.c (mapc_type_exists): function to test if a map of
	certain type exists.

1998-10-08  Erez Zadok  <ezk@horatio.mcl.cs.columbia.edu>

	* aux/macros/{mount_headers,try_compile_anyfs,try_compile_nfs}.m4,
	include/am_defs.h: Avoid a conflict in definitions of ntohl/htonl
	in RH-5.1 sparc64 between <netinet/in.h> and
	<linux/byteorder/generic.h> (2.1 kernels).

1998-09-28  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/func_bad_yp_all.m4 (ac_cv_func_yp_all_clean): RedHat
	5.1 systems with glibc glibc-2.0.7-19 or below leak a UDP socket
	from yp_all().

1998-09-25  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_linux.c (parse_opts): check for pcfs support
	only if autoconfigured.

1998-09-18  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* Makefile.am (EXTRA_DIST): distribute README.yk2 file.

	* README.y2k: explain y2k compliance status of am-utils.

1998-09-16  Erez Zadok  <ezk@iguana.mcl.cs.columbia.edu>

	* amd/amfs_host.c (fetch_fhandle, amfs_host_fmount,
	amfs_host_umounted): clnt_sperrno() may return a const.

Sat Aug  8 23:28:32 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: check for <nfs/nfsmount.h>, as per Christos
	Zoulas. Turned on checking for mount options: async, synchronous,
	deadthresh, leasterm, nqnfs, and readahead.

	* amd/info_nis.c: patch from christos@zoulas.com (Christos Zoulas)
	to include prototype definition for nis_isup().

Sun Jul 19 18:50:10 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/stubs.c (getcreds): force sscanf arg to u_long.

Tue Jul 14 20:34:25 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0a17s1

Wed Jul  8 21:49:15 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/host_macros.m4: all x86 hosts should have $arch be
	i386, not i[456]86.

Tue Jul  7 18:55:09 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/{mount_headers,try_compile_anyfs,try_compile_nfs}.m4,
	include/am_defs.h: include <linux/posix_types.h> before
	<linux/fs.h> because on redhat 5.1, there is a bug (misuse) of
	headers in <socketbits.h> (it defines _LINUX_TYPES_H instead of
	__KERNEL_STRICT_NAMES).

	* aux/configure.in: check for <linux/posix_types.h> because it is
	need for RedHat 5.1.

Wed Jun 17 00:05:33 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/Makefile.am (EXTRA_DIST): have fixrmtab generated from
	.in as well, so it doesn't get removed by make clean.

Tue Jun 16 22:00:15 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/{check_fs_mntent.m4, check_mnttab_type.m4,
	check_mount_type.m4}: redhat 5.1 puts some modules in
	/lib/modules/preferred/.

Wed May 13 16:33:57 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_autofs.c (mount_autofs): cast pid to long.

Tue Apr 28 15:12:36 1998  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* conf/nfs_prot/nfs_prot/nfs_prot_irix6.h,
	conf/nfs_prot/nfs_prot_sunos5_6.h: Undef MNTTAB_TYPE_AUTOFS too to
	avoid amd/am_ops.c (show_fstypes) from erroneously claiming
	support.

Fri Apr 24 23:02:11 1998  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>
	
	* libamu/xutil.c (get_syslog_facility): Don't use LOG_DAEMON
	unconditionally, may be missing on Ultrix V4.3.

Thu Apr 23 20:24:33 1998  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* conf/nfs_prot/nfs_prot_sunos5_4.h (MNTTYPE_CACHEFS): Define,
	missing from <sys/mntent.h>.
	
	* conf/mtab/mtab_ultrix.c: Need separate inclusion of <sys/fs_types.h>
	without KERNEL defined here.

	* aux/macros/mount_headers.m4: Need to include <ufs/ufs_mount.h>,
	<cdfs/cdfs_mount.h>, <cdfs/cdfsmount.h> so autoconfiguration of
	ufs_args_t, cdfs_args_t fields and cdfs mount options can succeed.

	* amd/ops_ufs.c (mount_ufs): Removed obsolete comment.

	* ChangeLog: Fixed confusing linebreaks from ChangeLog imports.
	Removed purely local (and obsolete) entry.

Thu Apr 23 00:22:17 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a16					***
	*******************************************************************

Wed Apr 22 01:20:39 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_mount_style.m4: define freebsd3 mount style.

	* aux/macros/check_mount_trap.m4: new mount trap for freebsd3.

	* aux/macros/check_mtype_printf_type.m4,
	aux/macros/check_mtype_type.m4 (ac_cv_mtype_type,): freebsd3 (as
	of snapshot 3.0-980311-SNAP) uses char * types for mount(2), not
	integers, but I'll keep them as integers and do the mapping in
	conf/mount/mount_freebsd3.c

	* minor new port to i386-pc-bsdi3.1.

	* minor new port to i386-unknown-netbsd1.3.1.

	* amd/opts.c: new option addopts:=ARG, which smartly merges ARG
	options with whatever the /default ones for a key are.  This
	allows adding or overriding /default options individual keys.

	* amd/am_ops.c (ops_match): strdup/malloc string assigned to
	opt_opts because it'll get free()'d upon next use.
	(merge_opts): new function to merge two sets of options.
	(ops_match): if addopts option exist, append and merge it to the
	current default options.

Tue Apr 21 12:54:59 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* wire-test/wire-test.c (main): use dynamically allocated returned
	string with list of interfaces.

	* amd/get_args.c (get_version_string): allocate enough space for
	header version string and a list of network interfaces of any
	length.

	* libamu/wire.c (print_wires): return dynamically allocated string
	containing list of networks.  Must be dynamic because some sites
	had potentially dozens of network interfaces.  Patch from Matthew
	Crosby <mcrosby@ms.com> slightly modified.

Mon Apr 20 00:37:20 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_irix5.h: underfine MNTTYPE_XFS because
	irix 5.3 does not have full header definitions for it.

	* fsinfo/fsi_lex.l (yywrap): define yywrap if needed, and
	undefined it when not needed (similar to amd/conf_tok.l)

	* hlfsd/hlfsd.h (ROOTID, SLINKID, INVALID): reduced maximum size
	of these to unsigned short (because uid_t on some linux systems is
	small).

	* released snapshot am-utils-6.0a16s10

	* doc/am-utils.texi (opts Option): documented resvport mount
	option.

Sun Apr 19 18:17:03 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (-D-Option): document behavior of -D info and
	especially what it does to hesiod (turn on RES_DEBUG).

	* scripts/amd.conf.5: document info debugging option.

	* libamu/xutil.c (dbg_opt): parse info debugging option.

	* include/am_utils.h (D_INFO): define new trace option.

	* Makefile.am (EXTRA_DIST): include list of official mirrors in
	distribution.

	* libamu/wire.c (SIZE): in the simple case, just compute
	sizeof(struct ifreq).

Sun Apr 19 16:30:35 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amd.c (daemon_mode): set a temporary secure umask(0022)
	before writing log file and restore it afterwards.  Patch from
	Donald Buczek <buczek@MPIMG-Berlin-Dahlem.MPG.DE>.

	* amd/get_args.c (get_args): 

	* doc/am-utils.texi (-F Option), amd/amd.8: mention that amd.conf
	file specified by -F is always processed last.

	* amd/amd.c (daemon_mode): do not fclose(stdout) so that the fd
	won't be reused.  Allows startup script to redirect stdout.  Patch
	from Donald Buczek <buczek@MPIMG-Berlin-Dahlem.MPG.DE>.

	* libamu/xutil.c (switch_to_logfile): compare logfile name and
	syslog string with correct length.  Patch from Donald Buczek
	<buczek@MPIMG-Berlin-Dahlem.MPG.DE>.

	* amd/restart.c (restart): correctly inherit existing NFS V.3
	mounts upon restart.  Patch from Donald Buczek
	<buczek@MPIMG-Berlin-Dahlem.MPG.DE>.

Sat Apr 18 19:01:19 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* using libtool 1.2 and automake 1.3 (with my patches).

	* aux/macros/opt_am_cflags.m4, */Makefile.in: rename AM_CFLAGS to
	AMU_CFLAGS to avoid conflicts with automake-1.3.

Sun Apr  5 23:09:08 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* converted to using libtool-1.2.

Tue Mar 10 16:52:09 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* fsinfo/fsi_analyze.c (fixup_required_mount_info): replaced silly
	for loop (ITER) which used to run only to initialize the variable
	dd once and then break; with a simple assignment.

	* hlfsd/hlfsd.h: cleanup so it compiles with Solaris
	/opt/SUNWspro/bin/cc, and use gid_t not int.

	* amd/mapc.c (mapc_sync): don't dereference pointer (so it
	compiles with Solaris /opt/SUNWspro/bin/cc)

Sun Mar  8 15:54:22 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/config.{guess,sub}: used from gcc-2.8.1.

Sat Mar  7 15:33:27 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0a16s9

	* INSTALL, doc/am-utils.texi (Supported Platforms): updated names
	based on new output of new config.guess.

	* aux/config.{sub,guess}: used newer versions from gcc-2.8.0.

	* amd/amd.8,doc/am-utils.texi: document correct usage of default
	/etc/amd.conf file.

	* fixmount/fixmount.c (inetresport,privsock): use some more
	portable code from amq/amq.c.

	* amd/get_args.c (get_args): use default /etc/amd.conf file only
	if no arguments had been passed to amd.

	* fixmount/fixmount.c (clnt_create_timeout): use tli/socket code
	ala amq/amq.c so that fixmount will work on both types of systems.

	* amq/amq.c (main): do no close tcp socket before running udp try,
	because we're not sure if it was opened at all.

	* mips-dec-ultrix* port merged in and cleaned up.

	* aux/configure.in: up minor shared library revision number, since
	it has changed enough.

	* hlfsd/hlfsd.c (main): don't check for overlay mount option here,
	as it is now done in compute_nfs_args().  Remove ultrix specific
	code also because it was moved to compute_nfs_args().

	* conf/mount/mount_svr4.c: removed DEBUG_MOUNT_SVR4 code, now that
	we have more generic code in print_nfs_args().

	* libamu/mount_fs.c (print_nfs_args): print maxlen of
	nfs_args.addr, and also syncaddr (which is mostly NULL).  Print
	struct knetconfig from nfs_args->knconf.

	* aux/macros/mount_headers.m4 (define): do not check for ufs/cdfs
	headers here, but in try_compile_anyfs.m4.

	* aux/macros/type_ufs_args.m4: move test for struct ufs_specific
	(for ultrix) here from its own macro.

	* aux/macros/type_cdfs_args.m4: move test for struct iso_specific
	(for ultrix) here from its own macro.

	* amd/ops_nfs.c (mount_nfs_fh): no need to run code again checking
	for overlay mount option.  Remove code which checks for overlay
	option, as it is now done in compute_nfs_args().

	* libamu/mount_fs.c (compute_mount_flags): move here code which
	checks for overlay mount option which was in amd/amfs_toplvl.c:
	mount_amfs_toplvl().

Wed Feb  7 15:35:51 1998  Rainer Orth  <ro@xayide.TechFak.Uni-Bielefeld.DE>

	* The following are Rainer's ChangeLog entries for his ultrix
	port, added manually. -Erez.

	* merged Ultrix port with am-utils 6.0 a16s5: amd/ops_afs.c
	(mount_toplvl) -> amd/amfs_toplvl.c (mount_amfs_toplvl)

	* include/am_defs.h: include cdfs specific mount headers
	avoid duplication definition of gt_names[] in <sys/fs_types.h> (Ultrix)

	* include/am_compat.h: define several mount options corresponding
	to mount flags: pgthresh, hard (nfs), defperm, nodefperm,
	noversion, rrip (cdfs), nocache, quota, sync (generic) removed
	duplicate MNTTAB_OPT_RO definition

	* aux/macros/try_compile_anyfs.m4: include Ultrix specific
	ufs/cdfs mount headers

	* aux/macros/mount_headers.m4: include several Ultrix/Digital UNIX
	specific mount headers

	* aux/macros/check_{fs_mntent, mount_type}.m4: check for GT_*
	mount types in mount headers (Ultrix)

	* aux/configure.in: Ultrix/Digital UNIX specific checks: new
	headers, mount structures and fields, filesystem and mount types,
	mount flags

	* aux/acconfig.h: placeholders for new mount options: quota
	(generic), ro (nfs), defperm, nodefperm, noversion, rrip (cdfs)
	cdfs, nfs, ufs mount structure fields new ufs, cdfs mount
	structures

	* amd/ops_ufs.c (mount_ufs): Ultrix stores generic mount flags in
	ufs_args.ufs_flags and has ufs specific pgthresh option

	* amd/ops_cdfs.c (mount_cdfs): handle Ultrix/Digital UNIX specific
	CDFS mount flags and options

	* amd/ops_afs.c (mount_toplvl), amd/ops_nfs.c (mount_nfs_fh),
	hlfsd/hlfsd.c (main): store generic mount flags in
	nfs_args.gfs_flags, handle separate NFS ro flag

	* aux/macros/{check_mnt2_cdfs_opt, struct_iso_specific,
	struct_ufs_specific}.m4: new files; check for Ultrix specific
	mount structures

	* conf/trap/trap_ultrix.h: arg 3 to mount(2) is rwflag

	* aux/macros/type_auth_create_gidlist.m4 (ultrix*):
	AUTH_CREATE_GIDLIST_TYPE is int (not short == gid_t) from a
	comment in <rpc/auth.h>

	* include/am_defs.h: #define KERNEL to avoid definition of
	gt_names[]
	conf/mtab/mtab_ultrix.c: #include <sys/fs_types> before <config.h>
	to force single definition here

	* libamu/mount_fs.c (compute_nfs_args): Ultrix support for
	nfs_args.gfs_flags moved to callers
	store mount options in nap->optstr

	* include/am_defs.h: fix _am_mntent mnt_{type, opts} field
	descriptions

	* aux/macros/mount_headers.m4, aux/macros/try_compile_nfs.m4:
	include <rpc/rpc.h> before AMU_NFS_PROTOCOL_HEADER for svc_req
	definition in prototypes

	* aux/macros/mount_headers.m4: include <sys/errno.h> before
	AMU_NFS_PROTOCOL_HEADER: <nfs/nfs.h> needs it for NFSERR_*
	definitions

	* conf/nfs_prot/nfs_prot_ultrix.h: new file

	* aux/macros/check_nfs_prot_headers.m4: use nfs_prot_ultrix.h

	* aux/macros/mount_headers.m4, aux/macros/try_compile_nfs.m4,
	aux/macros/try_compile_rpc.m4, include/am_defs.h: avoid multiple
	inclusion of <rpc/xdr.h>

Sat Mar  7 13:56:05 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: save state of config.cache and confdefs.h
	(as dbgcf.h) at various points of the configure.

	* aux/macros/save_state.m4: new macro to save state of configure,
	esp. useful in long ones.  Saves confdefs.h and write $ac_cv_*
	cache variables that are known so far.

	* released snapshot am-utils-6.0a16s8

1998-03-06  Erez Zadok  <ezk@mercer.psl.cs.columbia.edu>

	* fsinfo/fsi_lex.l,amd/conf_tok.l: define ECHO after undefining
	it, but only for flex.

Fri Mar  6 17:23:17 1998  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* hlfsd/homedir.c (plt_print): change pathname of hlfsd dump file
	to /usr/tmp/hlfsd.dump.XXXXXX, and use a safe method (if possible)
	to write the dump file.

	* doc/am-utils.texi,amd/opts.c: rename all references to nomadic
	functions to boolean functions, which is what they really are.

	* aux/configure.in: don't look for strcasecmp in libucb at all,
	but rather complete it from libamu/strcasecmp.c as needed.

Fri Mar  6 03:29:20 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_osf4.h: avoid conflicts with Irix's EFS.

	* libamu/wire.c (getwire): fix for 0.0.0.0 loopback on SunOS 3.X
	which defines IFF_ROUTE instead of IFF_LOOPBACK.  Patch from Tom
	Schmidt <tschmidt@micron.com>.

	* released snapshot am-utils-6.0a16s7

	* conf/nfs_prot/nfs_prot_hpux11.h: a first working port of amd to
	hppa1.0-hp-hpux11.00.tgz.

Thu Mar  5 21:59:03 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* converted all sources to use mntent field names, and map mnttab
	field names to mntent's.

	* include/am_defs.h (mnt_special): map struct mnttab field names
	to struct mntent field names.

	* aux/macros/check_mount_trap.m4: hpux11's mount trap style is
	identical to svr4/solaris2.

	* aux/macros/check_mount_style.m4: hpux11's mount style is
	identical to svr4/solaris2.

	* aux/macros/check_network_transport_type.m4: hpux11 is a TLI
	system!

	* aux/macros/check_nfs_sa_dref.m4: hpux11's NFS host address
	dereferencing style is same as svr4.

	* aux/macros/check_nfs_fh_dref.m4: hpux11's NFS file fh
	dereferencing style is same as svr4.

	* conf/transp/transp_tli.c (create_nfs_service): if failed to
	getnetconfigent() of ticlts, then try udp (hpux11).

	* conf/nfs_prot/nfs_prot_hpux11.h: added correct definitions for
	struct nfs_args, nfs_fh, and NFSMNT_* flags, taken from solaris
	2.5.1 (HP used them).

	* amd/rpc_fwd.c (fwd_init): don't use O_NDELAY for t_open()
	because hpux11 doesn't like it. if t_open failed, print error
	based on t_errlist, not sys_errlist.

Wed Mar  4 22:01:55 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi: lots of documentation fixes from Rainer Orth
	<ro@TechFak.Uni-Bielefeld.DE>.

Sat Feb 28 22:16:35 1998  Erez Zadok  <ezk@kosh.cs.columbia.edu>

	* fsinfo/fsi_lex.l: undefine ECHO again, so it doesn't get used
	later.

	* include/am_defs.h: defined the extern for ualarm() if it isn't
	found, regardless if the function isn't found in standard
	libraries, because otherwise libamu will include it.

1998-02-28  Erez Zadok (per Ron Snyder)  <ezk@short.cvo.roguewave.com>

	* initial port to hpux-11 completed.  Compiles cleanly, but
	probably does not work, because of missing NFS V.2/3 headers.

	* amd/conf_tok.l: cast yytext to char* when passed to strlen and
	strdup, for hpux-11's ansi-cc compiler.

	* include/am_utils.h: renamed all xfree() to XFREE() to avoid
	conflict with hpux-11's system headers.  Also move (voidp) cast
	from sources to inside the macro itself.

Sat Feb 28 13:44:21 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0a16s6

	* amd/info_nis.c (nis_isup): new function to test if NIS is up
	without hanging amd.  Used to ensure that amd does not clear the
	maps when the expiration period arrived, if the service is down.
	Otherwise it would be left with empty maps.  It is better to stay
	with possibly old information than none at all.

	* amd/mapc.c (mapc_sync): check to see if map service is up.

Tue Feb 24 02:19:42 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_lib2.m4 (AC_CHECK_LIB2): fix macro so it
	includes auxiliary library only if needed.

1998-02-22  Erez Zadok  <ezk@mercer.psl.cs.columbia.edu>

	* amd/conf_tok.l: undefine ECHO again, so it doesn't get used
	later.

Sun Feb 22 01:41:08 1998  Erez Zadok  <ezk@zen.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_osf2.h: port to alpha-dec-osf2.1
	completed.

	* conf/mtab/mtab_osf.c (mnt_dup): not all OSF have NFS3.

Sat Feb 21 19:45:48 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Network Host Filesystem): correct example for
	type:=host map.

	* aux/macros/os_cflags.m4: only osf4 should compile with
	-D_SOCKADDR_LEN.

	* aux/macros/check_nfs_prot_headers.m4: distinguish between OSF2
	and OSF4.

	* BUGS: include a new file listing known bugs.

Sat Feb 21 03:50:48 1998  Erez Zadok  <ezk@mercer.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_linux.h: turn DES off on all linux
	versions.

	* aux/macros/type_recvfrom_fromlen.m4: linux alpha should use
	size_t for recvfrom fromlen arg.

Sat Feb 21 03:33:59 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-hlfsd.in: turn -D fork so primary process never
	hangs.

Sat Feb 21 02:45:51 1998  Erez Zadok  <ezk@mercer.psl.cs.columbia.edu>

	* include/am_defs.h: don't include <sys/stat.h> and
	<linux/stat.h>, just remaining definitions in <statbuf.h>

Thu Jan 29 00:44:28 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0a16s5

	* conf/mount/mount_irix6.c (mount_irix): pass {u,e,x}fs_args to
	mount(2).

	* check for <sys/fs/xfs_clnt.h> and include it when needed.

	* conf/mount/{mount_irix5.c,mount_irix6.c} (mount_irix): recognize
	efs and xfs separately from "ufs".

	* amd/{ops_xfs.c,ops_efs.c}: new support for irix xfs/efs.

	* aux/configure.in: look for irix efs and xfs file systems.

	* scripts/amd.conf.5: new unmount_on_exit option documented.

	* doc/am-utils.texi (unmount_on_exit): new option documented.

	* amd/conf.c (gopt_unmount_on_exit): new function to handle new
	amd.conf option.

	* amd/map.c (umount_exported): if global amd.conf flag
	unmount_on_exit is on, then try to unmount all mounted (or
	restartable) file systems.

	* amd/amd.c: if print_pid option is on, then normally print it to
	stdout.  If also pid_file is specified, then print the process ID
	into that file.

	* amd/get_args.c (get_args): print correct -l option depending if
	system supports syslog and/or syslog facilities.  Patch from 
	Tom Schmidt <tschmidt@micron.com>.

	* doc/am-utils.texi (opts Option): updates for documentation for
	new cdfs options defperm, nodefperm, noversion, rrip.

	* amd/ops_cdfs.c (mount_cdfs): support cdfs options defperm,
	nodefperm, noversion, rrip.

	* conf/nfs_prot/nfs_prot_osf.h: need to look at <cdfs/cdfsmount.h>
	on osf.

	* aux/macros/{expand_cpp_hex.m4, expand_cpp_int.m4,
	expand_cpp_string.m4}: use #error to make failed compilations
	fail faster, rather than have the program fail during a run.

	* include/am_compat.h: added a few new cdfs options: rrip,
	noversion, defperm, and nodefperm (used in OSF).

Wed Jan 28 20:24:09 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* released snapshot am-utils-6.0a16s4

	* doc/am-utils.texi (Global Parameters): update manual for new
	amd.conf global variable hesiod_base.

	* scripts/amd.conf.5: update man page for new amd.conf global
	variable hesiod_base.

	* amd/get_args.c (get_args): use /etc/amd.conf file if exists by
	default, else try command line options.  Patch from Randall
	S. Winchester <rsw@Glue.umd.edu>.

Wed Jan 28 12:20:56 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_hesiod.c (hesiod_search), amd/conf.c
	(gopt_hesiod_base), amd/amd.h, amd/amd.c (init_global_options):
	included patch from Randall S. Winchester <rsw@Glue.umd.edu>, to
	support a hesiod base name in the amd.conf file.

	* doc/am-utils.texi (pid_file Parameter): document new global
	amd.conf parameter.

	* scripts/amd.conf.5: document new global option pid_file.

	* amd/amd.c (daemon_mode): if cannot open pid_file, continue to
	run, but print error message.

	* amd/conf.c (gopt_pid_file), amd/amd.h, amd/amd.c (daemon_mode,
	init_global_options): Included patch from Randall S. Winchester
	<rsw@Glue.umd.edu>, to support pid files in the amd.conf file.

	* amd/get_args.c (get_args): correct usage info on amd -t.

	* amd/*.c: massive file name and symbol name changes.  All amd
	file systems files and symbols are prefix with amfs_*.  Now using
	real name of file system: amfs_auto instead of afs, amfs_inherit
	instead of ifs, amfs_linkx instead of sfsx, etc.  This will enable
	clear distinction between amd file system and generic ones like
	nfs/ufs/pcfs/hsfs.  Also, now we can implement true afs (Andrew
	f/s) and DFS (Distributed f/s).

	* amd/amfs_union.c: unionfs for amd is always defined, no need to
	#ifdef it.

Mon Jan 26 16:51:38 1998  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (compute_nfs_args): set 'noconn' NFS option on
	or off, based on the particular quirks of the OS in question.

	* aux/macros/check_nfs_socket_connection.m4: new macro to set the
	correct wait of handling un/connected NFS sockets.

	* scripts/wait4amd.in: use rlogin instead of rsh.

	* amd/am_ops.c (ops_showfstypes): when showing F/S types in amd
	-v, always show "nfs3" for NFS V.3.

1998-01-25  Erez Zadok  <ezk@snoopy.cs.columbia.edu>

	* lots of small fixes for solaris 2.6, since gcc 2.8.0 -Wall gets
	more picky than 2.7.2.3 did.

1998-01-24  Erez Zadok  <ezk@snoopy.cs.columbia.edu>

	* include/am_utils.h (dlog): amuDebug macros reduced to shorter
	forms.

Fri Jan 23 18:38:30 1998  Erez Zadok  <ezk@goat.mcl.cs.columbia.edu>

	* released snapshot am-utils-6.0a16s3

	* include/am_defs.h: on Solaris 2.6, <sys/varargs.h> is included
	in <sys/fs/autofs.h> but since stdargs.h is used, and varargs.h
	must not, fake a definition for varargs.

Fri Jan 16 10:16:40 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* README: show how to configure in additional support such as
	hesiod using various --enable-* flags.

Wed Jan 14 15:13:02 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: look for strcasecmp(), and replace it if not
	available.

	* amd/ops_nfsl.c (nfsl_match): host names should be compared using
	case insensitive.

	* amd/opts.c: for each map variable, define if the comparison
	needs to be done case insensitive.

	* include/am_utils.h (STRCEQ): a new macro to use strcasecmp().
	Patch from Thomas Richter <richter@chemie.fu-berlin.de>

1998-01-14  Erez Zadok  <ezk@irt.cs.columbia.edu>

	* aux/configure.in: look for "isofs" as a possible mount type for
	cdfs (RedHat Linux).

Wed Jan 14 02:07:05 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_linux.c (parse_opts): don't look for cdfs mount
	type if not defined.

	* conf/nfs_prot/nfs_prot_linux.h: don't define __FD_* macros if
	already defined.

	* aux/configure.in: look for ext2fs before ufs, b/c some linux
	have both.

Mon Jan 12 15:43:20 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* Makefile.am (snapshot): allow me to install snapshots into the
	ftp directory.

	* scripts/ctl-hlfsd.in: don't turn on -D mem by default.

	* amd/get_args.c (get_args): minor bug in output of amd -H.

Mon Jan 12 03:05:06 1998  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a15					***
	*******************************************************************

Sun Jan 11 15:06:34 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (*_browsable_dirs): allow specifying
	browsable_dirs=full, which will print *all* entries (other than
	/default), including  those with '*' and '/' characters.

	* amd/info_file.c (MAX_LINE_LEN): up maximum readdir chain length
	to 1500.

	* doc/am-utils.texi: fixed reversed documentation for NFS mount
	options vers and proto.

	* doc/Makefile.am (install-html): separate target just for
	installing html files.  Another new target "alldocs" is just for
	installing all files needed for the am-utils home page.

	* scripts/amd.conf-sample: updated example for log_file.

	* scripts/amd.conf.5: updated for new way to declare new syslog
	facility in the log_file option.

	* amd/amd.8: updated for new way to declare new syslog facility in
	the -l option.

	* libamu/xutil.c (get_syslog_facility): allow users to specify the
	syslog facility as an appended string to the log device.  Ex. amd
	-l syslog:local7 will use LOG_LOCAL7, while the older -l syslog
	will use the default LOG_DAEMON facility.

	* amd/get_args.c (get_args): updated new syntax for amd -l
	syslog:facility.

Thu Jan  8 04:05:10 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/host_macros.m4: don't confuse sun3 (sparc) with sun3
	(intel).

	* libamu/wire.c (print_wires): bug fix.  Nullify output buffer
	before appending to it, on systems with two or more network
	interfaces.

	* conf/nfs_prot/nfs_prot_sunos5_3.h: add missing definition for
	the mntent for cachefs.

	* include/am_defs.h: external definition for strstr() should use
	const for both arguments.

	* aux/configure.in: add extern definitions for getwd() if missing.

	* include/am_defs.h: define the extern for strdup() even if the
	function does not exist, for it will be filled in by
	libamu/strdup.c

	* amq/pawd.c (cluster_server): don't use getccent() if the extern
	for it isn't there.  On hpux 10.20, the function is in libc, but
	<cluster.h> and struct cct_entry do not exist.

	* aux/configure.in: check for an extern for getccent() b/c some
	hpux systems don't have it (hpux 10.20).

Wed Jan  7 00:09:19 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* doc/am-utils.texi (Amq -T option): manual documentation updates
	for new amq options -T/-U.

	* amq/amq.8: updated man page for new amq options -T/-U.

	* amq/amq.c: two new switches to amq. -U will contact amd using
	UDP only.  -T will use TCP only.  Normally amq will try TCP and
	if that failed, will try UDP.

	* doc/am-utils.texi (pawd): manual documentation for pawd.

	* amq/pawd.1: new man page for pawd.

Tue Jan  6 04:21:59 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amq/pawd.c: a new program, Print Automounter Working Directory,
	to print the proper pathname of the cwd or any other pathname,
	adjusted for automounter paths, while avoiding mount points.

	* aux/macros/localconfig.m4: trivial support for am-utils
	maintainers to adjust some of the configuration of am-utils after
	it has been auto-configured by putting whatever definitions you
	wish in a file called localconfig.h, located in the top build
	directory (the same one where config.h is created for you).

	* doc/am-utils.texi (Caching Filesystem): updated documents for
	cachefs file system.

	* amd/ops_cachefs.c: initial cachefs support, for solaris.
	type:=cachefs, requires cachedir:=/cache/dir/name to be defined
	and initialized with cfsadmin -c.  $rfs is backdir to be cached
	from, and $fs is the local mount point of the cachefs.

	* conf/mount/mount_svr4.c (mount_svr4): support mounting of
	cachefs file systems.

	* amd/ops_cdfs.c: cdfs should be named 'cdfs', not whatever the
	mnttab type is.

Mon Jan  5 23:22:49 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/opts.c: added support for new variable $cachedir.

	* include/am_utils.h: added opt_cachedir field to struct am_opts.

Sat Jan  3 01:43:57 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_nfsl.c (nfsl_ffserver, nfsl_match): also check if the
	local hostname does not match $rhost, and if so, also assume
	type:=nfs.

Fri Jan  2 01:00:40 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* updated all source files to add 1998 as a copyright year.

	* amd/ops_nfsl.c: new amd meta file system "type:=nfsl".  Behaves
	like type:=linkx if the pathname denoted by $fs exists, and like
	type:=nfs if it does not.  A convenient shortcut for the most
	popular amd map entry.

	* amd/amd.c (main): amd should chdir to / before starting, to
	avoid hanging on other NFS server if started elsewhere.

	* amd/ops_TEMPLATE.c: added an empty template file for developers
	who wish to write new amd pseudo file systems.

Thu Jan  1 00:27:28 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/homedir.c (plt_init): make function exported, to save on
	the unnecessary init_homedir() function which was removed.
	(table_add): don't use xmalloc() when you can use strdup()
	instead.

Thu Jan  1 00:15:58 1998  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* hlfsd/homedir.c (hlfsd_endpwent): Don't actually run this
	because we will be making more passwd calls afterwards.  On
	Solaris 2.5.1, making getpwent() calls after calling endpwent()
	results in a memory leak! (and no, even Purify didn't detect
	it...)

Tue Dec 23 18:23:47 1997  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main): Bug fix.  Don't try to free() an
	automatically allocated address.

	* amd/ops_afs.c (mount_toplvl): Bug fix.  Don't try to free() an
	automatically allocated address.

	* ALL SOURCES: change every direct call to free() to xfree(), so
	it can be mapped to the right debugging function as needed.

	* include/am_utils.h: new free() policy.  If debugging memory,
	call dxfree(), which will print the file name and line number
	where the free occurred and the pointer address.  if only regular
	debugging, then free() and reset  the pointer to NULL so it cannot
	be used afterwards inadvertently.  If not DEBUG at all, then just
	run free().  Three different #define macros set the right mapping.

	* libamu/xutil.c (dxfree): renamed function to dxfree(), so it can
	be called only when debugging the memory.

Tue Dec 23 04:24:28 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* wire-test/wire-test.c (main): use xmalloc() not malloc().

	* conf/transp/transp_tli.c (get_knetconfig): use xzalloc() not
	calloc().

	* conf/mtab/mtab_mach3.c (convert): use xzalloc() not calloc().

	* conf/mount/mount_linux.c (parse_opts): use xmalloc() not
	malloc().

	* amd/info_ldap.c: use xmalloc() not malloc().

	* libamu/xutil.c (xzalloc): new function to allocate memory and
	zero its bytes.

	* amq/amq.c: amq does not need its own definition of xfree().

	* aux/macros/opt_debug.m4: if used --enable-debug=mem, then also
	look for function malloc_verify() in libmapmalloc.a, and function
	mallinfo() in libmalloc.

	* libamu/xutil.c (checkup_mem): do not use mallinfo field
	uordbytes, because it does not always exist.  Rather, compute it
	from other fields..

	* include/am_utils.h: add external definition to xfree() function
	used when debugging memory references.

Mon Dec 22 03:01:30 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir_browsable): reduce the number of
	bytes heuristically computed to be returned to the kernel.
	Otherwise browsable_dirs fails on OpenBSD 2.2.

	* amd/mntfs.c (uninit_mntfs): bug fix.  Moved freeing of
	mf_private field to AFTER it gets used.

Sat Dec 20 00:51:21 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_host.c (host_umounted): don't use clnt_spcreateerror()
	on systems that don't support it.

	* include/am_defs.h: add missing extern definition for free().

	* aux/configure.in: check for external definition for free().

	* libamu/Makefile.am: add to comment a mention of strstr as an
	optional function.

	* libamu/xutil.c (switch_to_logfile): use openlog() options only
	if they exist.

	* conf/transp/transp_sockets.c (get_nfs_version): don't use
	clnt_spcreateerror if it does not exist.

	* aux/configure.in: check for missing functions clnt_create and
	clnt_spcreateerror.  Check for missing strstr, and complete
	its code.  Check for missing external definition for strstr.

	* aux/macros/host_macros.m4: normalize sun3* names.

	* Makefile.am: updates for new sunos3 files distributed.

	* conf/nfs_prot/nfs_prot_sunos3.h: new file.

	* conf/fh_dref/fh_dref_sunos3.h: new file.

	* aux/macros/check_nfs_prot_headers.m4: added sunos3 case.

	* aux/macros/check_nfs_fh_dref.m4: added sunos3 case.

	* doc/am-utils.texi (wire Selector Variable): updated manual for
	adjusted variables wire, network, and netnumber, all using the
	in_network() function.

Fri Dec 19 04:37:36 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/opts.c: allow options to be processed by executing arbitrary
	functions.  Converted wire, network, and netnumber all to use the
	nomadic function in_network.  So from now on they perform a match
	against all networks, not just primary.

	* initial port to alpha-unknown-linux-gnu, probably works, but
	untested yet.

	* conf/nfs_prot/nfs_prot_linux.h: add special definitions for
	__FD_* macros which for som strange reason do not get included
	from <selectbits.h> on redhat alpha linux.  Also turn off usage of
	<rpc/des_auth.h> because it is incomplete on the same systems.

	* hlfsd/homedir.c (table_add): cast uid field to int, for
	comparison.

	* include/am_defs.h: more coflicts with redhat alpha linux
	"resolved".

	* aux/macros/{mount_headers,try_compile_anyfs,try_compile_nfs}.m4:
	There's a conflict of definitions on redhat alpha linux between
	<netinet/in.h> and <linux/fs.h> which must be avoided.

	* aux/configure.in: check for <socketbits.h>, which is in use on
	redhat alpha linux.

	* doc/am-utils.texi (Selectors): added documentation to describe
	the new "!" (negated) nomadic functions.

	* amd/opts.c (f_in_network): print debugging info that is correct,
	rather than saying that any ARG is on a local network.
	(eval_opts): added support for negating nomadic functions, by
	prepending "!" to their name.  Example, !exists(/foo/bar).

Thu Dec 18 20:57:19 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_compat.h: ensure that all NFS3 systems have the mount
	table entries (and amd opts switches) "proto" and "vers".

	* hlfsd/homedir.c (table_add): added some debugging info to try
	and track down a serious memory leak in hlfsd.

1997-12-18  Erez Zadok  <ezk@t-rex.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (compute_nfs_args): OpenBSD 2.2 requires that
	you do NOT set the noconn option, and use connected sockets
	always.  So I'm now forced not to set it at all, and have the user
	specify it as "conn" or "noconn" in their /default entry.  Argh...
	Finally, it looks as if OpenBSD 2.2's NFS 3 implementation may be
	buggy (TCP hangs with "short receive" kernel errors).  I'd better
	wait until they get it working in their version of the automounter
	first.  So I'm putting the "noconn" option back.

Thu Dec 18 02:39:39 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (compute_nfs_args): use maxgrps option and set
	nfs_args field maxgrouplist accordingly.

	* include/am_compat.h (MNTTAB_OPT_MAXGROUPS): complete definition
	for mount table entry for maxgroups based on NFS mount option
	maxgrp.

	* aux/configure.in: put back testing for NFS mount option
	"maxgrps".  Added test for mount table entry "maxgroups".

	* libamu/mount_fs.c (compute_nfs_args): perform more careful tests
	on nfs_proto, because it could be NULL.

	* doc/am-utils.texi (Selectors): added example of in_network()
	selector.

	* aux/macros/check_hide_mount_type.m4: all hpux versions,
	including 9.x, should use "ignore" as the mount type to hide from
	amd.

Wed Dec 17 13:09:21 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_utils.h (NSTREQ): use new macro instead of strncmp()
	every where in the sources.

Wed Dec 17 01:15:01 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* libamu/mount_fs.c (print_nfs_args): if -D trace is on, will
	print as much info that is given in struct nfs_args as possible.
	useful for detecting internal flags and options, as well as the
	file handle used.

	* scripts/ctl-amd.in: look for amd.conf file in ${prefix}/etc
	after /etc and before /etc/local.

Tue Dec 16 18:51:36 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in, libamu/Makefile.am: added support for linking
	with specific versions of libamu.  Upped shared library version of
	libamu to 1 (libamu.so.1.0.0)

	* include/am_defs.h: added external definition for mkstemp() as
	needed.

	* minor new port to i386-unknown-netbsd1.3 (BETA version of
	netbsd).

	* aux/config.guess: don't leave a trailing '.' on the system name
	for NetBSD-1.3_BETA and similarly for OpenBSD.

	* conf/nfs_prot/nfs_prot_netbsd1_3.h: new header for the slight
	differences in ypall calling conventions.

	* mk-amd-map/mk-amd-map.c (main): use mkstemp() whenever possible
	in preference over mktemp(), b/c it is more secure.

	* aux/configure.in: check for mkstemp(), a more secure version of
	mktemp().

Mon Dec 15 02:32:14 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_nfs.c (mount_nfs_fh): Systems that include the mount
	table "vers" option generally do not set the mnttab entry to
	"nfs3", but to "nfs" and then they set "vers=3".  Setting it to
	"nfs3" works, but it may break some things like "df -t nfs" and
	the "quota" program (esp. on Solaris and Irix).  So on those
	systems, set it to "nfs".

Sat Dec 13 01:36:27 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Distrib): updates for new ports, location of
	am-utils' home page, and URL cross references (now supported by my
	version of texi2html).

	* aux/macros/check_mtype_type.m4: also use string type for file
	system mount types under nextstep for mount(2).

	* aux/macros/check_mtype_printf_type.m4}: nextstep can handle both
	integer and string types for file system mount types in mount(2),
	but it is better to use string types.

	* conf/nfs_prot/nfs_prot_nextstep.h: set emum nfsstat's NFS_OK to
	0, not 1!  Otherwise, all NFS calls (esp. mount) return errno 1
	(EPERM) instead of 0 (OK).  Fixes m68k-next-nextstep3 which now
	works.

	* conf/nfs_prot/nfs_prot_bsdi2.h: set emum nfsstat's NFS_OK to 0,
	not 1!  Otherwise, all NFS calls (esp. mount) return errno 1
	(EPERM) instead of 0 (OK).

	* libamu/xdr_func.c (xdr_*): add debugging calls that are optioned
	by -D trace (protocol trace).

1997-12-11  Erez Zadok  <ezk@bach.cs.columbia.edu>

	* A.m68k-next-nextstep3/amu_nfs_prot.h: define missing S_ISDIR
	macro based on existence on others, and include <sys/stat.h>.

Thu Dec 11 14:14:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/try_compile_nfs.m4 (AC_TRY_COMPILE): turn off
	inclusion of <nfs/nfs_mount.h> which only affects nextstep3, on
	which this header is broken (it tries to include non-existing
	headers).

Wed Dec 10 16:09:07 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (mnt_flags): support either nfs or generic
	mount option for grpid.

	* aux/configure.in: turn back on NFS mount option grpid.

Sat Dec  6 04:36:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/Makefile.am (install-ps): added target to install postscript
	file in the am-utils' home page, as well as a few other useful
	files for the new am-utils Web page.

Mon Nov 17 05:22:56 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a14					***
	*******************************************************************

Sun Nov 16 21:56:16 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): updated table of new
	ports.

Sat Nov 15 06:36:27 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (compute_automounter_nfs_args): pass mnttab
	options so that they can be printed in logs as needed.

	* doc/am-utils.texi (osver Parameter): updated for the correct
	usage of the -o/-O options.

	* scripts/amd.conf.5: corrected info for -o/-O options.

	* amd/amd.8: updated man page for new -O op_sys_name option, and
	corrected the usage of the -o op_sys_ver option

	* amd/get_args.c (get_args): added new amd option -O to override
	OS name.
	(get_args): updated usage string.  Removed old -m option.  Added
	-o and -O options.

	* conf/nfs_prot/nfs_prot_irix5.h: add definition to FHSIZE in case
	it is not there.  Reportedly, irix 5.2 does not define it.

	* scripts/lostaltmail.in: removed references to unused $hack
	variable.

	* aux/macros/check_nfs_prot_headers.m4: Patch from Chris Metcalf
	<metcalf@cag.lcs.mit.edu> to correctly set the nfs_prot headers
	for solaris2.5.

	* doc/am-utils.texi (Distrib): typo in the subscription
	instructions to amd-dev.  Patch from Stefan Vogel
	<vogel@physik-rzu.unizh.ch>.

1997-11-15  Erez Zadok  <ezk@amtrak.cs.columbia.edu>

	* NFS3 works on powerpc-ibm-aix4.2.1.0.

	* libamu/mount_fs.c (compute_nfs_args): set fh3 variable to
	static.  Some compilers (gcc from egcs  on aix 4.2.1) corrupt the
	stack of an automatic variable when pointer to it is passed around
	several times.

Fri Nov 14 20:09:28 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/xutil.c (real_plog): syslog like behavior for normal
	logging.  Will not print repeated strings, only a count "last
	message repeated N times", but will always print something if
	message is repeated more than 100 times.

	* scripts/lostaltmail.in: look for lostaltmail.conf files also in
	/etc/global, /etc/os, and /etc/local (in that order).

Mon Nov 10 03:03:17 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* conf/mount/mount_aix.c (mount_aix3): add support for NFS V.3
	mounts.

	* aux/macros/struct_nfs_args.m4 (AC_TRY_COMPILE_NFS): test for
	aix42_nfs_args, specially set in conf/nfs_prot/nfs_prot_aix4_2.h

	* conf/sa_dref/sa_dref_*.h: from now on, the "dst" argument to the
	NFS_SA_DREF macro is a pointer to the structure that used to be
	passed to it before.  So now I have to dereference the pointer
	before accessing its values.

	* hlfsd/hlfsd.c (main): use the new and cleaner
	compute_nfs_args() and compute_automounter_nfs_args() functions.

	* amd/ops_nfs.c (mount_nfs_fh): use the new and cleaner
	compute_nfs_args() and compute_automounter_nfs_args() functions.

	* amd/ops_afs.c (mount_toplvl): MAJOR CODE REVISION.  Use the new
	and cleaner compute_nfs_args() and compute_automounter_nfs_args()
	functions.

	* libamu/mount_fs.c (compute_nfs_args): major code cleanup that
	relates for struct nfs_args.  A new function sets the numerous
	possible flags and fields of nfs_args_t in an orderly fashion.
	Code cleaned up, organized, and moved from amd/hlfsd into
	libamu.  This saves on overall size of code.
	(compute_automounter_nfs_args): A variant of compute_nfs_args()
	which sets special options/flags that need to be used when NFS
	mounting an automounter's mount point.  Used by hlfsd and amd.

	* amq/amq.c (get_secure_amd_client): don't print any more
	"get_secure_amd_client: using TCP, port 12345".  It's more
	annoying than useful a message, even when assumed to be compiled
	under DEBUG only.

Thu Oct 30 14:33:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_mnttab_type.m4: MAJOR BUG fixed for non-nfs
	mount table entries.  The code used to define the /etc/mnttab name
	for file systems based on physical media (disk, cdrom, floppy) to
	the generic name, rather than the OS specific name.  For example
	autoconf searches for all these types of mount table entries for a
	floppy based file system: vfat pcfs pc msdos msdosfs fat.  But if
	it found any, it hard-coded the mnttab name to "pcfs" rather than
	the actual name found!  Same for ufs, cdfs, pcfs, tmpfs, lofs,
	nullfs, unionfs, and umapfs.

	* aux/configure.in: also test for xfs (for newer Irix) when
	looking for mount type names, numbers, etc of a disk-based ufs.

Sun Oct 26 19:32:57 1997  Erez Zadok  <ezk@defiant.soscorp.com>

	* amq/amq.c (main): use pmap_ping() to test if remote host is up.
	This works better on bsdi2 and bsdi3, because their portmapper
	does not appear to like forwarding operations (it is generaly
	insecure).

Sat Oct 25 04:55:56 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a13					***
	*******************************************************************

Fri Oct 24 05:04:37 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_ncr2.h: added missing definition for
	struct datum typedef.

	* conf/nfs_prot/nfs_prot_netbsd.h: corrected typedef for
	ypall_callback_fxn_t for netbsd.

	* aux/macros/type_auth_create_gidlist.m4: hpux10.10 uses int for
	the 5th arg to authunix_create(), while before and after they used
	gid_t.

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): don't use
	clnt_create_timed() on older Solaris 2.3 systems that did not have
	it.

	* conf/nfs_prot/nfs_prot_bsdi2.h: <msdosfs/msdosfsmount.h> is for
	kernel only on bsdi2, so do not include it.

Fri Oct 24 00:29:42 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* hlfsd/stubs.c (nfsproc_readlink_2_svc): avoid logging repeated
	messages about resolution of mailboxes based on uid/gid.

	* scripts/ctl-hlfsd.in: check for alternate password file in
	${prefix}/etc/passwd and use it in hlfsd's startup.

Thu Oct 23 22:48:50 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* hlfsd/homedir.c (hlfsd_getpwent): added support for -P
	passwdfile option.  If hlfsd is started with -P passwdfile, then
	the passwdfile is read and parsed just as a standard unix
	passwd(4) file.  Only the username, uid, and homedir fields are
	read and checked.  All the rest are ignored.  No NIS/netgroup
	support!

	* hlfsd/hlfsd.c (main): check if hlfsd is run as root after
	parsing command line options, so that usage() can be printed when
	-h is invoked.

Wed Oct 22 00:16:39 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/nfs_start.c (mount_automounter): if autofs service listener
	fails to initialize it is OK if using a test amd.

	* amd/opts.c (f_in_network): new nomadic function in_network(arg),
	which returns TRUE if 'arg' is any one of this host's networks.

	* libamu/wire.c (getwire): rewritten parts of function, to store
	all networks names and numbers in the order of the interface (not
	in reverse).

Mon Oct 20 01:59:25 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: don't add ops_ufs.o on AIX twice.  My code
	would have worked had it not been due to AIX's buggy /bin/sh.

	* doc/Makefile.am (EXTRA_DIST): include am-utils.dvi and
	am-utils.ps in the distribution sources.
	(html): generate html documentation for
	http://www.cs.columbia.edu/~ezk/am-utils/

Sun Oct 19 12:35:49 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_netbsd.h: override the definition of
	ypall_callback_fxn_t.  The NetBSD team compiles all sources with
	gcc -Wall -Wmissing-prototypes -Wstrict-prototypes.

	* amd/info_nis.c: allow for override of ypall_callback_fxn_t
	function typedef.

	* libamu/xutil.c (amu_release_controlling_tty): new function to
	release the controlling tty in a clean and sane manner.  No longer
	using setpgid() b/c it may not work.  Uses setsid(),
	and ioctl() (in order).  This new function is used in amd/amd.c
	and hlfsd/hlfsd.c.  Also avoid setpgrp(), because it works on some
	systems, but on others it is the same as setpgid().

Sat Oct 18 23:42:40 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/acconfig.h: check for nfs mount option 'fsname'.  Code for
	it was in amd/ops_afs.c, amd/ops_nfs.c, and hlfsd/hlfsd.c, but
	never used, because the configure test for fsname flag wasn't
	used.  This fixed a bug in HPUX 10, where syncer and manual mounts
	left blank lines in /etc/mnttab.

	* aux/configure.in: check for nfs mount option 'fsname'.

Fri Oct 17 13:30:27 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (mount_toplvl): turn on 'ignore' option in nfs
	mount flags of toplvl mounts.  Important esp. for HPUX 10.  Now
	hpux-10 will mount amd's mounts points as 'ignore' (by df).

	* aux/configure.in: check for NFS mount option 'ignore', useful in
	HPUX 10.

Thu Oct 16 03:28:33 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_hide_mount_type.m4: hpux 10 should use "ignore"
	mount type and not NFS, for the amd mount points.

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): don't log
	an RPC timeout as an error, but just an info message.  From
	Andreas Stolcke <stolcke@speech.sri.com>

	* If the NFS server is down or does not support the portmapper
	call (such as certain Novell NFS servers) we mark it as version 2
	and we let the nfs code deal with the case that is down.  If when
	the server comes back up, it can support NFS V.3 and/or TCP, it
	will use those.  From christos@deshaw.com (Christos Zoulas).

	* hlfsd/homedir.c (plt_print): various compile time cleanups to
	printfs that take a long, but pass an int to print.  From
	christos@deshaw.com (Christos Zoulas).

	* aux/macros/func_bad_yp_all.m4 (ac_cv_func_yp_all_clean,): new
	macro to determine if the OS has a bad yp_all(), based on the host
	OS name.  So far only irix (all versions) have a bad yp_all, so
	they will use am_yp_all() instead (which is slower as it
	enumerates manually all of the map's entries).

Thu Oct 16 03:14:37 1997  Erez Zadok  <ezk@subzero.cs.columbia.edu>

	* amd/info_nis.c (am_yp_all): code for a replacement yp_all that
	avoids using a file-descriptor leaking yp_all() on some systems
	like irix.

Wed Oct 15 21:52:35 1997  Erez Zadok  <ezk>

	* fsinfo/fsinfo.h: avoid redefining yywrap incorrectly on DU-4.x
	systems using /usr/bin/flex.

	* amd/conf_tok.l (yywrap): avoid redefining yywrap for systems
	that have a modified GNU flex which does define yywrap (DU-4.x).

Fri Sep 26 14:25:29 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/checkmount/checkmount_bsd44.c: include prototype.

Fri Sep 26 01:26:24 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a12					***
	*******************************************************************

Fri Sep 26 00:13:48 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_irix6.h: completely turn off all autofs
	code in irix6 until it can be tested correctly

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): time out
	on clnt_create for 3 seconds, rather than wait for the much longer
	default.

	* conf/nfs_prot/nfs_prot_aix4_2.h: port to powerpc-ibm-aix4.2.1.0.
	Includes NFS3, untested.

Thu Sep 25 11:03:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_pcfs.c (mount_pcfs): fill in uid/gid fields of
	pcfs_args_t if they exist.

	* amd/ops_cdfs.c (mount_cdfs): fill in ssector field of
	cdfs_args_t if it exists.

	* new minor ports hppa1.1-hp-hpux10.10, hppa1.1-hp-hpux9.05,
	hppa1.1-hp-hpux9.07, m68k-hp-hpux9.00, and sparc-sun-sunos4.1.4.

Wed Sep 24 00:48:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (wire-test): updated documentation for the new
	option.

	* wire-test/wire-test.8: updated man page for new option.

	* wire-test/wire-test.c (main): added a test for various
	combinations of NFS proto/vers to a remote/local host.

	* aux/macros/try_compile_anyfs.m4 (AC_TRY_COMPILE): include
	<isofs/cd9660/cd9660_mount.h> and <msdosfs/msdosfsmount.h> so that
	freebsd will correctly set mount options for pcfs and cdfs.

	* amd/ops_pcfs.c (mount_pcfs): set mask field of pcfs_args to
	0777 (if field exists).

	* aux/macros/try_compile_anyfs.m4 (AC_TRY_COMPILE): include
	<msdosfs/msdosfsmount.h> if available.

	* minor new port: rs6000-ibm-aix4.1.4.0.

	* libamu/mount_fs.c (mount_fs): fixed bug that caused HPUX not to
	write the "time" field in /etc/mnttab.

	* conf/mtab/mtab_file.c (mnt_dup): fixed typo in macro names for
	detecting mnt_time field of mntent_t.

	* libamu/mtab.c (mnt_free): fixed typo in macro names for
	detecting mnt_time field of mntent_t.

Tue Sep 23 15:30:03 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mtab/mtab_file.c (lock): Use flock() in preference over
	fcntl() to lock the mtab file.

Mon Sep 22 23:04:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_sockets.c (get_nfs_version): define
	the try_again goto label only for NFS3.
	(pmap_ping): assume timeout failure of clnt_stat.

	* libamu/xdr_func.c (xdr_groupnode, xdr_exportnode): cast to
	"groups *".

Mon Sep 22 20:34:33 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* conf/transp/transp_sockets.c (pmap_ping): patch from Dan Riley
	<dsr@mail.lns.cornell.edu> to make sure that amd works with more
	secure portmappers that do not allow forwarding of RPC messages to
	other services.

	* */Makefile.am: all source files should also depend on the new
	include/am_xdr_func.h header.

	* include/am_xdr_func.h: new file as part of the code cleanup from
	Christos Zoulas <christos@deshaw.com>.

	* Lots of fixes from Christos Zoulas <christos@deshaw.com> that
	involved missing prototypes, cleaned up ones, and removal of
	unused variables.

	* libamu/xdr_func.c (xdr_mountres3): some code cleanup.  A switch
	statement with only one case is unclean.

Mon Sep 22 17:26:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_<FOO>fs.c (mount_<FOO>fs): initialize mntent_t fields to
	0 so that all fields are initialized to zero at first.  This way
	SunOS 4.x and other systems don't get /etc/mtab entries with
	random integers for the fsck/freq fields. Patch from Andreas
	Stolcke <stolcke@speech.sri.com>.

Mon Sep 22 00:34:19 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: include <nfs/nfs_clnt.h> so
	that the important definition for HOSTNAMESZ will be found.

	* amd/ops_afs.c (mount_toplvl): limit hostname size to HOSTNAMESZ
	(inside the nfs_args structure) if the system uses that macro.
	Otherwise systems like SunOS refuse to NFS mount long pathnames
	and result in ENAMETOOLONG errno's.

Wed Sep 17 04:56:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): specify new support for
	solaris 2.6, and hlfsd running on 2.5.1 too.

Wed Sep 17 03:55:02 1997  Erez Zadok  <ezk@amsterdam.psl.cs.columbia.edu>

	* conf/mount/mount_svr4.c (mount_svr4): don't attemt an autofs
	mount if it is not supported or was turned off.

Wed Sep 17 03:19:36 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: fixed so that it will nfs mount
	again.  Apparently at some previous release SunOS 4 supported was
	broken and all nfs mounts resulted in ESTALE.

Wed Sep 17 00:26:25 1997  Erez Zadok  <ezk@amsterdam.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5_6.h: nfs protocol headers for
	solaris 2.6.

	* aux/macros/check_nfs_prot_headers.m4: added solaris 2.6 nfs
	protocol header selection.

Sat Sep 13 14:31:51 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): avoid
	infinite loop.

Sun Sep  7 18:23:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a11					***
	*******************************************************************

Fri Sep  5 11:55:10 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (main): if plock() succeeded, don't try to display
	errno message.   Patch from Chris Metcalf
	<metcalf@catfish.lcs.mit.edu.

Thu Sep  4 19:17:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/homedir.c (table_add): make sure duplicate passwd entries
	are ignored.   Only the first entry should ever be used, because
	that's how lookup in passwd database works.

	* conf/transp/transp_sockets.c (get_nfs_version): when determining
	if a remote host is up or down, use NFS v.2.  Fix suggested by
	Enami Tsugutomo <enami@cv.sony.co.jp>.

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): new
	function to get the best possible NFS version, but also timeout
	faster than normal defaults, so remote hosts which are down can be
	detected in a reasonable time.
	(get_nfs_version): use the new "best" function.

Tue Sep  2 00:41:00 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a10					***
	*******************************************************************

Mon Sep  1 15:39:51 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_tli.c (get_nfs_version): don't use
	clnt_tp_create_timed() on systems that don'e have it (Solaris 2.4
	and earlier).

	* aux/configure.in: test for existence of clnt_tp_create_timed(),
	since Solaris 2.4 (and possibly earlier) do not have it.

Mon Sep  1 15:23:18 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* amd/ops_autofs.c (autofs_unmount_1_svc): only display rdevid
	field if it exists (solaris 2.4's autofs does not have it).

Mon Sep  1 14:45:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/type_auth_create_gidlist.m4: a new test to determine
	the correct type to the 5th argument of authunix_create().

Mon Sep  1 03:44:32 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* libamu/xdr_func.c (xdr_umntrequest): add test for autofs
	structure umntrequest, if it has the field rdevid.  Seems Solaris
	2.4 and earlier didn't have it.

Mon Sep  1 01:10:53 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (hlfsd_init): moved initialization upwards, so it
	can be done before primary process forks.
	(main): bug fix: wait a bit to give child a chance to initialize.
	Without this, hlfsd got into a busy infinite loop while, never
	completing the mount.

	* amd/info_nis.c: patch from Jason Thorpe <thorpej@nas.nasa.gov>
	to make amd works when talking to NIS+ servers in NIS
	compatibility mode.

Mon Sep  1 00:46:56 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/mapc.c (MAX_CHAIN): increased maximum chain size to 1024.

Sun Aug 31 20:20:40 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/conf.c (gopt_fully_qualified_hosts): a new function to
	process another new global variable.

	* amd/ops_nfs.c (make_nfs_auth): if a new global variable
	fully_qualified_hosts is on, use FQHN in RPC/NFS authentications.
	Patch from Chris Metcalf <metcalf@catfish.lcs.mit.edu>.

	* amd/conf.c (process_last_regular_map): If the amd.conf file only
	has a [global] section (pretty useless IMHO), do not try to
	process a map that does not exist.

	* scripts/amd.conf.5: fixed typos (repeated 'as' word).

	* doc/am-utils.texi: MAJOR DOCUMENTATION REVISION COMPLETED!!!

	* amd/conf.c (reset_cf_map): Bug fix.  Reset 'tag' field of cfm
	structure, so it does not carry over from map entry to another.

Sat Aug 30 18:39:21 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amd.c (main): fixed the meaning of the plock option.  A bug
	caused it to be reversed.

Sat Aug 30 15:13:18 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/stubs.c: don't initialize some statics here.  They are
	better initialized in hlfsd_init_filehandles().

Fri Aug 22 14:47:16 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (gopt_show_statfs_entries): new function and a global
	amd.conf key show_statfs_entries.  Defaults to 'no'.  If 'yes',
	then all maps flagged as browsable will also show a count of the
	number of entries (keys) in that map.

	* amd/nfs_subr.c (count_map_entries): new function to count number
	of entries in a map.  Now used if browsable is turned on in a map,
	to return a count of available keys in a given map.

	* hlfsd/stubs.c (eq_fh): use correct memcmp().  BUG fixed! hlfsd
	confused the file handles for ".", "..", and the symlink, causing
	mess.

	* aux/macros/func_bad_memcmp.m4: new test, based on autoconf 2.12,
	but also defines HAVE_BAD_MEMCMP, so I avoid linkage conflicts
	with bad memcmp() in libc's (nextstep3).

Thu Aug 21 17:38:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: check if autofs_args_t has a field named
	addr.  Solaris has it for specifying the address of the daemon,
	but Irix does not.  So how does irix tell the kernel the daemon's
	address?  I suspect that it is hardcoded to "localhost" using a
	"private well-known port" (#define AUTOFS_PORT 2048).

	* conf/nfs_prot/nfs_prot_linux.h: added missing autofs
	definitions.

	* README.autofs: new file listing autofs support notes

	* very preliminary autofs code working.  Call it pre-alpha
	quality.

Sun Aug 17 02:25:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (ropt_mount_type, gopt_mount_type): don't accept
	"autofs" if system does not support it.

	* amd/amd.c (main): log am-utils version string (same as amd -v)
	at start of run.

	* conf/transp/transp_sockets.c (get_nfs_version): in order to tell
	if a remote host is available, try to contact its portmapper and
	timeout if no answer is received in 3 seconds.

Thu Aug 14 16:12:04 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_extern.m4 (pattern): use a simpler pattern for
	match for external function definitions.  The function could span
	multiple lines, so only match the opening parenthesis, not the
	closing one too.

	* aux/macros/os_cpp-flags.m4 (ac_cv_os_cppflags,): do NOT turn on
	posix mode for nextstep3.  It is broken.

	* amd/amd.c (init_global_options): run uname() only if
	<sys/utsname.h> and uname(2) exist.

	* amd/rpc_fwd.c (fwd_packet): if remote host is down, the
	forwarding socket is null, so declare this an error.

	* include/am_utils.h (AM_ERRNO_HOST_DOWN): find best errno to set
	for when a remote host is down.  Try, in order, "host down", "host
	unreachable", "invalid argument".

	* amd/ops_nfs.c (discard_fh): don't dereference a null pointer
	(happens when remote host is down, and fp->fh_fs is NULL).
	(prime_nfs_fhandle_cache): ditto, and set fs flags to !FSF_VALID
	and FSF_DOWN.

	* amd/sched.c: nobody uses "union wait" any more, or so it
	appears, so clean up that code.

	* conf/transp/transp_tli.c (get_nfs_version): if remote host is
	down, time it out faster than default (3 seconds).
	(get_mount_client): free netconfig entry when done with it.

	* conf/nfs_prot/nfs_prot_nextstep.h: initial (and somewhat ugly)
	port to nextstep3 (m68k-next-nextstep3).

	* fsinfo/Makefile.am (LDADD): needs to link with libamu in case
	system does not have strdup().

	* include/am_defs.h: complete external definition for getlogin()
	if needed.

	* conf/transp/transp_tli.c (get_nfs_version): no need to keep
	static versout variable.

	* amd/rpc_fwd.c (fwd_packet): if fwdto packet is null, remote
	server is probably down.  Don't use sendto() in that case.

	* buildall (default): run gmake if found, before trying plain
	make.  GNU make is always preferable.

Tue Aug 12 21:23:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/host_macros.m4: cleanup of os_version and os
	overrides.  Solaris 2.5.1 for example will come up as solaris2 and
	2.5.1, rather than sunos5 and 5.5.1.  Both can be overridden in
	the amd.conf file.

Fri Aug  8 14:37:30 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a9					***
	*******************************************************************

Thu Aug  7 00:52:14 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_ncr2.h: new file, for NCR2
	(i486-ncr-sysv4.3.03) headers.  Needed to complete missing stuff
	from <ndbm.h> and <sys/resource.h>.

	* scripts/amd.conf.5: new map page.

	* amd/info_hesiod.c: define extern for hesiod_resolve, since bsdi3
	does not.

	* amd/amd.8: updated man page.

	* amd/get_args.c (get_args): removed defunct -h option to amd.

	* amq/amq.8: updated man page.

	* amd/info_nisplus.c (nisplus_search): prototype fixes so Sun
	SparcCompiler CC won't complain.

	* amd/info_hesiod.c (hesiod_search): small fixes to compile with
	hesiod-1.3, as per Rainer Orth <ro@TechFak.Uni-Bielefeld.DE>.

	* aux/macros/opt_ldflags.m4: new option added to configure
	--enable-ldflags, to specify -L option for configuring/compiling.
	The older one --enable-libs is now to be used only for -l options.

	* amd/ops_nfs.c (mount_nfs_fh): bug fixed.  Should initialize
	nc_protoname from nfs_proto if available for all TLI systems, not
	just those that have NFS V3.

	* amd/info_ldap.c: ldap patches from Leif Johansson
	<leifj@matematik.su.se>, adding two new amd.conf ldap variables:
	ldap_cache_seconds and ldap_cache_maxmem.

	* hlfsd/hlfsd.c (main): bug fixed. port number must be wrapped in
	htons().

Sun Aug  3 17:20:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/nfs_start.c (mount_automounter): register amd with the rpc
	program number that may have been overridden by amd.conf.

	* libamu/xutil.c (set_amd_program_number, get_amd_program_number):
	allow storing and retrieving alternate amd program numbers.

	* amd/conf.c (gopt_portmap_program): new function to parse
	amd.conf entry portmap_program=1234.

	* amq/amq.c (main): allow specifying an alternate rpc program
	number for amd via -P prognum.

	* new amq RPC to get the process id of the running amd.  This is
	used in ctl-amd to quickly find the pid of the amd that is to be
	killed.

	* expanded shared libraries support.  Using GNU libtool-1.0,
	am-utils now builds shared libraries on many platforms that have
	support for it and proper compilers/linkers.  See "INSTALL" file
	for compatibility chart.

Thu Jul 31 13:07:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* fsinfo/fsi_lex.l: removed code that was in support of very old
	versions of flex.  No longer needed.

Tue Jul 29 12:00:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (init_global_options): find the kernel architecture
	from uname() if possible.

Mon Jul 28 03:53:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* new working port: i386-unknown-openbsd2.1

Fri Jul 25 03:16:31 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* working port: sparc-sun-solaris2.4.  Had to fix fhandle_t from
	structure to actual char[], because the structure was passed to
	xdr_fhandle as data and not a pointer.  Surprisingly, gcc
	-fpcc-struct-return did not help.
	
	* conf/nfs_prot/nfs_prot_sunos5_4.h: special nfs protocol
	definitions for solaris 2.4 have to be different from 2.3, and
	different from 2.5.

	* libamu/xdr_fhstatus.c (xdr_fhstatus): minor code cleanup.

Thu Jul 24 16:22:39 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_svr4.c (mount_svr4): use STREQ to compare mount
	types, not ==.  Fix from Christos Zoulas <christos@deshaw.com>.

	* mk-amd-map/mk-amd-map.8: man page taken from bsd44.

Thu Jul 24 00:01:55 1997  Erez Zadok  <ezk@moisil.cs.columbia.edu>

	* conf/mount/mount_linux.c: made the nfs error mapping code into a
	small function.

Wed Jul 23 16:11:49 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_linux.h (NFS_ERROR_MAPPING): special
	error mappings from errno numbers to NFS errors.  From Debian
	Linux.

	* scripts/am-eject.in (fs): new script (taken from Debian Linux
	folks) to auto-unmount floppy/cd devices before ejecting them.

	* fsinfo/wr_exportfs.c (write_exportfs): from Debian folks, pass
	'5' as second arg to show_area_being_processed.  I'm not sure why.

	* fsinfo/wr_atab.c (write_atab): from Debian folks, pass '5' as
	second arg to show_area_being_processed.  I'm not sure why.

	* conf/mount/mount_linux.c (parse_opts): as per Debian Linux,
	ensure that you have a buffer in *xopts to strcat onto.
	(mount_linux): fixed from Debian folks to ensure that NFS mount
	sockets are connected only for kernels prior to 1.3.10 (avoids
	hangs for multi-homed hosts).

	* amd/mapc.c (make_entry_chain): from Debian folks: don't skip
	over amd map keys that have a prefix, and include the prefix in
	the returned readdir().

	* amd/info_passwd.c (passwd_init, passwd_search): format
	enhancements from the Debian Linux folks.  They added
	- var0:=pw-prefix:=anydir
	- var1:=pw-rhost:=dom3.dom2.dom1
	- var2:=pw-user:=user
	- var3:=pw-home:=/anydir/dom1/dom2/dom3/user

	* new ports: sparc-sun-solaris2.4 and sparc-sun-sunos4.1.1.

	* amd/ops_afs.c (afs_retry): patches from Debian Linux.  If
	afs_mount timed out, then explicitly forbid further retries after
	the timeout.  (afs_bgmount): buf fix from Debian Linux.  Timeout
	values (17 and 5) were mistakenly swapped.

Wed Jul 23 15:53:25 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5_3.h: turn off non-existent NFS V.3
	support for Solaris 2.4 (the header files incorrectly define parts
	of the NFS V.3 protocol, but the kernel does not support it).

Wed Jul 23 00:07:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_hesiod.c: minor cleanup to use hes_init and hesiod_init
	for determining if using old or new hesiod libraries,
	respectively.

	* amd/ops_nfs.c (mount_nfs_fh): If "noconn" option exists in NFS
	V.3 then use non-connected sockets (both TCP and UDP).  Otherwise
	they cause hangs of mounts from multi-homed hosts when the return
	route is not the same as the outgoing route (esp. on NetBSD
	1.2.1).  If "conn" option was supplied, then don't turn on the
	"noconn" mount option.  Otherwise default to "noconn" mount
	option.

	* aux/configure.in: better check for systems that need libgdbm and
	<ndbm.h>

Tue Jul 22 04:02:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main), amd/ops_afs.c (mount_toplvl): ensure that
	mounts are hidden from df(1) on systems that keep mount tables in
	kernel, such as osf1.

Tue Jul 22 02:26:55 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a8					***
	*******************************************************************

Mon Jul 21 21:33:19 1997  Erez Zadok  <ezk@stone.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main): bug fixed: forgot to set sin_family to
	AF_INET when hlfsd mounts itself, thus getting an errno "protocol
	family not supported".

Mon Jul 21 20:46:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* verified that amd on NetBSD 1.2.1 (i386) works, but the OS
	itself is flaky.

	* verified that amd AIX 3 works w/ the new readdir() code.

Mon Jul 21 18:59:30 1997  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* amd/mapc.c (maptypes): changed the default map caching type for
	nis and ndbm maps to "MAPC_ALL", so that all possible entries will
	be available to amd for browsable_dirs=yes.

Mon Jul 21 18:04:16 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir, afs_readdir_browsable): split
	afs_readdir into a browsable version and a non-browsable one.
	Fixed bugs that resulted in an infinite nfs_readdir loop on the
	localhost for some operating systems.

Sat Jul 19 19:38:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir): fixed up the browsable code to
	comply with nfs_readdir specs.  It was returning all entries at
	once, even if there was not enough space in the RPC packet.  Now,
	it sends a reasonably sized chunk, and sets static state to resume
	it for the next continuation RPC of readdir.

	* amd/conf.c (set_conf_kv): fixed bug that resulted in the first
	regular map not getting all of the [global] options defaulted from.

Fri Jul 18 00:45:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c (main): fixed so that portmapper "ping" will only fail
	upon an RPC timeout

	* scripts/ctl-{amd,hlfsd}.in (killproc): better method to find the
	amd/hlfsd process to kill.

	* amd/ops_afs.c (mount_toplvl), hlfsd/hlfsd.c (main): code to
	determine how to avoid df from seeing amd's toplvl mounts.  Moved
	from libamu/mount_fs.c and include/am_utils.h.  Ensure that hlfsd
	is hidden from df.
	(mount_toplvl): fixed df types for irix.

Thu Jul 17 21:59:45 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* amq/amq.c (main): fixed bug that caused the 5 second timeout for
	TLI amq using udp to be ignored.
	(main): if amq cannot contact remote host's portmapper within 5
	seconds, timeout and fail faster than the default longer timeout
	(this is for non-TLI systems).

Thu Jul 17 17:08:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c (get_secure_amd_client): if amq cannot contact
	remote host's portmapper within 5 seconds, timeout and fail faster
	than the default TLI timeout of over 4 minutes.

	* amd/am_ops.c (ops_showfstypes): added styles for new bsd44
	file systems nullfs, unionfs, and umapfs.
	(ops_show1): cleanup code and and reuse this function.
	(vops): empty placeholders for nullfs, unionfs, and umapfs.

	* amd/ops_{nullfs, unionfs, umapfs}.c: 3 new empty templates for
	bsd44 style file systems.

	* fsinfo/fsinfo.8: man page for fsinfo rewritten from bsd44
	sources.

	* amd/conf_tok.l, fsinof/fsi_lex.c: undefine ECHO to avoid
	conflict with systems that define it in <sys/ioctl.h> and also
	define a conflicting one via lex.  Newer versions of f/lex are ok.

Wed Jul 16 00:17:45 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_nfs.c (mount_nfs_fh): fill in nfs_args' fields
	acdirmin/max and acregmin/max only if they exist.

	* aux/configure.in: test for nfs_args fields acdirmin and
	acregmin.

Tue Jul 15 17:24:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: commented out checking for MNT2_GEN_OPT_* for
	"nondev" and commented back in checking for "nodev".  This was a
	typo.

	* include/am_compat.h: more compatibility options: define "ro"
	mnttab option all the time.  Define "overlay" as needed.  Added
	more fillers of mnttab options (as per Daniel S. Riley
	<dsr@mail.lns.cornell.edu>), for acdirmax, acdirmin, acregmax,
	acregmin, noac, grpid, nosuid, and actimo.

	* libamu/mount_fs.c (mnt_flags): fixed a typo in "ro" option as
	per dsr@mail.lns.cornell.edu (Daniel S. Riley).  Then cleaned up
	the same code for other options in struct opt_tab.

Mon Jul 14 22:36:37 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/get_args.c (get_args): moved amd.conf file parsing to before
	the switching the default log/debug options.  Suggested by
	dsr@mail.lns.cornell.edu (Daniel S. Riley).

	* aux/update_build_version: new script to record the build version
	of amd, along with the rest of the info thet comes up with amd -v.

Sun Jul 13 00:30:24 1997  Erez Zadok  <ezk@decca.damtp.cam.ac.uk>

	* aux/macros/os_cflags.m4: new macro, to add additional
	compilation options (also used during configuration), based on the
	OS and the compiler.  Used for solaris-2.6, osf, and irix6.

Fri Jul 11 10:15:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf_tok.l, conf_parse.y: allow values of keys to include
	white spaces, if they are double-quoted (key="some value")

	* amd/info_hesiod.c (hesiod_search): cleanup and minor bug fixes
	of hesiod from Danny Braniss <danny@cs.huji.ac.il>.

Fri Jul 11 02:16:06 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a7					***
	*******************************************************************

Thu Jul 10 12:19:25 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_defs.h: fill in extern definition of innetgr() in
	case system headers don't.

	* aux/macros/path_prog_lex.m4 aux/configure.in: using macros that
	will show the full pathname to yacc/bison and f/lex.  Some systems
	have older or bad versions of those and this way the user will
	know for sure what is being invoked.

	* tasks: file populated with todo items.

	* scripts/amd2ldif.in: Script to convert amd maps to plain text
	LDAP object files.  Contributed by Leif Johansson
	<leifj@matematik.su.se>.

	* aux/config.guess: added recognition for sun3's running 4.2bsd,
	from Tom Schmidt <tschmidt@micron.com>.  Fixed one small typo.

	* amd/conf.c: several variables that were local to a map, were
	also added to [global], where they apply to all maps.  Each map
	can then individually override those defaults.  Flags
	affected: browsable_dirs and mount_type.  Options affected:
	map_type, map_options, and search_path.

	* amd/amd.h: eliminated several global flags each of which took an
	int, in favor of one global flags variable used as a bit field.

	* amd/amd.c (init_global_options): moved all global variables into
	a single struct amu_global_options, so it is easier to add new
	ones and/or identify existing ones.

	* amd/get_args.c (get_args): removed unused amd -m option.

	* amd/conf.c (gopt_cluster): added new amd.conf option for cluster
	name, same as amd -C.

	* amd/info_ldap.c: LDAP info map functions from Leif Johansson
	<leifj@matematik.su.se>.

	* amd/conf.c (gopt_ldap_base, gopt_ldap_hostports): put in global
	amd.conf options for ldap_base and ldap_hostports.

	* amd/opts.c (f_netgrp): new amd map function netgrp(ARG) to test
	if the current host is in the ARG host netgroup.

	* aux/configure.in: some systems replaced dbm in libc with GNU's
	libgdbm, so check for libgdbm, but only if dbm_open is not in
	libc already.  This was a recommendation from Tom Schmidt
	<tschmidt@micron.com>.

	* conf/nfs_prot/nfs_prot_sunos5_3.h: port to sparc-sun-solaris2.3
	completed.

Wed Jul  9 18:14:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* port to sparc-unknown-netbsd1.2E done, not tested.  Includes NFS
	V.3.

Tue Jul  8 17:35:07 1997  Erez Zadok  <ezk@elk.mcl.cs.columbia.edu>

	* port to i386-unknown-freebsd3.0 done and working.  Includes NFS
	V.3.

	* aux/macros/check_nfs_fh_dref.m4: freebsd3 should use
	file handle dereferencing style similar to freebsd22.

	* include/am_defs.h: need to include <net/if_var.h> before
	<netinet/if_ether.h> on freebsd3.

	* conf/nfs_prot/nfs_prot_freebsd3.h: new protocol header additions
	for freeBSD 3.0.

Tue Jul  8 16:53:41 1997  Erez Zadok  <ezk@moisil.cs.columbia.edu>

	* amd/info_nis.c (nis_reload): cast nis' callback function so
	picky compilers won't complain.

	* libamu/xdr_mountres3.c (xdr_mountres3): make sure this function
	gets compiled only if the system has NFS V3 and does not have
	xdr_mountres3.

Tue Jul  8 12:42:03 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* COPYING: put in some legal stuff in this file.

Mon Jul  7 19:10:44 1997  Erez Zadok  <ezk@prometheus.soscorp.com>

	* NFS V3 now works under Irix5, thanks to patches from 
	Andreas Stolcke <stolcke@speech.sri.com>.

	* conf/mount/mount_irix5.c: sparate mount_irix.c into an irix5
	version and an irix6 version, since irix5's NFS V3 code is broken
	and hacky.

	* amd/info_hesiod.c (hs_zone_transfer): minor fixes to buffer
	sizes for some hesiod queries.  Patch from Danny Braniss
	<danny@cs.huji.ac.il>.

Mon Jul  7 19:04:14 1997  Erez Zadok  <ezk@glory.soscorp.com>

	* amd/ops_nfs.c (mount_nfs_fh): fixed NFS V.3 support for bsdi3.

Sun Jul  6 14:22:24 1997  Erez Zadok  <ezk@glory.soscorp.com>

	* aux/{configure.in,acconfig.h}: added checks for struct
	nfs_args's fields proto and sotype (bsdi3).
	
	* amd/ops_nfs.c (mount_nfs_fh): added nfsv3 option to
	nfs_args.flags for bsdi3.  Set field proto to 0.  Set sotype field
	to SOCK_STREAM or SOCK_DGRAM.

	* aux/macros/check_mount_style.m4: add case for bsdi3.

	* amd/info_hesiod.c: got hesiod support for bsdi3.

Sun Jul  6 11:14:47 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: look for hesiod on libc (bsdi3)

	* amd/get_args.c (get_args): reformat usage so it fits in 80
	columns.

	* scripts/ctl-amd.in: changed directory name for optional tftpboot
	map to /tftpboot/.amd.

Sat Jul  5 17:46:45 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a6					***
	*******************************************************************

Sat Jul  5 03:17:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-amd.in: include -T tag for tftpboot.

	* new port: mips-sgi-irix5.3.  Compiled with gcc, but NFS V3 code
	is broken and needs work on the specific nfs_args that irix5 uses
	for V3 mounts.

Sat Jul  5 01:44:25 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/get_args.c (get_args): new options amd -T tag.  A map with
	tag=foo matching the -T tag will be processed.  All untagged maps
	get processed all the time.

Fri Jul  4 16:19:26 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: need to check for strcasecmp in libucb (ncr2)

	* aux/macros/check_os_libs.m4: a new macro to set the usage of
	libnsl and libsocket based on the OS.

	* libamu/mount_fs.c (mnt_flags): used MNTTAB_OPT_GRPID if it is
	defined (problem on osf4).

	* conf/nfs_prot/nfs_prot_irix5.h: new file for irix5 headers.

	* include/am_defs.h, aux/macros/try_compile_nfs.m4,
	aux/macros/mount_headers.m4: do include <sys/proc.h> because it
	failes on irix5.  Rather, put in the individual
	conf/nfs_prot/nfs_prot_*.h headers.

	* amd/conf.c: AIX3 doesn't like strdup() being passed a constant
	char*, so cast all strdup()'s args to a non-const char*.

	* amd/mapc.c (root_newmap): don't try to strdup only a "const
	char *".

Fri Jul  4 15:47:10 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: added rpc/rpc.h and
	sys/errno.h.

Thu Jul  3 17:49:00 1997  Erez Zadok  <ezk@prometheus.soscorp.com>

	* made sure am-utils compiles, links, and runs properly on Irix
	6.2 using "cc -32 -Wl,-woff,"

	* aux/macros/check_lib2.m4: a bug fix version to autoconf 2.12
	AC_CHECK_LIB.  If OTHER-LIBRARIES are defined and used, then add
	them to $LIBS.

	* aux/configure.in: some cleanup of which libraries are needed.
	Espectially ensure that libnsl is included only on Solaris, where
	so far it is the only system on which it is absolutely necessary.
	Also no longer need to include libc explicitly. 

	* amd/amd.c,wire-test/wire-test.c (main): convert IP address to
	network-long order before printing it.

	* wire-test/wire-test.c (main): also check and report on the IP
	address of the local host, since some systems have bad versions of
	get_myaddress, or ones that conflict with other versions in
	multiple libraries (SunOS 4 and Irix especially).

Wed Jul  2 18:19:02 1997  Erez Zadok  <ezk@starblazers.soscorp.com>

	* scripts/ctl-amd.in: don't use full pathname so killproc() works
	better.  Also run bsd44 and irix style ps programs. 

	* aux/macros/check_lib_funcs.m4: bug fixed: used to define usage
	of library no matter if it was found or not.

Wed Jul  2 02:11:48 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_mnt2_gen_opt.m4: turned back on the checking
	for M_* macros, but ensure that <sys/stream.h> is not included at
	all so it won't conflict with other M_* macros.

Tue Jul  1 21:16:51 1997  Erez Zadok  <ezk@mako.cs.columbia.edu>

	* conf/mount/mount_irix.c (mount_irix): first arg to mount(2) on
	irix should be "spec" (host:/path), not the dir of the mnt point.

	* amd/ops_afs.c (afs_lookuppn): bug in enable_default_selectors
	fixed.  If on, it essentially ignored the setting in a
	selector-controlled /defaults if there were 2 or more entries in it.

Tue Jul  1 12:23:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-{amd,hlfsd}.in (killproc): if failed to find process
	using BSD style ps, then try SVR4 style ps.

	* include/am_utils.h (amuDebug): renamed Debug macro to amuDebug
	etc., to avoid conflicts with similar named macros in <ldap.h>.

	* aux/configure.in, amd/info_ldap.c, etc.: put in all the autoconf
	support needed for LDAP.  Now the code has to be written mostly in
	amd/info_ldap.c.

	* Included additional patches from Andreas Stolcke
	<stolcke@speech.sri.com> to support using the best possible
	combination of NFS version (2,3) and protocol (udp,tcp) for any
	given host, since it appears that some Irix versions have NFS V3,
	but do not support TCP.

	* scripts/ctl-amd.in: updated amd control script to look for and
	use amd.conf file.

Tue Jul  1 00:28:23 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/mapc.c (mapc_create): now, each map in the amd.conf can be
	initialized off of a different type, or default to cycling through
	all maps until one of them matches.

Mon Jun 30 20:49:13 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir): per-map browsing (readdir) done.
	if browsable_dirs=yes is set in the map section in amd.conf, that
	map will return all entries back to a readdir(2).

Sun Jun 29 16:22:11 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* rudimentary amd.conf file support included.  You may even
	override things like os=sos5, to get "backwards" compatibility with
	upl102.

Sat Jun 28 13:35:02 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/conf.c: new file to process amd.conf file.

	* amd/get_args.c (get_args): new options -H to print help.

	* moved enable_default_selectors to be amd.conf controlled, and
	not compiler controlled.

	* amd/get_args.c (get_args): new options -F <conf-file> to parse an
	amd configuration file.

Wed Jun 25 23:15:42 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* converted all files that used strcmp() == 0 or != 0  to using
	the STREQ() macro.

Mon Jun 23 22:31:14 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/macros/check_lib_funcs.m4: new M4 macro that can be used to
	search for any number of functions in any given library.

Mon Jun 23 01:04:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/mapc.c: Included patch from Leif Johansson
	<leifj@matematik.su.se> to ensure that systems without an RE
	library can compile.

	* libamu/mount_fs.c (mount_fs): Included patch from Andreas
	Stolcke <stolcke@speech.sri.com>, to ensure that mount options on
	table are properly delimited by a comma.

	* amd/ops_nfs.c (mount_nfs_fh): Included patch from Andreas
	Stolcke <stolcke@speech.sri.com>, to allow users to override the
	proto= and vers= mount options.

Sun Jun 22 01:00:11 1997  Eric Dana  (edana@ncr2.bgs.com)

	* conf/nfs_prot/nfs_prot_svr4.h: port completed to
	i486-ncr-sysv4.3.03.  Assorted source cleanups done.

	* include/am_defs.h, aux/macros/mount_headers.m4: don't include
	mnttab.h if sys/mnttab.h was already included, because on ncr2,
	they contain conflicting entries for struct mnttab.

Sat Jun 21 23:52:15 1997  Eric Dana  (edana@ncr2.bgs.com)

	* aux/macros/check_nfs_prot_headers.m4: added support for ncr2.

Fri Jun 20 06:14:17 1997  Erez Zadok  <ezk>

	* amd/*.c: lots of 64-bit "ugly" ports like casts to long ints.

	* aux/macros/struct_nfs_fh.m4: check for "struct nfssvcfh" because
	on DU-4.0 it is better than the next one to be picked (nfsv2fh_t).

Wed Jun 18 18:59:49 1997  Erez Zadok  <ezk@defiant.soscorp.com>

	* aux/macros/struct_nfs_fh.m4 (AC_TRY_COMPILE_NFS): check for
	nfsv2fh_t before fhandle_t becasue on bsdi2.1 the former is
	better.

Tue Jun 10 17:06:58 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/rpc_fwd.c (fwd_packet): TLI bug fix. if fwdto socket is
	NULL, set the maxlen and len fields in netbuf to zero.

Wed May 28 22:52:28 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/fix-amd-map.in (name): replace all matching patterns on
	line.

Sun May 25 19:33:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a5					***
	*******************************************************************

Sun May 25 13:37:24 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amq_subr.c (amqproc_getvers_1_svc): amq's RPC service
	procedure now returns the full string that amd -v returns.

	* amd/get_args.c (get_version_string): new function to return
	complete version/info string so it could be used more flexibly.

	* amd/am_ops.c (ops_showamfstypes, ops_showfstypes): put the list
	of Fs types into a string buffer, rather than a FILE*.

	* amd/mapc.c (mapc_showtypes): put the list of map types into a
	string buffer, rather than a FILE*.

Sun May 25 01:25:36 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/get_args.c (get_args): amd -v also prints user who built
	amd, hostname built on, and date of configuration.

Sat May 24 13:40:50 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/lostaltmail.conf-sample: sample lostaltmail
	configuration file.

	* scripts/lostaltmail.in: new script lostaltmail used to redeliver
	"lost" mail that hlfsd redirected to a temp location because the
	primary home file system of the user was full.

	* scripts/amd2sun.in: new script amd2sun. Used to convert Sub
	automount maps to amd maps.

	* scripts/ctl-hlfsd.in: new script ctl-hlfsd.  Used to start,
	stop, or restart hlfsd.
	
	* scripts/expn.1: man page for expn command.

	* scripts/ctl-amd.in: new script ctl-amd.  Used to start, stop, or
	restart amd.

	* scripts/expn.in: new script expn.  Actually taken from David
	Muir Sharnoff <muir@idiom.com>.  Used by hlfsd's mail re-delivery
	script.

	* scripts/wait4amd.in: new script wait4amd added.  Waits for amd
	to come up on a host, and then runs a command (rsh $hostname by
	default).

	* scripts/Makefile.am: new directory now holds all shell/perl
	scripts that belong to am-utils.

	* conf/mount/mount_linux.c (parse_opts): new parser for
	linux-specific mounts.  Handles fs-type specific mount-options
	correctly.  Currently implemented: msdos, iso9660.

	* amd/ops_pcfs.c (pcfs_ops): don't timeout cdfs mounts by default
	(fix for linux).

	* amd/ops_cdfs.c (cdfs_ops): don't timeout cdfs mounts by default
	(fix for linux).

	* amd/mapc.c (make_entry_chain): fixed bug that resulted in amd
	core dumps upon "ls" of a mount point; an invalid pointer was
	being returned and dereferenced.

	* port to Linux sparc working!

	* hlfsd/homedir.c (hlfsd_diskspace): close file descriptor if
	failed to write test file, or else the fd will leak.

Sun May 18 00:42:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_hesiod.c (hs_strip_our_domain): use strcasecmp()
	instead of strcmp().

	* Port to Digital Unix 4.0 (OSF) done.

	* hlfsd/hlfsd.c: renamed dirname to dir_name to avoid conflicts
	with dirname() function in <string.h> on OSF systems.

	* fsinfo/fsi_util.c (set_ether_if): take out extern definition of
	inet_addr().  It should come from <arpa/inet.h> instead.

	* conf/mtab/mtab_osf.c: fixed macros and added NFS V3 specs.

	* include/am_utils.h: renamed FIRST/LAST to AM_FIRST/AM_LAST to
	avoid conflicts with DU 4.0 system header.

Thu May 15 22:49:12 1997  Erez Zadok  <ezk@subzero.cs.columbia.edu>

	* libamu/mount_fs.c (mount_fs): pass along NFS version so I can
	determine if to include additional options in the mount table file
	entry (such as proto=tcp, and vers=3).

Thu May 15 00:42:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (mount_fs): include NFS version number in the
	mount table options, as well as proto={tcp,udp}.

Wed May 14 14:30:19 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* NFS V3 code ported to most other systems, so it compiles for V2
	and V3 NFS systems.

	* NFS VERSION 3 support, first pass.  Working for Solaris and
	using TCP.

Sun May 11 01:14:29 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amq/amq.c: many newline characters were missing from various
	stderr printfs.

Sat May 10 13:09:06 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5.h: protocol defintions for
	Solaris, which include NFS V3 support.

	* conf/nfs_prot/nfs_prot_default.h: default NFS protocol headers.
	*** Released am-utils-6.0a15					***
	* conf/transp/transp_{tli,sockets}.c (get_mount_client): use NFS
	protocol version while getting a mount client.

	* amd/ops_nfs.c (mount_nfs_fh): set the mount types, mnttab types,
	file handle size, and proper file handle based on the correct NFS
	version number.
	browsable_dirs=full, which will print *all* entries (other than
	* conf/mount/mount_svr4.c (mount_svr4): support NFS3 mounts under
	Solaris and other SVR4 systems.

	* amd/ops_nfs.c: store NFS file handle version and version
	specific handle in struct fh_cache.
	(got_nfs_fh): pick the correct RPC reply based on the NFS version
	of the server.
	(prime_nfs_fhandle_cache): figure out the right NFS file handle
	for a node, but now include NFS protocol version information.
	(call_mountd): set the correct version for the mount protocol,
	based on the NFS protocol version.
	(nfs_init): use the NFS protocol generic structure
	am_nfs_handle_t.
	to 1500.
	* include/am_utils.h: new structure am_nfs_handle_t to contain all
	possible versions of NFS file handles.
	* doc/am-utils.texi: fixed reversed documentation for NFS mount
	* amd/srvr_nfs.c (start_ping): ping program performs NFS version
	specific pings.
	(recompute_portmap): figure out the correct portmap version mount.
	(nfs_keepalive): call start_ping() with the correct NFS version.
	(find_nfs_srvr): if mount option "vers=" is given, use it.  Get
	the NFS server version and verify that it is up.

	* conf/transp/transp_{tli,sockets}.c (get_nfs_version): a new
	function to find the best NFS version for a particular host.
	installing html files.  Another new target "alldocs" is just for
	* libamu/amu.h: determine what is the highest version of NFS we
	should try.

	* include/am_utils.h (NFS_VERSION3): added definition for NFS V3
	protocol number.
	Added field fs_version to struct fserver, so we can now store the
	server protocol version.
	facility in the log_file option.
Fri May  9 01:09:45 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>
	* libamu/xutil.c (get_syslog_facility): allow users to specify the
	* aux/macros/check_field.m4 (AC_MOUNT_HEADERS): map '.' (dot) into
	underscores too, so I can test for sub-fields.
	will use the default LOG_DAEMON facility.
	* libamu/wire.c: use test that checks for sub-fields of struct
	ifreq.
Thu Jan  8 04:05:10 1998  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
Sat May  6 10:20:17 2000  Erez Zadok  <ezk@glory.soscorp.com>
	(intel).
	* port to BSD/OS 3.0 completed!  Many xdr_ functions were broken
	into smaller files.  M4 macros fixed to test for existence of
	file systems using getvfsbyname().
	before appending to it, on systems with two or more network
	* amd/sched.c (sigchld): signal handler must waitpid() for all
	possible children.
	the mntent for cachefs.
	* hlfsd/homedir.c: signal handler must waitpid() for all possible
	children. 
	const for both arguments.
	* aux/macros/check_restartable_signals.m4: new macro to determine
	if need to reinstall signal handlers per OS is better than trying
	to figure these out based on system macros.

Fri May  5 19:23:28 2000  Erez Zadok  <ezk@glory.soscorp.com>
	* amq/pawd.c (cluster_server): don't use getccent() if the extern
	* amd/ops_nfs.c (mount_nfs_fh): set nfs_args_t version number.
	<cluster.h> and struct cct_entry do not exist.
	* amd/ops_afs.c (mount_toplvl): set nfs_args_t version number.
	hpux systems don't have it (hpux 10.20).
	* amd/ops_nfs.c (mount_nfs_fh): process nfs mount option resvport
	(must be supplied for bsdi 3.0)

	* libamu/wire.c: use HAVE_FIELD_STRUCT_IFREQ_IFR_ADDR (and
	associated new macro) for determining the right way to compute the
	size of the interface structure.
	for new amq options -T/-U.
Fri Apr 11 15:56:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: need to include libc before libnsl if
	get_myaddress() is available because on irix libnsl has a buggy
	get_myaddress().

	* include/am_defs.h: make sure REINSTATE_SIGNAL_HANDLER is defined
	on Irix 6 (an SVR4 variant)
	* amq/pawd.c: a new program, Print Automounter Working Directory,
Thu Mar 27 02:28:40 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* aux/macros/localconfig.m4: trivial support for am-utils
	*******************************************************************
	*** Released am-utils-6.0a4					***
	*******************************************************************
	wish in a file called localconfig.h, located in the top build
Wed Mar 26 21:15:36 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	* doc/am-utils.texi (Caching Filesystem): updated documents for
	* amd/amq_subr.c (ok_security): turned off insecure code unless
	user explicitly runs configure --enable-amq-mount.
	* amd/ops_cachefs.c: initial cachefs support, for solaris.
	* hlfsd/hlfsd.c (main): use new protoypes dor create_nfs_service().

	* amd/nfs_start.c (mount_automounter): use code that separately
	creates the NFS and the amq service.  Register tcp and udp
	services for amd.
	cachefs file systems.
	* conf/transp/transp_*.c (create_amq_service): new function to
	separately create the amq service for amd.  Simplified prototypes
	for create_nfs_service().
	mnttab type is.
Wed Mar 19 20:40:56 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
Mon Jan  5 23:22:49 1998  Erez Zadok  <ezk@lorien.cs.columbia.edu>
	*******************************************************************
	*** Released am-utils-6.0a3					***
	*******************************************************************

Wed Mar 19 17:49:18 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* amd/ops_nfsl.c (nfsl_ffserver, nfsl_match): also check if the
	* new port: rs6000-ibm-aix3.2.5 and rs6000-ibm-aix4.1.5.0.  Lots
	of small changes to support these two.
	type:=nfs.
Wed Mar 19 14:33:30 1997  Erez Zadok  <ezk@grande.cs.columbia.edu>
	* updated all source files to add 1998 as a copyright year.
	* conf/umount/umount_default.c (umount_fs): bug: unlock_mntlist()
	should run if MOUNT_TABLE_ON_FILE, not otherwise.
	like type:=linkx if the pathname denoted by $fs exists, and like
Mon Mar 17 22:02:43 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main): fill in fhsize field if exists
	(freebsd-2.2).

	* amd/ops_{nfs,afs}.c (mount_toplvl): fill in fhsize field if
	exists (freebsd-2.2).

Sat Mar 15 19:37:48 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* hlfsd/homedir.c (plt_init): make function exported, to save on
	* new port: i386-unknown-freebsd2.2.  FreeBSD 2.2 and higher
	changed the filehandle type in struct nfs_args from nfsv2fh_t to
	u_char.
	instead.
Sat Mar 14 10:11:03 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
Thu Jan  1 00:15:58 1998  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>
	* SHARED LIBRARIES: too many change to list individually.  Now,
	libamu can be built as a shared library, and other programs link
	with it.

Tue Mar 11 22:24:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/macros/opt_shared.m4: new macro for setting options for
	building shared am-utils libraries.
	* amd/ops_afs.c (mount_toplvl): Bug fix.  Don't try to free() an
Sun Mar  9 19:17:46 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* ALL SOURCES: change every direct call to free() to xfree(), so
	* fixmount/fixrmtab: cleaned up the script.
	call dxfree(), which will print the file name and line number
	* fixmount/Makefile.am (EXTRA_DIST): adde $(sbin_SCRIPTS) so that
	fixrmtab gets distributed too.

	* conf/nfs_prot/nfs_prot_bsdi2.h: added support for MOUNTPROC_DUMP.
	Added extern for xdr_mountlist().
Tue Dec 23 04:24:28 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* aux/configure.in: trimmed down many tests for MNT2_GEN_OPT,
	MNT2_NFS_OPT, and MNTTAB_OPT that were not referenced anywhere in
	the sources.

Sat Mar  8 00:23:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	calloc().
	* fixmount/hlfsd ported to bsd44, hpux, and linux systems.

	* aux/macros/check_fixmount_style.m4: add check for bsd44 systems.
	malloc().
	* conf/fixmount/fixmount_default.c: use lockf() if flock() is
	unavailable.
	zero its bytes.
	* include/am_defs.h: include <string.h> even if don't have
	STDC_HEADERS defined (sunos4).
	(seteuid): define seteuid() to be setresuid() for systems that
	have but not the other (hpux).
	* amq/amq.c: amq does not need its own definition of xfree().
	* aux/macros/check_extern.m4: test should include <strings.h>.
	look for function malloc_verify() in libmapmalloc.a, and function
Tue Mar  4 17:16:52 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* lib/xutil.c (debug_option): moved from amd/getargs.c to this
	more proper file.
	uordbytes, because it does not always exist.  Rather, compute it
	* include/am_utils.h: put in structure for debug options, for all
	progams to use.
	used when debugging memory references.
	* amd/get_args.c: moved structure for debug options out.
Mon Dec 22 03:01:30 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
Sun Mar  2 00:13:07 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	Otherwise browsable_dirs fails on OpenBSD 2.2.
	* ported fixmount.
	* amd/mntfs.c (uninit_mntfs): bug fix.  Moved freeing of
	* lib/ualarm.c: replacement function for systems that don't have a
	ualarm().
Sat Dec 20 00:51:21 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* ported fsinfo.
	* amd/ops_host.c (host_umounted): don't use clnt_spcreateerror()
Sun Mar  1 10:23:34 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	* include/am_defs.h: add missing extern definition for free().
	* ported mk-amd-map.

	* buildall: added -K option to buildall, to run mkconf.
	optional function.
Fri Feb 28 01:10:25 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	if they exist.
	*******************************************************************
	*** Released am-utils-6.0a2					***
	*******************************************************************
	* aux/configure.in: check for missing functions clnt_create and
Thu Feb 27 13:58:59 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* all *.[hcyl] files: add copyright line.
	* Makefile.am: updates for new sunos3 files distributed.
	* aux/macros/check_mount_type.m4: test for mount type for
	linux-like systems, by checking for loadable or statically linked
	kernel filesystem modules.
	* conf/fh_dref/fh_dref_sunos3.h: new file.
	* aux/macros/check_mnttab_type.m4: test for mount table entry
	for linux-like systems, by checking for loadable or statically
	linked kernel filesystem modules.
	* aux/macros/check_nfs_fh_dref.m4: added sunos3 case.
	* aux/configure.in: pcfs filesystems can use vfat type (linux)
	* doc/am-utils.texi (wire Selector Variable): updated manual for
	* aux/macros/check_fs_mntent.m4: test for filesystem existence for
	linux-like systems, by checking for loadable or statically linked
	kernel filesystem modules.
	in_network() function.
	* conf/trap/trap_hpux.h: ugly hack added because of stupide HPUX
	9.0 header files.  This should be removed when HPUX 9.0 is deemed
	defunct.
	functions.  Converted wire, network, and netnumber all to use the
	* aux/acconfig.h: set an undefined variable for having an extern
	to clnt_sperrno().
	against all networks, not just primary.
	* include/am_defs.h: define extern for clnt_sperrno() if needed.
	* conf/nfs_prot/nfs_prot_linux.h: add special definitions for
	* aux/configure.in: test for extern clnt_sperrno().
	<rpc/des_auth.h> because it is incomplete on the same systems.
	* aux/macros/check_nfs_fh_dref.m4: HPUX's NFS fhandle dref is
	similar to irix.
	* hlfsd/homedir.c (table_add): cast uid field to int, for
	* aux/macros/check_mount_style.m4: use mount helper on HPUX.
	* include/am_defs.h: more coflicts with redhat alpha linux
	* aux/macros/check_mtype_type.m4: hpux's mount type is a char*,
	not integer (but may be mapped to one later).
	* aux/macros/{mount_headers,try_compile_anyfs,try_compile_nfs}.m4:
	* conf/mount/mount_hpux.c (mount_hpux): HPUX has confusing header
	files.  They have mount(2) and vfsmount(2) which don't take same
	arguments, and they have string mount types MNTTYPE_* as well as
	integer types MOUNT_*.  So I need this new mount function to map
	from string types to integer types for the vfsmount() function.
	redhat alpha linux.
	* conf/trap/trap_hpux.h (MOUNT_TRAP): instead of calling
	vfsmount(), call mount_hpux().
	the new "!" (negated) nomadic functions.
Thu Feb 27 03:34:14 1997  Erez "HWank1" Zadok  <ezk@okeeffe.cs.columbia.edu>
	rather than saying that any ARG is on a local network.
	* lib/mount_fs.c (mnt_flags): make sure SYNC option is on only if
	both MNTTAB_OPT_SYNC and MNT2_GEN_OPT_SYNC are defined.

Thu Feb 27 00:26:00 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>
Thu Dec 18 20:57:19 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* conf/nfs_prot/nfs_prot_hpux.h: NFS protocol definitions for
	hpux.

	* include/am_defs.h: no need to include rpc/auth.h or rpc/clnt.h.
	Finally, it looks as if OpenBSD 2.2's NFS 3 implementation may be
	* aux/configure.in: no need to test for rpc/auth.h and rpc/clnt.h.
	wait until they get it working in their version of the automounter
	* buildall: added ability to configure using other shells than
	/bin/sh, on those systems where /bin/sh is buggy or limited
	(HPUX).
	maxgrp.
	* aux/macros/struct_nfs_fh.m4: reinstated the macro but have it
	defined am_nfs_fh, and also test for plain typedef "nfs_fh".
	"maxgrps".  Added test for mount table entry "maxgroups".
	* aux/acconfig.h: #undef am_nfs_fh, which is being defined by a
	reinstated macro.
	* libamu/mount_fs.c (compute_nfs_args): perform more careful tests
	* aux/configure.in: check for <nfs/export.h>

	* include/am_defs.h: include <nfs/export.h> (HPUX) if exists.
	including 9.x, should use "ignore" as the mount type to hide from
	* aux/macros/try_compile_nfs.m4: include <nfs/export.h> (HPUX) if
	exists.

	* aux/macros/mount_headers.m4 (define): removed some non-working
	(on HPUX) code that attempts to recreate the fhandle_t rather than
	load it up from system headers.  Also added some NFS protocol
	header inclusion.  include <nfs/export.h> (HPUX) if exists.
	every where in the sources.
Wed Feb 26 00:32:35 1997  Erez "HWank1" Zadok  <ezk@okeeffe.cs.columbia.edu>

	* aux/macros/mount_headers.m4 (define): Use M4 changequote to
	ensure [] brackets are correctly used.
	useful for detecting internal flags and options, as well as the
	* aux/macros/expand_cpp_{string,hex,int}.m4: encapsulate
	multi-line M4 inclusions in [].
	after /etc and before /etc/local.
Tue Feb 25 22:19:44 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* aux/configure.in, libamu/Makefile.am: added support for linking
	* conf/mtab/mtab_bsd.c (mnt_dup): use statfs field f_fstypename if
	it exists.

	* aux/acconfig.h: HAVE_FIELD_STRUCT_STATFS_F_FSTYPENAME, new
	config.h macro for field f_fstypename of struct statfs.
	needed.
	* aux/configure.in: testing for field f_fstypename field of struct
	statfs (NetBSD).
	netbsd).
	* aux/acconfig.h: moved all of the "static" definitions out to a
	fixed file called include/am_defs.h.  Added to all */Makefile.am
	files a dependency on am_defs.h.  Created am_defs.h of course, and
	then added #include <amd_defs.h> to all of the source and header
	files that required it.
	for NetBSD-1.3_BETA and similarly for OpenBSD.
Mon Feb 24 01:27:02 1997  Erez Zadok  <ezk@defiant.soscorp.com>
	* conf/nfs_prot/nfs_prot_netbsd1_3.h: new header for the slight
	* aux/acconfig.h: two more externals for xdr functions that may be
	implemented by libamu.
	mktemp().
	* conf/nfs_prot/nfs_prot_bsdi2.h: added missing RPC and XDR
	definitions.
	* amd/ops_nfs.c (mount_nfs_fh): Systems that include the mount
Sun Feb 23 15:25:26 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	"nfs3", but to "nfs" and then they set "vers=3".  Setting it to
	* buildall (default): added -D option for turning on even stricker
	developer options.
	systems, set it to "nfs".
	* */Makefile.am: make sure @AMU_NFS_PROT_HEADERS@ is used to
	determine dependencies on optional NFS protocol headers.

	* aux/acconfig.h: define and use HAVE_NFS_PROT_HEADERS as needed.

	* aux/macros/check_nfs_prot_header.m4: new test to determine what
	NFS protocol headers to use. 
	system mount types under nextstep for mount(2).
	* conf/nfs_prot/nfs_prot_{irix6,sunos4,bsdi2}.h: new headers to
	complete missing system headers for NFS protocol definitions.
	integer and string types for file system mount types in mount(2),
Sun Feb 16 15:58:42 1997  Erez "HWank1" Zadok  <ezk@vir.cs.columbia.edu>
	(EPERM) instead of 0 (OK).  Fixes m68k-next-nextstep3 which now
	* amd/ops_nfs.c (mount_nfs_fh): encapsulated some more code in
	#ifdef's as needed.

	* amd/ops_afs.c (mount_toplvl): make sure TIMEO/RETRANS code is
	suitable #ifdef'ed.

	* include/am_compat.h: a couple more mnttab options
	(timeo/retrans) setting just in case.

	* amd/autil.c (host_normalize): make sure hostent->h_name is
	passed a non-const char *.

	* conf/mount/mount_linux.c (mount_linux): cleaned up a block of code.
	inclusion of <nfs/nfs_mount.h> which only affects nextstep3, on
	* {lib,amq,amd}/*.c (many functions): cast xdr_entry to
	XDRPROC_T_TYPE.
	* libamu/mount_fs.c (mnt_flags): support either nfs or generic
	* lib/nfs_prot_svc.c (nfs_program_2): cast xdr_entry to
	XDRPROC_T_TYPE.

	* lib/nfs_prot_xdr.c (xdr_entry): cast xdr_entry to
	XDRPROC_T_TYPE.

	* lib/wire.c (getwire): Make sure safe assignment from const to
	none is done.
	file in the am-utils' home page, as well as a few other useful
Sat Feb 15 19:38:51 1997  Erez "HWank1" Zadok  <ezk@vir.cs.columbia.edu>
Mon Nov 17 05:22:56 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* aux/macros/expand_cpp_int.m4: new macro for expanding integers.
	*******************************************************************
	* aux/configure.in: added linux/fs.h support in configure and
	several M4 macros.

	* conf/mount/mount_linux.c (mount_linux): use macro instead of
	"ugly" fixed hex number for mount() arguments.
	ports.
Sat Feb 15 02:09:47 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/info_hesiod.c: removed macro HAVE_HS_ZONE_TRANSFER and
	turned all of its code always on.  That code always seems to
	compile, as long as you have hesiod and libresolv.
	* scripts/amd.conf.5: corrected info for -o/-O options.
	* amd/mapc.c: removed macro HAVE_HS_ZONE_TRANSFER and turned all
	of its code always on.
	OS name.
	* aux/configure.in: removed superfluous test for hs_zone_transfer
	function (will never find it because it is an amd-internal
	function).
	-o and -O options.
	* amd/mapc.c (maptypes): must used correct new name for am-utils'
	hesiod initialization function: hesiod_am_init.

	* amd/info_hesiod.c (hesiod_am_init): renamed hesiod_init to
	hesiod_am_init so as not to conflict with libhesiod's
	hesiod_init() function.
	variable.
	* aux/configure.in: added test and explicit inclusion of
	libresolv.a for later resolution of library references with
	libhesiod.
	<metcalf@cag.lcs.mit.edu> to correctly set the nfs_prot headers
	* aux/macros/opt_cppflags.m4: new file.  configure/compile C
	preprocessor flags.
	* doc/am-utils.texi (Distrib): typo in the subscription
	* aux/macros/opt_libs.m4: new file.  configure/compile library
	flags.
	<vogel@physik-rzu.unizh.ch>.
	* Makefile.am (EXTRA_DIST_AUX): include two new macros
	opt_cppflags.m4 and opt_libs.m4.
1997-11-15  Erez Zadok  <ezk@amtrak.cs.columbia.edu>
	* aux/configure.in: test for libhesiod needs to additional
	libresolv to link completely.  Additional configuration time
	options added for setting initial CPPFLAGS and LIBS.

Tue Feb 10 02:15:40 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	* NFS3 works on powerpc-ibm-aix4.2.1.0.

	*** Released am-utils-6.0a1					***
	static.  Some compilers (gcc from egcs  on aix 4.2.1) corrupt the
	stack of an automatic variable when pointer to it is passed around
Thu Feb  6 02:55:19 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_ndbm.c (ndbm_search,ndbm_init): fixed the code so that
	it works on freebsd, where they map dbm_pagfno a non-existing
	macro on purpose, to force you to port the code to Berkeley DB.
	* libamu/xutil.c (real_plog): syslog like behavior for normal
Fri Jan 31 01:35:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_afs.c (mount_toplvl): added a sleep(1) right before the
	actual mount_toplvl, to avoid some possible race conditions.

Thu Jan 30 02:31:49 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/rpc_fwd.c: removed all TLI (HAVE_T_OPEN) code.

Wed Jan 29 18:25:07 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* lib/wire.c (getwire): removed HAVE_T_OPEN (TLI code)
	passed to it before.  So now I have to dereference the pointer
	* amd/amd.c (main): fix local address using htonl(). Free up
	buffers allocated by netdir_*() functions.

Wed Jan 22 23:53:24 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/fix-amd-map.in: new script that will convert old-style amd
	maps to new one.
	compute_nfs_args() and compute_automounter_nfs_args() functions.
Tue Jan 21 01:18:16 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	and cleaner compute_nfs_args() and compute_automounter_nfs_args()
	* FIRST AMD IN AM-UTILS FINALLY WORKS (mounts itself as toplvl,
	and replies back to simple nfs/link type mount queries).
	relates for struct nfs_args.  A new function sets the numerous
	* conf/mtab/mtab_svr4.c: reorganized the code in this file to be
	easier to read, and fixed a few bugs with un/setting the lock file
	descriptor.
	libamu.  This saves on overall size of code.
Wed Jan  8 15:27:49 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	mounting an automounter's mount point.  Used by hlfsd and amd.
	* amd/sched.c: removed HAS_SVR3_SIGNALS code to handle older
	signals in Svr3 systems.  Only stellix ever used this.
	* amq/amq.c (get_secure_amd_client): don't print any more
	* amd/rpc_fwd.c (fwd_reply): removed all code that was triggered
	by DYNAMIC_BUFFERS, since it was not in use.
	under DEBUG only.
Tue Jan  7 00:45:59 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/opts.c (eval_opts): removed AMD_COMPAT code.  Amd no longer
	takes '=' sign as old selector.  Fix your maps.
	(deslashify): removed APOLLO code that treated two '//' as one.
	for file systems based on physical media (disk, cdrom, floppy) to
Sun Jan  5 01:25:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	autoconf searches for all these types of mount table entries for a
	* amd/ops_nfsx.c (nfsx_init): removed HARD_NFSX_ERRORS, code which
	was not used.  It made any submount error fail the whole group.
	the actual name found!  Same for ufs, cdfs, pcfs, tmpfs, lofs,
	* amd/ops_nfs.c (make_nfs_auth): removed code dependent on
	HAS_NFS_QUALIFIED_NAMES.
	(mount_nfs_fh): removed macro for NFS_ARGS_NEEDS_PATH, assuming it
	is never on.  So code that was triggered by #ifndef
	NFS_ARGS_NEEDS_PATH (osf1, aix3, and bsd44 variants) may have to
	be fixed later.
	Removed all ULTRIX_HACK code.  Ultrix is DEAD!
	removed all PRESET_AC code, which was only on for Linux to preset
	the attribute cache values (otherwise they default to zero).
	(nfs_umounted): revobed KICK_KERNEL code (IRIX systems).  Will
	have to fixed up later.
	(mount_nfs_fh): removed code that was never included, which
	attempted to set the port on which amd's nfs mounts on.  This
	isn't supported by the ping algorithm yet.  In any case, it is all
	done in nfs_init().

	* amd/srvr_nfs.c (find_nfs_srvr), amd/ops_nfs.c (mount_nfs_fh):
	removed HAS_TCP_NFS code.  The whole use of NFS V.3 with TCP or
	specially hacked NFS V.2 that uses TCP (BSD 4.4 variants) will
	have to be addressed later.
Sun Oct 26 19:32:57 1997  Erez Zadok  <ezk@defiant.soscorp.com>
	* amd/nfs_subr.c (nfsproc_getattr_2): removed all code dependent
	on PRECISE_SYMLINKS.
	This works better on bsdi2 and bsdi3, because their portmapper
	* amd/mapc.c (mapc_meta_search): removed code that depended on
	HAS_DEPOT.  It is known buggy code.  The whole DEPOT support needs
	to be rethought.
	(mapc_add_kv): ported code to use standard regular expression
	(regexp) library.
	insecure).
	* amd/{map.c,ops_sfs.c,ops_ufs.c}: removed all code dependent on
	FLUSH_KERNEL_NAME_CACHE and the macro itself.
	*** Released am-utils-6.0a13					***
Sat Jan  4 15:46:58 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
Fri Oct 24 05:04:37 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* amd/map.c (exported_ap_alloc): removed all code triggered by
	SHRINK_EXPORTED_AP and the macro itself.
	struct datum typedef.
	* amd/info_nis.c: removed HAS_NIS_RELOAD macro, and left the code
	in all the time.  Assuming that there is always NIS realod
	available.
	(yp_all_fixed): removed code for BROKEN_YP_ALL.  If your yp_all()
	function is broken such that it does not release filedescriptors
	it created, then you are hosed.  Get a fix for yp_all from your
	vendor or switch operating systems.

Tue Dec 31 15:34:36 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	gid_t.
	* amd/info_hesiod.c: renamed macro HAS_HESIOD_RELOAD to
	HAVE_HS_ZONE_TRANSFER.
	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): don't use
Mon Dec 30 17:33:23 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/{nfs,host}_ops.cremoved INFORM_MOUNTD macro, so its code is
	always included.  We should always try to inform the remove mount
	daemon of mounts we performed.  If we want an option for this, it
	should be a run-time option.

	* amd/host_ops.c: removed all that optionally did not make the
	directory mount points for amd.

	* HOST_EXEC code removed from everywhere.  There is no indication
	that it was used anywhere.  If it needs to be used, then a
	run-time switch should control it.

Thu Dec 26 00:06:52 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	passwdfile option.  If hlfsd is started with -P passwdfile, then
	* amd/*_ops.c: removed all references to mntent_t's fields
	mnt_freq and mnt_passno, since they are no longe rused (and never
	have been).
	read and checked.  All the rest are ignored.  No NIS/netgroup
	* amd/am_ops.c: removed function sunos4_match, which was off
	anyway.  This was one of the places where an '=' sign was allowed
	as an assignment operator (which is now ':=').

	* amd/afs_ops.c (afs_bgmount): removed SUNOS4_COMPAT code which
	was off anyway.  This was one of the places where an '=' sign was
	allowed as an assignment operator (which is now ':=').
	-h is invoked.
Tue Dec 24 01:53:52 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
Wed Oct 22 00:16:39 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>
	* amq/amq.c: ported to am-utils.  Working.

	* conf/mount/mount_svr4.c (mount_svr4): changed mount type on svr4
	to be string, as it should be (rather than a string mapped to int
	and back mapped to string).
	which returns TRUE if 'arg' is any one of this host's networks.
Sun Dec 22 13:26:05 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	all networks names and numbers in the order of the interface (not
	* lib/mount_fs.c (mount_fs): removed MNTINFO_PREF code.
Mon Oct 20 01:59:25 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>
	* lib/umount_fs.c: split this into three files: default, osf, and
	bsd44, that are in conf/umount/umount_*.c.
	* aux/configure.in: don't add ops_ufs.o on AIX twice.  My code
Thu Dec 19 17:33:46 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>
	* doc/Makefile.am (EXTRA_DIST): include am-utils.dvi and
	* aux/configure.in, aux/aclocal.m4, aux/acconfig.h: added new
	macro to automatically figure out if an external definition for
	sys_errlist[] exists.
	(html): generate html documentation for
	* lib/xutil.c (xfree): removed "#undef free" because it's not
	needed there.  Any system that redefines free() needs help.

	* conf/mtab/mtab_file.c (REWRITE_MTAB_IN_PLACE): removed code that
	was dependent on REWRITE_MTAB_IN_PLACE.  It does not appear to be
	in active use anywhere.  If added later, it should be a run-time
	configuration option.
	ypall_callback_fxn_t.  The NetBSD team compiles all sources with
	* conf/mtab/mtab_mach3.c: removed code that was #ifdef'ed not to
	be MOUNT_TABLE_ON_FILE, since mach2 always stores its mount tables
	in a file in /etc.
	function typedef.
	* lib/util.c (str3cat): removed _AIX code.  AIX should have a
	working realloc, or else find a cleaner solution to this.
	(mkdirs): removed SUNOS4_WORKAROUND code.  This was to do a sync()
	after immediately making directories so that fsck will be able to
	fix the filesystem in the event of an immediate crash.  This was
	because a bug in UFS which is fixed by now.
	* libamu/xutil.c (amu_release_controlling_tty): new function to
	* lib/hutil.c (domain_strip): removed PARTIAL_DOMAINS triggered
	code.  Does not appear to be on and used anywhere.
	(dofork): removed MACH3 code, b/c mach3 NFS bugs are fixed by now.
	and hlfsd/hlfsd.c.  Also avoid setpgrp(), because it works on some
	* lib/resvport.c: split the binding of reserved ports code to a
	separate file.  A #define (HAVE_T_OPEN) separates the TLI (SVR4)
	from the BSD code.

Thu Dec 19 02:08:35 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* lib/Makefile.am (amu_LIBADD): includs @LIBOBJS@ now, auto-filled
	in by automake and configure, for optional sources that need to be
	built as part of libamu.a.

	* aux/aclocal.m4: Make sure AC_CHECK_MOUNT_STYLE adds mountutil.o
	to LIBOBJS.

	* lib/memcmp.c (memcmp): new file added to replace a possible bad
	implementation of memcmp.

Wed Dec 18 22:20:23 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* converted the sources to use memset/memmove/memcmp instead of
	bzero/bcopy/bcmp.

	* ran all sources through gnu Indent w/ options specified in
	aux/amindent.

Wed Dec 11 22:19:29 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* At this point the initial genration of config.h via autoconf and
	some preliminary makefiles via automake is done.  I will not begin
	modifying sources, so it's a good time to document from here.

Wed Dec 10 22:19:29 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Initial ChangeLog Entry					***
	*******************************************************************

	* amd/ops_afs.c (mount_toplvl): turn on 'ignore' option in nfs
	mount flags of toplvl mounts.  Important esp. for HPUX 10.  Now
	hpux-10 will mount amd's mounts points as 'ignore' (by df).

	* aux/configure.in: check for NFS mount option 'ignore', useful in
	HPUX 10.

Thu Oct 16 03:28:33 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_hide_mount_type.m4: hpux 10 should use "ignore"
	mount type and not NFS, for the amd mount points.

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): don't log
	an RPC timeout as an error, but just an info message.  From
	Andreas Stolcke <stolcke@speech.sri.com>

	* If the NFS server is down or does not support the portmapper
	call (such as certain Novell NFS servers) we mark it as version 2
	and we let the nfs code deal with the case that is down.  If when
	the server comes back up, it can support NFS V.3 and/or TCP, it
	will use those.  From christos@deshaw.com (Christos Zoulas).

	* hlfsd/homedir.c (plt_print): various compile time cleanups to
	printfs that take a long, but pass an int to print.  From
	christos@deshaw.com (Christos Zoulas).

	* aux/macros/func_bad_yp_all.m4 (ac_cv_func_yp_all_clean,): new
	macro to determine if the OS has a bad yp_all(), based on the host
	OS name.  So far only irix (all versions) have a bad yp_all, so
	they will use am_yp_all() instead (which is slower as it
	enumerates manually all of the map's entries).

Thu Oct 16 03:14:37 1997  Erez Zadok  <ezk@subzero.cs.columbia.edu>

	* amd/info_nis.c (am_yp_all): code for a replacement yp_all that
	avoids using a file-descriptor leaking yp_all() on some systems
	like irix.

Wed Oct 15 21:52:35 1997  Erez Zadok  <ezk>

	* fsinfo/fsinfo.h: avoid redefining yywrap incorrectly on DU-4.x
	systems using /usr/bin/flex.

	* amd/conf_tok.l (yywrap): avoid redefining yywrap for systems
	that have a modified GNU flex which does define yywrap (DU-4.x).

Fri Sep 26 14:25:29 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/checkmount/checkmount_bsd44.c: include prototype.

Fri Sep 26 01:26:24 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a12					***
	*******************************************************************

Fri Sep 26 00:13:48 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_irix6.h: completely turn off all autofs
	code in irix6 until it can be tested correctly

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): time out
	on clnt_create for 3 seconds, rather than wait for the much longer
	default.

	* conf/nfs_prot/nfs_prot_aix4_2.h: port to powerpc-ibm-aix4.2.1.0.
	Includes NFS3, untested.

Thu Sep 25 11:03:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_pcfs.c (mount_pcfs): fill in uid/gid fields of
	pcfs_args_t if they exist.

	* amd/ops_cdfs.c (mount_cdfs): fill in ssector field of
	cdfs_args_t if it exists.

	* new minor ports hppa1.1-hp-hpux10.10, hppa1.1-hp-hpux9.05,
	hppa1.1-hp-hpux9.07, m68k-hp-hpux9.00, and sparc-sun-sunos4.1.4.

Wed Sep 24 00:48:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (wire-test): updated documentation for the new
	option.

	* wire-test/wire-test.8: updated man page for new option.

	* wire-test/wire-test.c (main): added a test for various
	combinations of NFS proto/vers to a remote/local host.

	* aux/macros/try_compile_anyfs.m4 (AC_TRY_COMPILE): include
	<isofs/cd9660/cd9660_mount.h> and <msdosfs/msdosfsmount.h> so that
	freebsd will correctly set mount options for pcfs and cdfs.

	* amd/ops_pcfs.c (mount_pcfs): set mask field of pcfs_args to
	0777 (if field exists).

	* aux/macros/try_compile_anyfs.m4 (AC_TRY_COMPILE): include
	<msdosfs/msdosfsmount.h> if available.

	* minor new port: rs6000-ibm-aix4.1.4.0.

	* libamu/mount_fs.c (mount_fs): fixed bug that caused HPUX not to
	write the "time" field in /etc/mnttab.

	* conf/mtab/mtab_file.c (mnt_dup): fixed typo in macro names for
	detecting mnt_time field of mntent_t.

	* libamu/mtab.c (mnt_free): fixed typo in macro names for
	detecting mnt_time field of mntent_t.

Tue Sep 23 15:30:03 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mtab/mtab_file.c (lock): Use flock() in preference over
	fcntl() to lock the mtab file.

Mon Sep 22 23:04:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_sockets.c (get_nfs_version): define
	the try_again goto label only for NFS3.
	(pmap_ping): assume timeout failure of clnt_stat.

	* libamu/xdr_func.c (xdr_groupnode, xdr_exportnode): cast to
	"groups *".

Mon Sep 22 20:34:33 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* conf/transp/transp_sockets.c (pmap_ping): patch from Dan Riley
	<dsr@mail.lns.cornell.edu> to make sure that amd works with more
	secure portmappers that do not allow forwarding of RPC messages to
	other services.

	* */Makefile.am: all source files should also depend on the new
	include/am_xdr_func.h header.

	* include/am_xdr_func.h: new file as part of the code cleanup from
	Christos Zoulas <christos@deshaw.com>.

	* Lots of fixes from Christos Zoulas <christos@deshaw.com> that
	involved missing prototypes, cleaned up ones, and removal of
	unused variables.

	* libamu/xdr_func.c (xdr_mountres3): some code cleanup.  A switch
	statement with only one case is unclean.

Mon Sep 22 17:26:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_<FOO>fs.c (mount_<FOO>fs): initialize mntent_t fields to
	0 so that all fields are initialized to zero at first.  This way
	SunOS 4.x and other systems don't get /etc/mtab entries with
	random integers for the fsck/freq fields. Patch from Andreas
	Stolcke <stolcke@speech.sri.com>.

Mon Sep 22 00:34:19 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: include <nfs/nfs_clnt.h> so
	that the important definition for HOSTNAMESZ will be found.

	* amd/ops_afs.c (mount_toplvl): limit hostname size to HOSTNAMESZ
	(inside the nfs_args structure) if the system uses that macro.
	Otherwise systems like SunOS refuse to NFS mount long pathnames
	and result in ENAMETOOLONG errno's.

Wed Sep 17 04:56:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* doc/am-utils.texi (Supported Platforms): specify new support for
	solaris 2.6, and hlfsd running on 2.5.1 too.

Wed Sep 17 03:55:02 1997  Erez Zadok  <ezk@amsterdam.psl.cs.columbia.edu>

	* conf/mount/mount_svr4.c (mount_svr4): don't attemt an autofs
	mount if it is not supported or was turned off.

Wed Sep 17 03:19:36 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: fixed so that it will nfs mount
	again.  Apparently at some previous release SunOS 4 supported was
	broken and all nfs mounts resulted in ESTALE.

Wed Sep 17 00:26:25 1997  Erez Zadok  <ezk@amsterdam.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5_6.h: nfs protocol headers for
	solaris 2.6.

	* aux/macros/check_nfs_prot_headers.m4: added solaris 2.6 nfs
	protocol header selection.

Sat Sep 13 14:31:51 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): avoid
	infinite loop.

Sun Sep  7 18:23:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a11					***
	*******************************************************************

Fri Sep  5 11:55:10 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (main): if plock() succeeded, don't try to display
	errno message.   Patch from Chris Metcalf
	<metcalf@catfish.lcs.mit.edu.

Thu Sep  4 19:17:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/homedir.c (table_add): make sure duplicate passwd entries
	are ignored.   Only the first entry should ever be used, because
	that's how lookup in passwd database works.

	* conf/transp/transp_sockets.c (get_nfs_version): when determining
	if a remote host is up or down, use NFS v.2.  Fix suggested by
	Enami Tsugutomo <enami@cv.sony.co.jp>.

	* conf/transp/transp_tli.c (amu_clnt_create_best_vers): new
	function to get the best possible NFS version, but also timeout
	faster than normal defaults, so remote hosts which are down can be
	detected in a reasonable time.
	(get_nfs_version): use the new "best" function.

Tue Sep  2 00:41:00 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a10					***
	*******************************************************************

Mon Sep  1 15:39:51 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/transp/transp_tli.c (get_nfs_version): don't use
	clnt_tp_create_timed() on systems that don'e have it (Solaris 2.4
	and earlier).

	* aux/configure.in: test for existence of clnt_tp_create_timed(),
	since Solaris 2.4 (and possibly earlier) do not have it.

Mon Sep  1 15:23:18 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* amd/ops_autofs.c (autofs_unmount_1_svc): only display rdevid
	field if it exists (solaris 2.4's autofs does not have it).

Mon Sep  1 14:45:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/type_auth_create_gidlist.m4: a new test to determine
	the correct type to the 5th argument of authunix_create().

Mon Sep  1 03:44:32 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* libamu/xdr_func.c (xdr_umntrequest): add test for autofs
	structure umntrequest, if it has the field rdevid.  Seems Solaris
	2.4 and earlier didn't have it.

Mon Sep  1 01:10:53 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (hlfsd_init): moved initialization upwards, so it
	can be done before primary process forks.
	(main): bug fix: wait a bit to give child a chance to initialize.
	Without this, hlfsd got into a busy infinite loop while, never
	completing the mount.

	* amd/info_nis.c: patch from Jason Thorpe <thorpej@nas.nasa.gov>
	to make amd works when talking to NIS+ servers in NIS
	compatibility mode.

Mon Sep  1 00:46:56 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/mapc.c (MAX_CHAIN): increased maximum chain size to 1024.

Sun Aug 31 20:20:40 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/conf.c (gopt_fully_qualified_hosts): a new function to
	process another new global variable.

	* amd/ops_nfs.c (make_nfs_auth): if a new global variable
	fully_qualified_hosts is on, use FQHN in RPC/NFS authentications.
	Patch from Chris Metcalf <metcalf@catfish.lcs.mit.edu>.

	* amd/conf.c (process_last_regular_map): If the amd.conf file only
	has a [global] section (pretty useless IMHO), do not try to
	process a map that does not exist.

	* scripts/amd.conf.5: fixed typos (repeated 'as' word).

	* doc/am-utils.texi: MAJOR DOCUMENTATION REVISION COMPLETED!!!

	* amd/conf.c (reset_cf_map): Bug fix.  Reset 'tag' field of cfm
	structure, so it does not carry over from map entry to another.

Sat Aug 30 18:39:21 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amd.c (main): fixed the meaning of the plock option.  A bug
	caused it to be reversed.

Sat Aug 30 15:13:18 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/stubs.c: don't initialize some statics here.  They are
	better initialized in hlfsd_init_filehandles().

Fri Aug 22 14:47:16 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (gopt_show_statfs_entries): new function and a global
	amd.conf key show_statfs_entries.  Defaults to 'no'.  If 'yes',
	then all maps flagged as browsable will also show a count of the
	number of entries (keys) in that map.

	* amd/nfs_subr.c (count_map_entries): new function to count number
	of entries in a map.  Now used if browsable is turned on in a map,
	to return a count of available keys in a given map.

	* hlfsd/stubs.c (eq_fh): use correct memcmp().  BUG fixed! hlfsd
	confused the file handles for ".", "..", and the symlink, causing
	mess.

	* aux/macros/func_bad_memcmp.m4: new test, based on autoconf 2.12,
	but also defines HAVE_BAD_MEMCMP, so I avoid linkage conflicts
	with bad memcmp() in libc's (nextstep3).

Thu Aug 21 17:38:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: check if autofs_args_t has a field named
	addr.  Solaris has it for specifying the address of the daemon,
	but Irix does not.  So how does irix tell the kernel the daemon's
	address?  I suspect that it is hardcoded to "localhost" using a
	"private well-known port" (#define AUTOFS_PORT 2048).

	* conf/nfs_prot/nfs_prot_linux.h: added missing autofs
	definitions.

	* README.autofs: new file listing autofs support notes

	* very preliminary autofs code working.  Call it pre-alpha
	quality.

Sun Aug 17 02:25:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf.c (ropt_mount_type, gopt_mount_type): don't accept
	"autofs" if system does not support it.

	* amd/amd.c (main): log am-utils version string (same as amd -v)
	at start of run.

	* conf/transp/transp_sockets.c (get_nfs_version): in order to tell
	if a remote host is available, try to contact its portmapper and
	timeout if no answer is received in 3 seconds.

Thu Aug 14 16:12:04 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_extern.m4 (pattern): use a simpler pattern for
	match for external function definitions.  The function could span
	multiple lines, so only match the opening parenthesis, not the
	closing one too.

	* aux/macros/os_cpp-flags.m4 (ac_cv_os_cppflags,): do NOT turn on
	posix mode for nextstep3.  It is broken.

	* amd/amd.c (init_global_options): run uname() only if
	<sys/utsname.h> and uname(2) exist.

	* amd/rpc_fwd.c (fwd_packet): if remote host is down, the
	forwarding socket is null, so declare this an error.

	* include/am_utils.h (AM_ERRNO_HOST_DOWN): find best errno to set
	for when a remote host is down.  Try, in order, "host down", "host
	unreachable", "invalid argument".

	* amd/ops_nfs.c (discard_fh): don't dereference a null pointer
	(happens when remote host is down, and fp->fh_fs is NULL).
	(prime_nfs_fhandle_cache): ditto, and set fs flags to !FSF_VALID
	and FSF_DOWN.

	* amd/sched.c: nobody uses "union wait" any more, or so it
	appears, so clean up that code.

	* conf/transp/transp_tli.c (get_nfs_version): if remote host is
	down, time it out faster than default (3 seconds).
	(get_mount_client): free netconfig entry when done with it.

	* conf/nfs_prot/nfs_prot_nextstep.h: initial (and somewhat ugly)
	port to nextstep3 (m68k-next-nextstep3).

	* fsinfo/Makefile.am (LDADD): needs to link with libamu in case
	system does not have strdup().

	* include/am_defs.h: complete external definition for getlogin()
	if needed.

	* conf/transp/transp_tli.c (get_nfs_version): no need to keep
	static versout variable.

	* amd/rpc_fwd.c (fwd_packet): if fwdto packet is null, remote
	server is probably down.  Don't use sendto() in that case.

	* buildall (default): run gmake if found, before trying plain
	make.  GNU make is always preferable.

Tue Aug 12 21:23:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/host_macros.m4: cleanup of os_version and os
	overrides.  Solaris 2.5.1 for example will come up as solaris2 and
	2.5.1, rather than sunos5 and 5.5.1.  Both can be overridden in
	the amd.conf file.

Fri Aug  8 14:37:30 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a9					***
	*******************************************************************

Thu Aug  7 00:52:14 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_ncr2.h: new file, for NCR2
	(i486-ncr-sysv4.3.03) headers.  Needed to complete missing stuff
	from <ndbm.h> and <sys/resource.h>.

	* scripts/amd.conf.5: new map page.

	* amd/info_hesiod.c: define extern for hesiod_resolve, since bsdi3
	does not.

	* amd/amd.8: updated man page.

	* amd/get_args.c (get_args): removed defunct -h option to amd.

	* amq/amq.8: updated man page.

	* amd/info_nisplus.c (nisplus_search): prototype fixes so Sun
	SparcCompiler CC won't complain.

	* amd/info_hesiod.c (hesiod_search): small fixes to compile with
	hesiod-1.3, as per Rainer Orth <ro@TechFak.Uni-Bielefeld.DE>.

	* aux/macros/opt_ldflags.m4: new option added to configure
	--enable-ldflags, to specify -L option for configuring/compiling.
	The older one --enable-libs is now to be used only for -l options.

	* amd/ops_nfs.c (mount_nfs_fh): bug fixed.  Should initialize
	nc_protoname from nfs_proto if available for all TLI systems, not
	just those that have NFS V3.

	* amd/info_ldap.c: ldap patches from Leif Johansson
	<leifj@matematik.su.se>, adding two new amd.conf ldap variables:
	ldap_cache_seconds and ldap_cache_maxmem.

	* hlfsd/hlfsd.c (main): bug fixed. port number must be wrapped in
	htons().

Sun Aug  3 17:20:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/nfs_start.c (mount_automounter): register amd with the rpc
	program number that may have been overridden by amd.conf.

	* libamu/xutil.c (set_amd_program_number, get_amd_program_number):
	allow storing and retrieving alternate amd program numbers.

	* amd/conf.c (gopt_portmap_program): new function to parse
	amd.conf entry portmap_program=1234.

	* amq/amq.c (main): allow specifying an alternate rpc program
	number for amd via -P prognum.

	* new amq RPC to get the process id of the running amd.  This is
	used in ctl-amd to quickly find the pid of the amd that is to be
	killed.

	* expanded shared libraries support.  Using GNU libtool-1.0,
	am-utils now builds shared libraries on many platforms that have
	support for it and proper compilers/linkers.  See "INSTALL" file
	for compatibility chart.

Thu Jul 31 13:07:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* fsinfo/fsi_lex.l: removed code that was in support of very old
	versions of flex.  No longer needed.

Tue Jul 29 12:00:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/amd.c (init_global_options): find the kernel architecture
	from uname() if possible.

Mon Jul 28 03:53:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* new working port: i386-unknown-openbsd2.1

Fri Jul 25 03:16:31 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* working port: sparc-sun-solaris2.4.  Had to fix fhandle_t from
	structure to actual char[], because the structure was passed to
	xdr_fhandle as data and not a pointer.  Surprisingly, gcc
	-fpcc-struct-return did not help.
	
	* conf/nfs_prot/nfs_prot_sunos5_4.h: special nfs protocol
	definitions for solaris 2.4 have to be different from 2.3, and
	different from 2.5.

	* libamu/xdr_fhstatus.c (xdr_fhstatus): minor code cleanup.

Thu Jul 24 16:22:39 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mount/mount_svr4.c (mount_svr4): use STREQ to compare mount
	types, not ==.  Fix from Christos Zoulas <christos@deshaw.com>.

	* mk-amd-map/mk-amd-map.8: man page taken from bsd44.

Thu Jul 24 00:01:55 1997  Erez Zadok  <ezk@moisil.cs.columbia.edu>

	* conf/mount/mount_linux.c: made the nfs error mapping code into a
	small function.

Wed Jul 23 16:11:49 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_linux.h (NFS_ERROR_MAPPING): special
	error mappings from errno numbers to NFS errors.  From Debian
	Linux.

	* scripts/am-eject.in (fs): new script (taken from Debian Linux
	folks) to auto-unmount floppy/cd devices before ejecting them.

	* fsinfo/wr_exportfs.c (write_exportfs): from Debian folks, pass
	'5' as second arg to show_area_being_processed.  I'm not sure why.

	* fsinfo/wr_atab.c (write_atab): from Debian folks, pass '5' as
	second arg to show_area_being_processed.  I'm not sure why.

	* conf/mount/mount_linux.c (parse_opts): as per Debian Linux,
	ensure that you have a buffer in *xopts to strcat onto.
	(mount_linux): fixed from Debian folks to ensure that NFS mount
	sockets are connected only for kernels prior to 1.3.10 (avoids
	hangs for multi-homed hosts).

	* amd/mapc.c (make_entry_chain): from Debian folks: don't skip
	over amd map keys that have a prefix, and include the prefix in
	the returned readdir().

	* amd/info_passwd.c (passwd_init, passwd_search): format
	enhancements from the Debian Linux folks.  They added
	- var0:=pw-prefix:=anydir
	- var1:=pw-rhost:=dom3.dom2.dom1
	- var2:=pw-user:=user
	- var3:=pw-home:=/anydir/dom1/dom2/dom3/user

	* new ports: sparc-sun-solaris2.4 and sparc-sun-sunos4.1.1.

	* amd/ops_afs.c (afs_retry): patches from Debian Linux.  If
	afs_mount timed out, then explicitly forbid further retries after
	the timeout.  (afs_bgmount): buf fix from Debian Linux.  Timeout
	values (17 and 5) were mistakenly swapped.

Wed Jul 23 15:53:25 1997  Erez Zadok  <ezk@felix.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5_3.h: turn off non-existent NFS V.3
	support for Solaris 2.4 (the header files incorrectly define parts
	of the NFS V.3 protocol, but the kernel does not support it).

Wed Jul 23 00:07:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_hesiod.c: minor cleanup to use hes_init and hesiod_init
	for determining if using old or new hesiod libraries,
	respectively.

	* amd/ops_nfs.c (mount_nfs_fh): If "noconn" option exists in NFS
	V.3 then use non-connected sockets (both TCP and UDP).  Otherwise
	they cause hangs of mounts from multi-homed hosts when the return
	route is not the same as the outgoing route (esp. on NetBSD
	1.2.1).  If "conn" option was supplied, then don't turn on the
	"noconn" mount option.  Otherwise default to "noconn" mount
	option.

	* aux/configure.in: better check for systems that need libgdbm and
	<ndbm.h>

Tue Jul 22 04:02:05 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main), amd/ops_afs.c (mount_toplvl): ensure that
	mounts are hidden from df(1) on systems that keep mount tables in
	kernel, such as osf1.

Tue Jul 22 02:26:55 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a8					***
	*******************************************************************

Mon Jul 21 21:33:19 1997  Erez Zadok  <ezk@stone.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main): bug fixed: forgot to set sin_family to
	AF_INET when hlfsd mounts itself, thus getting an errno "protocol
	family not supported".

Mon Jul 21 20:46:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* verified that amd on NetBSD 1.2.1 (i386) works, but the OS
	itself is flaky.

	* verified that amd AIX 3 works w/ the new readdir() code.

Mon Jul 21 18:59:30 1997  Erez Zadok  <ezk@chestnut.mcl.cs.columbia.edu>

	* amd/mapc.c (maptypes): changed the default map caching type for
	nis and ndbm maps to "MAPC_ALL", so that all possible entries will
	be available to amd for browsable_dirs=yes.

Mon Jul 21 18:04:16 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir, afs_readdir_browsable): split
	afs_readdir into a browsable version and a non-browsable one.
	Fixed bugs that resulted in an infinite nfs_readdir loop on the
	localhost for some operating systems.

Sat Jul 19 19:38:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir): fixed up the browsable code to
	comply with nfs_readdir specs.  It was returning all entries at
	once, even if there was not enough space in the RPC packet.  Now,
	it sends a reasonably sized chunk, and sets static state to resume
	it for the next continuation RPC of readdir.

	* amd/conf.c (set_conf_kv): fixed bug that resulted in the first
	regular map not getting all of the [global] options defaulted from.

Fri Jul 18 00:45:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c (main): fixed so that portmapper "ping" will only fail
	upon an RPC timeout

	* scripts/ctl-{amd,hlfsd}.in (killproc): better method to find the
	amd/hlfsd process to kill.

	* amd/ops_afs.c (mount_toplvl), hlfsd/hlfsd.c (main): code to
	determine how to avoid df from seeing amd's toplvl mounts.  Moved
	from libamu/mount_fs.c and include/am_utils.h.  Ensure that hlfsd
	is hidden from df.
	(mount_toplvl): fixed df types for irix.

Thu Jul 17 21:59:45 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* amq/amq.c (main): fixed bug that caused the 5 second timeout for
	TLI amq using udp to be ignored.
	(main): if amq cannot contact remote host's portmapper within 5
	seconds, timeout and fail faster than the default longer timeout
	(this is for non-TLI systems).

Thu Jul 17 17:08:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amq/amq.c (get_secure_amd_client): if amq cannot contact
	remote host's portmapper within 5 seconds, timeout and fail faster
	than the default TLI timeout of over 4 minutes.

	* amd/am_ops.c (ops_showfstypes): added styles for new bsd44
	file systems nullfs, unionfs, and umapfs.
	(ops_show1): cleanup code and and reuse this function.
	(vops): empty placeholders for nullfs, unionfs, and umapfs.

	* amd/ops_{nullfs, unionfs, umapfs}.c: 3 new empty templates for
	bsd44 style file systems.

	* fsinfo/fsinfo.8: man page for fsinfo rewritten from bsd44
	sources.

	* amd/conf_tok.l, fsinof/fsi_lex.c: undefine ECHO to avoid
	conflict with systems that define it in <sys/ioctl.h> and also
	define a conflicting one via lex.  Newer versions of f/lex are ok.

Wed Jul 16 00:17:45 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/ops_nfs.c (mount_nfs_fh): fill in nfs_args' fields
	acdirmin/max and acregmin/max only if they exist.

	* aux/configure.in: test for nfs_args fields acdirmin and
	acregmin.

Tue Jul 15 17:24:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: commented out checking for MNT2_GEN_OPT_* for
	"nondev" and commented back in checking for "nodev".  This was a
	typo.

	* include/am_compat.h: more compatibility options: define "ro"
	mnttab option all the time.  Define "overlay" as needed.  Added
	more fillers of mnttab options (as per Daniel S. Riley
	<dsr@mail.lns.cornell.edu>), for acdirmax, acdirmin, acregmax,
	acregmin, noac, grpid, nosuid, and actimo.

	* libamu/mount_fs.c (mnt_flags): fixed a typo in "ro" option as
	per dsr@mail.lns.cornell.edu (Daniel S. Riley).  Then cleaned up
	the same code for other options in struct opt_tab.

Mon Jul 14 22:36:37 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/get_args.c (get_args): moved amd.conf file parsing to before
	the switching the default log/debug options.  Suggested by
	dsr@mail.lns.cornell.edu (Daniel S. Riley).

	* aux/update_build_version: new script to record the build version
	of amd, along with the rest of the info thet comes up with amd -v.

Sun Jul 13 00:30:24 1997  Erez Zadok  <ezk@decca.damtp.cam.ac.uk>

	* aux/macros/os_cflags.m4: new macro, to add additional
	compilation options (also used during configuration), based on the
	OS and the compiler.  Used for solaris-2.6, osf, and irix6.

Fri Jul 11 10:15:11 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/conf_tok.l, conf_parse.y: allow values of keys to include
	white spaces, if they are double-quoted (key="some value")

	* amd/info_hesiod.c (hesiod_search): cleanup and minor bug fixes
	of hesiod from Danny Braniss <danny@cs.huji.ac.il>.

Fri Jul 11 02:16:06 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a7					***
	*******************************************************************

Thu Jul 10 12:19:25 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* include/am_defs.h: fill in extern definition of innetgr() in
	case system headers don't.

	* aux/macros/path_prog_lex.m4 aux/configure.in: using macros that
	will show the full pathname to yacc/bison and f/lex.  Some systems
	have older or bad versions of those and this way the user will
	know for sure what is being invoked.

	* tasks: file populated with todo items.

	* scripts/amd2ldif.in: Script to convert amd maps to plain text
	LDAP object files.  Contributed by Leif Johansson
	<leifj@matematik.su.se>.

	* aux/config.guess: added recognition for sun3's running 4.2bsd,
	from Tom Schmidt <tschmidt@micron.com>.  Fixed one small typo.

	* amd/conf.c: several variables that were local to a map, were
	also added to [global], where they apply to all maps.  Each map
	can then individually override those defaults.  Flags
	affected: browsable_dirs and mount_type.  Options affected:
	map_type, map_options, and search_path.

	* amd/amd.h: eliminated several global flags each of which took an
	int, in favor of one global flags variable used as a bit field.

	* amd/amd.c (init_global_options): moved all global variables into
	a single struct amu_global_options, so it is easier to add new
	ones and/or identify existing ones.

	* amd/get_args.c (get_args): removed unused amd -m option.

	* amd/conf.c (gopt_cluster): added new amd.conf option for cluster
	name, same as amd -C.

	* amd/info_ldap.c: LDAP info map functions from Leif Johansson
	<leifj@matematik.su.se>.

	* amd/conf.c (gopt_ldap_base, gopt_ldap_hostports): put in global
	amd.conf options for ldap_base and ldap_hostports.

	* amd/opts.c (f_netgrp): new amd map function netgrp(ARG) to test
	if the current host is in the ARG host netgroup.

	* aux/configure.in: some systems replaced dbm in libc with GNU's
	libgdbm, so check for libgdbm, but only if dbm_open is not in
	libc already.  This was a recommendation from Tom Schmidt
	<tschmidt@micron.com>.

	* conf/nfs_prot/nfs_prot_sunos5_3.h: port to sparc-sun-solaris2.3
	completed.

Wed Jul  9 18:14:59 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* port to sparc-unknown-netbsd1.2E done, not tested.  Includes NFS
	V.3.

Tue Jul  8 17:35:07 1997  Erez Zadok  <ezk@elk.mcl.cs.columbia.edu>

	* port to i386-unknown-freebsd3.0 done and working.  Includes NFS
	V.3.

	* aux/macros/check_nfs_fh_dref.m4: freebsd3 should use
	file handle dereferencing style similar to freebsd22.

	* include/am_defs.h: need to include <net/if_var.h> before
	<netinet/if_ether.h> on freebsd3.

	* conf/nfs_prot/nfs_prot_freebsd3.h: new protocol header additions
	for freeBSD 3.0.

Tue Jul  8 16:53:41 1997  Erez Zadok  <ezk@moisil.cs.columbia.edu>

	* amd/info_nis.c (nis_reload): cast nis' callback function so
	picky compilers won't complain.

	* libamu/xdr_mountres3.c (xdr_mountres3): make sure this function
	gets compiled only if the system has NFS V3 and does not have
	xdr_mountres3.

Tue Jul  8 12:42:03 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* COPYING: put in some legal stuff in this file.

Mon Jul  7 19:10:44 1997  Erez Zadok  <ezk@prometheus.soscorp.com>

	* NFS V3 now works under Irix5, thanks to patches from 
	Andreas Stolcke <stolcke@speech.sri.com>.

	* conf/mount/mount_irix5.c: sparate mount_irix.c into an irix5
	version and an irix6 version, since irix5's NFS V3 code is broken
	and hacky.

	* amd/info_hesiod.c (hs_zone_transfer): minor fixes to buffer
	sizes for some hesiod queries.  Patch from Danny Braniss
	<danny@cs.huji.ac.il>.

Mon Jul  7 19:04:14 1997  Erez Zadok  <ezk@glory.soscorp.com>

	* amd/ops_nfs.c (mount_nfs_fh): fixed NFS V.3 support for bsdi3.

Sun Jul  6 14:22:24 1997  Erez Zadok  <ezk@glory.soscorp.com>

	* aux/{configure.in,acconfig.h}: added checks for struct
	nfs_args's fields proto and sotype (bsdi3).
	
	* amd/ops_nfs.c (mount_nfs_fh): added nfsv3 option to
	nfs_args.flags for bsdi3.  Set field proto to 0.  Set sotype field
	to SOCK_STREAM or SOCK_DGRAM.

	* aux/macros/check_mount_style.m4: add case for bsdi3.

	* amd/info_hesiod.c: got hesiod support for bsdi3.

Sun Jul  6 11:14:47 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: look for hesiod on libc (bsdi3)

	* amd/get_args.c (get_args): reformat usage so it fits in 80
	columns.

	* scripts/ctl-amd.in: changed directory name for optional tftpboot
	map to /tftpboot/.amd.

Sat Jul  5 17:46:45 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a6					***
	*******************************************************************

Sat Jul  5 03:17:09 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-amd.in: include -T tag for tftpboot.

	* new port: mips-sgi-irix5.3.  Compiled with gcc, but NFS V3 code
	is broken and needs work on the specific nfs_args that irix5 uses
	for V3 mounts.

Sat Jul  5 01:44:25 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/get_args.c (get_args): new options amd -T tag.  A map with
	tag=foo matching the -T tag will be processed.  All untagged maps
	get processed all the time.

Fri Jul  4 16:19:26 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: need to check for strcasecmp in libucb (ncr2)

	* aux/macros/check_os_libs.m4: a new macro to set the usage of
	libnsl and libsocket based on the OS.

	* libamu/mount_fs.c (mnt_flags): used MNTTAB_OPT_GRPID if it is
	defined (problem on osf4).

	* conf/nfs_prot/nfs_prot_irix5.h: new file for irix5 headers.

	* include/am_defs.h, aux/macros/try_compile_nfs.m4,
	aux/macros/mount_headers.m4: do include <sys/proc.h> because it
	failes on irix5.  Rather, put in the individual
	conf/nfs_prot/nfs_prot_*.h headers.

	* amd/conf.c: AIX3 doesn't like strdup() being passed a constant
	char*, so cast all strdup()'s args to a non-const char*.

	* amd/mapc.c (root_newmap): don't try to strdup only a "const
	char *".

Fri Jul  4 15:47:10 1997  Erez Zadok  <ezk@americas.psl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos4.h: added rpc/rpc.h and
	sys/errno.h.

Thu Jul  3 17:49:00 1997  Erez Zadok  <ezk@prometheus.soscorp.com>

	* made sure am-utils compiles, links, and runs properly on Irix
	6.2 using "cc -32 -Wl,-woff,"

	* aux/macros/check_lib2.m4: a bug fix version to autoconf 2.12
	AC_CHECK_LIB.  If OTHER-LIBRARIES are defined and used, then add
	them to $LIBS.

	* aux/configure.in: some cleanup of which libraries are needed.
	Espectially ensure that libnsl is included only on Solaris, where
	so far it is the only system on which it is absolutely necessary.
	Also no longer need to include libc explicitly. 

	* amd/amd.c,wire-test/wire-test.c (main): convert IP address to
	network-long order before printing it.

	* wire-test/wire-test.c (main): also check and report on the IP
	address of the local host, since some systems have bad versions of
	get_myaddress, or ones that conflict with other versions in
	multiple libraries (SunOS 4 and Irix especially).

Wed Jul  2 18:19:02 1997  Erez Zadok  <ezk@starblazers.soscorp.com>

	* scripts/ctl-amd.in: don't use full pathname so killproc() works
	better.  Also run bsd44 and irix style ps programs. 

	* aux/macros/check_lib_funcs.m4: bug fixed: used to define usage
	of library no matter if it was found or not.

Wed Jul  2 02:11:48 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/macros/check_mnt2_gen_opt.m4: turned back on the checking
	for M_* macros, but ensure that <sys/stream.h> is not included at
	all so it won't conflict with other M_* macros.

Tue Jul  1 21:16:51 1997  Erez Zadok  <ezk@mako.cs.columbia.edu>

	* conf/mount/mount_irix.c (mount_irix): first arg to mount(2) on
	irix should be "spec" (host:/path), not the dir of the mnt point.

	* amd/ops_afs.c (afs_lookuppn): bug in enable_default_selectors
	fixed.  If on, it essentially ignored the setting in a
	selector-controlled /defaults if there were 2 or more entries in it.

Tue Jul  1 12:23:38 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/ctl-{amd,hlfsd}.in (killproc): if failed to find process
	using BSD style ps, then try SVR4 style ps.

	* include/am_utils.h (amuDebug): renamed Debug macro to amuDebug
	etc., to avoid conflicts with similar named macros in <ldap.h>.

	* aux/configure.in, amd/info_ldap.c, etc.: put in all the autoconf
	support needed for LDAP.  Now the code has to be written mostly in
	amd/info_ldap.c.

	* Included additional patches from Andreas Stolcke
	<stolcke@speech.sri.com> to support using the best possible
	combination of NFS version (2,3) and protocol (udp,tcp) for any
	given host, since it appears that some Irix versions have NFS V3,
	but do not support TCP.

	* scripts/ctl-amd.in: updated amd control script to look for and
	use amd.conf file.

Tue Jul  1 00:28:23 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/mapc.c (mapc_create): now, each map in the amd.conf can be
	initialized off of a different type, or default to cycling through
	all maps until one of them matches.

Mon Jun 30 20:49:13 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_afs.c (afs_readdir): per-map browsing (readdir) done.
	if browsable_dirs=yes is set in the map section in amd.conf, that
	map will return all entries back to a readdir(2).

Sun Jun 29 16:22:11 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* rudimentary amd.conf file support included.  You may even
	override things like os=sos5, to get "backwards" compatibilty with
	upl102.

Sat Jun 28 13:35:02 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/conf.c: new file to process amd.conf file.

	* amd/get_args.c (get_args): new options -H to print help.

	* moved enable_default_selectors to be amd.conf controlled, and
	not compiler controlled.

	* amd/get_args.c (get_args): new options -F <conf-file> to parse an
	amd configuration file.

Wed Jun 25 23:15:42 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* converted all files that used strcmp() == 0 or != 0  to using
	the STREQ() macro.

Mon Jun 23 22:31:14 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/macros/check_lib_funcs.m4: new M4 macro that can be used to
	search for any number of functions in any given library.

Mon Jun 23 01:04:23 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/mapc.c: Included patch from Leif Johansson
	<leifj@matematik.su.se> to ensure that systems without an RE
	library can compile.

	* libamu/mount_fs.c (mount_fs): Included patch from Andreas
	Stolcke <stolcke@speech.sri.com>, to ensure that mount options on
	table are properly delimited by a comma.

	* amd/ops_nfs.c (mount_nfs_fh): Included patch from Andreas
	Stolcke <stolcke@speech.sri.com>, to allow users to override the
	proto= and vers= mount options.

Sun Jun 22 01:00:11 1997  Eric Dana  (edana@ncr2.bgs.com)

	* conf/nfs_prot/nfs_prot_svr4.h: port completed to
	i486-ncr-sysv4.3.03.  Assorted source cleanups done.

	* include/am_defs.h, aux/macros/mount_headers.m4: don't include
	mnttab.h if sys/mnttab.h was already included, because on ncr2,
	they contain conflicting entries for struct mnttab.

Sat Jun 21 23:52:15 1997  Eric Dana  (edana@ncr2.bgs.com)

	* aux/macros/check_nfs_prot_headers.m4: added support for ncr2.

Fri Jun 20 06:14:17 1997  Erez Zadok  <ezk>

	* amd/*.c: lots of 64-bit "ugly" ports like casts to long ints.

	* aux/macros/struct_nfs_fh.m4: check for "struct nfssvcfh" because
	on DU-4.0 it is better than the next one to be picked (nfsv2fh_t).

Wed Jun 18 18:59:49 1997  Erez Zadok  <ezk@defiant.soscorp.com>

	* aux/macros/struct_nfs_fh.m4 (AC_TRY_COMPILE_NFS): check for
	nfsv2fh_t before fhandle_t becasue on bsdi2.1 the former is
	better.

Tue Jun 10 17:06:58 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/rpc_fwd.c (fwd_packet): TLI bug fix. if fwdto socket is
	NULL, set the maxlen and len fields in netbuf to zero.

Wed May 28 22:52:28 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/fix-amd-map.in (name): replace all matching patterns on
	line.

Sun May 25 19:33:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a5					***
	*******************************************************************

Sun May 25 13:37:24 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amq_subr.c (amqproc_getvers_1_svc): amq's RPC service
	procedure now returns the full string that amd -v returns.

	* amd/get_args.c (get_version_string): new function to return
	complete version/info string so it could be used more flexibly.

	* amd/am_ops.c (ops_showamfstypes, ops_showfstypes): put the list
	of Fs types into a string buffer, rather than a FILE*.

	* amd/mapc.c (mapc_showtypes): put the list of map types into a
	string buffer, rather than a FILE*.

Sun May 25 01:25:36 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/get_args.c (get_args): amd -v also prints user who built
	amd, hostname built on, and date of configuration.

Sat May 24 13:40:50 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* scripts/lostaltmail.conf-sample: sample lostaltmail
	configuration file.

	* scripts/lostaltmail.in: new script lostaltmail used to redeliver
	"lost" mail that hlfsd redirected to a temp location because the
	primary home file system of the user was full.

	* scripts/amd2sun.in: new script amd2sun. Used to convert Sub
	automount maps to amd maps.

	* scripts/ctl-hlfsd.in: new script ctl-hlfsd.  Used to start,
	stop, or restart hlfsd.
	
	* scripts/expn.1: man page for expn command.

	* scripts/ctl-amd.in: new script ctl-amd.  Used to start, stop, or
	restart amd.

	* scripts/expn.in: new script expn.  Actually taken from David
	Muir Sharnoff <muir@idiom.com>.  Used by hlfsd's mail re-delivery
	script.

	* scripts/wait4amd.in: new script wait4amd added.  Waits for amd
	to come up on a host, and then runs a command (rsh $hostname by
	default).

	* scripts/Makefile.am: new directory now holds all shell/perl
	scripts that belong to am-utils.

	* conf/mount/mount_linux.c (parse_opts): new parser for
	linux-specific mounts.  Handles fs-type specific mount-options
	correctly.  Currently implemented: msdos, iso9660.

	* amd/ops_pcfs.c (pcfs_ops): don't timeout cdfs mounts by default
	(fix for linux).

	* amd/ops_cdfs.c (cdfs_ops): don't timeout cdfs mounts by default
	(fix for linux).

	* amd/mapc.c (make_entry_chain): fixed bug that resulted in amd
	core dumps upon "ls" of a mount point; an invalid pointer was
	being returned and dereferenced.

	* port to Linux sparc working!

	* hlfsd/homedir.c (hlfsd_diskspace): close file descriptor if
	failed to write test file, or else the fd will leak.

Sun May 18 00:42:41 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_hesiod.c (hs_strip_our_domain): use strcasecmp()
	instead of strcmp().

	* Port to Digital Unix 4.0 (OSF) done.

	* hlfsd/hlfsd.c: renamed dirname to dir_name to avoid conflicts
	with dirname() function in <string.h> on OSF systems.

	* fsinfo/fsi_util.c (set_ether_if): take out extern defintion of
	inet_addr().  It should come from <arpa/inet.h> instead.

	* conf/mtab/mtab_osf.c: fixed macros and added NFS V3 specs.

	* include/am_utils.h: renamed FIRST/LAST to AM_FIRST/AM_LAST to
	avoid conflicts with DU 4.0 system header.

Thu May 15 22:49:12 1997  Erez Zadok  <ezk@subzero.cs.columbia.edu>

	* libamu/mount_fs.c (mount_fs): pass along NFS version so I can
	determine if to include additional options in the mount table file
	entry (such as proto=tcp, and vers=3).

Thu May 15 00:42:12 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* libamu/mount_fs.c (mount_fs): include NFS version number in the
	mount table options, as well as proto={tcp,udp}.

Wed May 14 14:30:19 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* NFS V3 code ported to most other systems, so it compiles for V2
	and V3 NFS systems.

	* NFS VERSION 3 support, first pass.  Working for Solaris and
	using TCP.

Sun May 11 01:14:29 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* amq/amq.c: many newline characters were missing from various
	stderr printfs.

Sat May 10 13:09:06 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_sunos5.h: protocol defintions for
	Solaris, which include NFS V3 support.

	* conf/nfs_prot/nfs_prot_default.h: default NFS protocol headers.

	* conf/transp/transp_{tli,sockets}.c (get_mount_client): use NFS
	protocol version while getting a mount client.

	* amd/ops_nfs.c (mount_nfs_fh): set the mount types, mnttab types,
	file handle size, and proper file handle based on the correct NFS
	version number.

	* conf/mount/mount_svr4.c (mount_svr4): support NFS3 mounts under
	Solaris and other SVR4 systems.

	* amd/ops_nfs.c: store NFS file handle version and version
	specific handle in struct fh_cache.
	(got_nfs_fh): pick the correct RPC reply based on the NFS version
	of the server.
	(prime_nfs_fhandle_cache): figure out the right NFS file handle
	for a node, but now include NFS protocol version information.
	(call_mountd): set the correct version for the mount protocol,
	based on the NFS protocol version.
	(nfs_init): use the NFS protocol generic structure
	am_nfs_handle_t.

	* include/am_utils.h: new structure am_nfs_handle_t to contain all
	possible versions of NFS file handles.

	* amd/srvr_nfs.c (start_ping): ping program performs NFS version
	specific pings.
	(recompute_portmap): figure out the correct portmap version mount.
	(nfs_keepalive): call start_ping() with the correct NFS version.
	(find_nfs_srvr): if mount option "vers=" is given, use it.  Get
	the NFS server version and verify that it is up.

	* conf/transp/transp_{tli,sockets}.c (get_nfs_version): a new
	function to find the best NFS version for a particular host.

	* libamu/amu.h: determine what is the highest version of NFS we
	should try.

	* include/am_utils.h (NFS_VERSION3): added definition for NFS V3
	protocol number.
	Added field fs_version to struct fserver, so we can now store the
	server protocol version.

Fri May  9 01:09:45 1997  Erez Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/macros/check_field.m4 (AC_MOUNT_HEADERS): map '.' (dot) into
	underscores too, so I can test for sub-fields.

	* libamu/wire.c: use test that checks for sub-fields of struct
	ifreq.

Sat May  6 10:20:17 2000  Erez Zadok  <ezk@glory.soscorp.com>

	* port to BSD/OS 3.0 completed!  Many xdr_ functions were broken
	into smaller files.  M4 macros fixed to test for existence of
	file systems using getvfsbyname().

	* amd/sched.c (sigchld): signal handler must waitpid() for all
	possible children.

	* hlfsd/homedir.c: signal handler must waitpid() for all possible
	children. 

	* aux/macros/check_restartable_signals.m4: new macro to determine
	if need to reinstall signal handlers per OS is better than trying
	to figure these out based on system macros.

Fri May  5 19:23:28 2000  Erez Zadok  <ezk@glory.soscorp.com>

	* amd/ops_nfs.c (mount_nfs_fh): set nfs_args_t version number.

	* amd/ops_afs.c (mount_toplvl): set nfs_args_t version number.

	* amd/ops_nfs.c (mount_nfs_fh): process nfs mount option resvport
	(must be supplied for bsdi 3.0)

	* libamu/wire.c: use HAVE_FIELD_STRUCT_IFREQ_IFR_ADDR (and
	associated new macro) for determining the right way to compute the
	size of the interface structure.

Fri Apr 11 15:56:13 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* aux/configure.in: need to include libc before libnsl if
	get_myaddress() is available because on irix libnsl has a buggy
	get_myaddress().

	* include/am_defs.h: make sure REINSTATE_SIGNAL_HANDLER is defined
	on Irix 6 (an SVR4 variant)

Thu Mar 27 02:28:40 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a4					***
	*******************************************************************

Wed Mar 26 21:15:36 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/amq_subr.c (ok_security): turned off insecure code unless
	user explicitly runs configure --enable-amq-mount.

	* hlfsd/hlfsd.c (main): use new protoypes dor create_nfs_service().

	* amd/nfs_start.c (mount_automounter): use code that separately
	creates the NFS and the amq service.  Register tcp and udp
	services for amd.

	* conf/transp/transp_*.c (create_amq_service): new function to
	separately create the amq service for amd.  Simplified prototypes
	for create_nfs_service().

Wed Mar 19 20:40:56 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a3					***
	*******************************************************************

Wed Mar 19 17:49:18 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* new port: rs6000-ibm-aix3.2.5 and rs6000-ibm-aix4.1.5.0.  Lots
	of small changes to support these two.

Wed Mar 19 14:33:30 1997  Erez Zadok  <ezk@grande.cs.columbia.edu>

	* conf/umount/umount_default.c (umount_fs): bug: unlock_mntlist()
	should run if MOUNT_TABLE_ON_FILE, not otherwise.

Mon Mar 17 22:02:43 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* hlfsd/hlfsd.c (main): fill in fhsize field if exists
	(freebsd-2.2).

	* amd/ops_{nfs,afs}.c (mount_toplvl): fill in fhsize field if
	exists (freebsd-2.2).

Sat Mar 15 19:37:48 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* new port: i386-unknown-freebsd2.2.  FreeBSD 2.2 and higher
	changed the filehandle type in struct nfs_args from nfsv2fh_t to
	u_char.

Sat Mar 14 10:11:03 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* SHARED LIBRARIES: too many change to list individually.  Now,
	libamu can be built as a shared library, and other programs link
	with it.

Tue Mar 11 22:24:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/macros/opt_shared.m4: new macro for setting options for
	building shared am-utils libraries.

Sun Mar  9 19:17:46 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* fixmount/fixrmtab: cleaned up the script.

	* fixmount/Makefile.am (EXTRA_DIST): adde $(sbin_SCRIPTS) so that
	fixrmtab gets distributed too.

	* conf/nfs_prot/nfs_prot_bsdi2.h: added support for MOUNTPROC_DUMP.
	Added extern for xdr_mountlist().

	* aux/configure.in: trimmed down many tests for MNT2_GEN_OPT,
	MNT2_NFS_OPT, and MNTTAB_OPT that were not referenced anywhere in
	the sources.

Sat Mar  8 00:23:58 1997  Erez Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* fixmount/hlfsd ported to bsd44, hpux, and linux systems.

	* aux/macros/check_fixmount_style.m4: add check for bsd44 systems.

	* conf/fixmount/fixmount_default.c: use lockf() if flock() is
	unavailable.

	* include/am_defs.h: include <string.h> even if don't have
	STDC_HEADERS defined (sunos4).
	(seteuid): define seteuid() to be setresuid() for systems that
	have but not the other (hpux).

	* aux/macros/check_extern.m4: test should include <strings.h>.

Tue Mar  4 17:16:52 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* lib/xutil.c (debug_option): moved from amd/getargs.c to this
	more proper file.

	* include/am_utils.h: put in structure for debug options, for all
	progams to use.

	* amd/get_args.c: moved structure for debug options out.

Sun Mar  2 00:13:07 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* ported fixmount.

	* lib/ualarm.c: replacement function for systems that don't have a
	ualarm().

	* ported fsinfo.

Sun Mar  1 10:23:34 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* ported mk-amd-map.

	* buildall: added -K option to buildall, to run mkconf.

Fri Feb 28 01:10:25 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a2					***
	*******************************************************************

Thu Feb 27 13:58:59 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* all *.[hcyl] files: add copyright line.

	* aux/macros/check_mount_type.m4: test for mount type for
	linux-like systems, by checking for loadable or statically linked
	kernel filesystem modules.

	* aux/macros/check_mnttab_type.m4: test for mount table entry
	for linux-like systems, by checking for loadable or statically
	linked kernel filesystem modules.

	* aux/configure.in: pcfs filesystems can use vfat type (linux)

	* aux/macros/check_fs_mntent.m4: test for filesystem existence for
	linux-like systems, by checking for loadable or statically linked
	kernel filesystem modules.

	* conf/trap/trap_hpux.h: ugly hack added because of stupide HPUX
	9.0 header files.  This should be removed when HPUX 9.0 is deemed
	defunct.

	* aux/acconfig.h: set an undefined variable for having an extern
	to clnt_sperrno().

	* include/am_defs.h: define extern for clnt_sperrno() if needed.

	* aux/configure.in: test for extern clnt_sperrno().

	* aux/macros/check_nfs_fh_dref.m4: HPUX's NFS fhandle dref is
	similar to irix.

	* aux/macros/check_mount_style.m4: use mount helper on HPUX.

	* aux/macros/check_mtype_type.m4: hpux's mount type is a char*,
	not integer (but may be mapped to one later).

	* conf/mount/mount_hpux.c (mount_hpux): HPUX has confusing header
	files.  They have mount(2) and vfsmount(2) which don't take same
	arguments, and they have string mount types MNTTYPE_* as well as
	integer types MOUNT_*.  So I need this new mount function to map
	from string types to integer types for the vfsmount() function.

	* conf/trap/trap_hpux.h (MOUNT_TRAP): instead of calling
	vfsmount(), call mount_hpux().

Thu Feb 27 03:34:14 1997  Erez "HWank1" Zadok  <ezk@okeeffe.cs.columbia.edu>

	* lib/mount_fs.c (mnt_flags): make sure SYNC option is on only if
	both MNTTAB_OPT_SYNC and MNT2_GEN_OPT_SYNC are defined.

Thu Feb 27 00:26:00 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/nfs_prot/nfs_prot_hpux.h: NFS protocol definitions for
	hpux.

	* include/am_defs.h: no need to include rpc/auth.h or rpc/clnt.h.

	* aux/configure.in: no need to test for rpc/auth.h and rpc/clnt.h.

	* buildall: added ability to configure using other shells than
	/bin/sh, on those systems where /bin/sh is buggy or limited
	(HPUX).

	* aux/macros/struct_nfs_fh.m4: reinstated the macro but have it
	defined am_nfs_fh, and also test for plain typedef "nfs_fh".

	* aux/acconfig.h: #undef am_nfs_fh, which is being defined by a
	reinstated macro.

	* aux/configure.in: check for <nfs/export.h>

	* include/am_defs.h: include <nfs/export.h> (HPUX) if exists.

	* aux/macros/try_compile_nfs.m4: include <nfs/export.h> (HPUX) if
	exists.

	* aux/macros/mount_headers.m4 (define): removed some non-working
	(on HPUX) code that attempts to recreate the fhandle_t rather than
	load it up from system headers.  Also added some NFS protocol
	header inclusion.  include <nfs/export.h> (HPUX) if exists.

Wed Feb 26 00:32:35 1997  Erez "HWank1" Zadok  <ezk@okeeffe.cs.columbia.edu>

	* aux/macros/mount_headers.m4 (define): Use M4 changequote to
	ensure [] brackets are correctly used.

	* aux/macros/expand_cpp_{string,hex,int}.m4: encapsulate
	multi-line M4 inclusions in [].

Tue Feb 25 22:19:44 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* conf/mtab/mtab_bsd.c (mnt_dup): use statfs field f_fstypename if
	it exists.

	* aux/acconfig.h: HAVE_FIELD_STRUCT_STATFS_F_FSTYPENAME, new
	config.h macro for field f_fstypename of struct statfs.

	* aux/configure.in: testing for field f_fstypename field of struct
	statfs (NetBSD).

	* aux/acconfig.h: moved all of the "static" definitions out to a
	fixed file called include/am_defs.h.  Added to all */Makefile.am
	files a dependency on am_defs.h.  Created am_defs.h of course, and
	then added #include <amd_defs.h> to all of the source and header
	files that required it.

Mon Feb 24 01:27:02 1997  Erez Zadok  <ezk@defiant.soscorp.com>

	* aux/acconfig.h: two more externals for xdr functions that may be
	implemented by libamu.

	* conf/nfs_prot/nfs_prot_bsdi2.h: added missing RPC and XDR
	definitions.

Sun Feb 23 15:25:26 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* buildall (default): added -D option for turning on even stricker
	developer options.

	* */Makefile.am: make sure @AMU_NFS_PROT_HEADERS@ is used to
	determine dependencies on optional NFS protocol headers.

	* aux/acconfig.h: define and use HAVE_NFS_PROT_HEADERS as needed.

	* aux/macros/check_nfs_prot_header.m4: new test to determine what
	NFS protocol headers to use. 

	* conf/nfs_prot/nfs_prot_{irix6,sunos4,bsdi2}.h: new headers to
	complete missing system headers for NFS protocol definitions.

Sun Feb 16 15:58:42 1997  Erez "HWank1" Zadok  <ezk@vir.cs.columbia.edu>

	* amd/ops_nfs.c (mount_nfs_fh): encapsulated some more code in
	#ifdef's as needed.

	* amd/ops_afs.c (mount_toplvl): make sure TIMEO/RETRANS code is
	suitable #ifdef'ed.

	* include/am_compat.h: a couple more mnttab options
	(timeo/retrans) setting just in case.

	* amd/autil.c (host_normalize): make sure hostent->h_name is
	passed a non-const char *.

	* conf/mount/mount_linux.c (mount_linux): cleaned up a block of code.

	* {lib,amq,amd}/*.c (many functions): cast xdr_entry to
	XDRPROC_T_TYPE.

	* lib/nfs_prot_svc.c (nfs_program_2): cast xdr_entry to
	XDRPROC_T_TYPE.

	* lib/nfs_prot_xdr.c (xdr_entry): cast xdr_entry to
	XDRPROC_T_TYPE.

	* lib/wire.c (getwire): Make sure safe assignment from const to
	none is done.

Sat Feb 15 19:38:51 1997  Erez "HWank1" Zadok  <ezk@vir.cs.columbia.edu>

	* aux/macros/expand_cpp_int.m4: new macro for expanding integers.

	* aux/configure.in: added linux/fs.h support in configure and
	several M4 macros.

	* conf/mount/mount_linux.c (mount_linux): use macro instead of
	"ugly" fixed hex number for mount() arguments.

Sat Feb 15 02:09:47 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/info_hesiod.c: removed macro HAVE_HS_ZONE_TRANSFER and
	turned all of its code always on.  That code always seems to
	compile, as long as you have hesiod and libresolv.

	* amd/mapc.c: removed macro HAVE_HS_ZONE_TRANSFER and turned all
	of its code always on.

	* aux/configure.in: removed superfluous test for hs_zone_transfer
	function (will never find it because it is an amd-internal
	function).

	* amd/mapc.c (maptypes): must used correct new name for am-utils'
	hesiod initialization function: hesiod_am_init.

	* amd/info_hesiod.c (hesiod_am_init): renamed hesiod_init to
	hesiod_am_init so as not to conflict with libhesiod's
	hesiod_init() function.

	* aux/configure.in: added test and explicit inclusion of
	libresolv.a for later resolution of library references with
	libhesiod.

	* aux/macros/opt_cppflags.m4: new file.  configure/compile C
	preprocessor flags.

	* aux/macros/opt_libs.m4: new file.  configure/compile library
	flags.

	* Makefile.am (EXTRA_DIST_AUX): include two new macros
	opt_cppflags.m4 and opt_libs.m4.

	* aux/configure.in: test for libhesiod needs to additional
	libresolv to link completely.  Additional configuration time
	options added for setting initial CPPFLAGS and LIBS.

Tue Feb 10 02:15:40 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	*******************************************************************
	*** Released am-utils-6.0a1					***
	*******************************************************************

Thu Feb  6 02:55:19 1997  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* amd/info_ndbm.c (ndbm_search,ndbm_init): fixed the code so that
	it works on freebsd, where they map dbm_pagfno a non-existing
	macro on purpose, to force you to port the code to Berkeley DB.

Fri Jan 31 01:35:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_afs.c (mount_toplvl): added a sleep(1) right before the
	actual mount_toplvl, to avoid some possible race conditions.

Thu Jan 30 02:31:49 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/rpc_fwd.c: removed all TLI (HAVE_T_OPEN) code.

Wed Jan 29 18:25:07 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* lib/wire.c (getwire): removed HAVE_T_OPEN (TLI code)

	* amd/amd.c (main): fix local address using htonl(). Free up
	buffers allocated by netdir_*() functions.

Wed Jan 22 23:53:24 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/fix-amd-map.in: new script that will convert old-style amd
	maps to new one.

Tue Jan 21 01:18:16 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* FIRST AMD IN AM-UTILS FINALLY WORKS (mounts itself as toplvl,
	and replies back to simple nfs/link type mount queries).

	* conf/mtab/mtab_svr4.c: reorganized the code in this file to be
	easier to read, and fixed a few bugs with un/setting the lock file
	descriptor.

Wed Jan  8 15:27:49 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/sched.c: removed HAS_SVR3_SIGNALS code to handle older
	signals in Svr3 systems.  Only stellix ever used this.

	* amd/rpc_fwd.c (fwd_reply): removed all code that was triggered
	by DYNAMIC_BUFFERS, since it was not in use.

Tue Jan  7 00:45:59 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/opts.c (eval_opts): removed AMD_COMPAT code.  Amd no longer
	takes '=' sign as old selector.  Fix your maps.
	(deslashify): removed APOLLO code that treated two '//' as one.

Sun Jan  5 01:25:09 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/ops_nfsx.c (nfsx_init): removed HARD_NFSX_ERRORS, code which
	was not used.  It made any submount error fail the whole group.

	* amd/ops_nfs.c (make_nfs_auth): removed code dependent on
	HAS_NFS_QUALIFIED_NAMES.
	(mount_nfs_fh): removed macro for NFS_ARGS_NEEDS_PATH, assuming it
	is never on.  So code that was triggered by #ifndef
	NFS_ARGS_NEEDS_PATH (osf1, aix3, and bsd44 variants) may have to
	be fixed later.
	Removed all ULTRIX_HACK code.  Ultrix is DEAD!
	removed all PRESET_AC code, which was only on for Linux to preset
	the attribute cache values (otherwise they default to zero).
	(nfs_umounted): revobed KICK_KERNEL code (IRIX systems).  Will
	have to fixed up later.
	(mount_nfs_fh): removed code that was never included, which
	attempted to set the port on which amd's nfs mounts on.  This
	isn't supported by the ping algorithm yet.  In any case, it is all
	done in nfs_init().

	* amd/srvr_nfs.c (find_nfs_srvr), amd/ops_nfs.c (mount_nfs_fh):
	removed HAS_TCP_NFS code.  The whole use of NFS V.3 with TCP or
	specially hacked NFS V.2 that uses TCP (BSD 4.4 variants) will
	have to be addressed later.

	* amd/nfs_subr.c (nfsproc_getattr_2): removed all code dependent
	on PRECISE_SYMLINKS.

	* amd/mapc.c (mapc_meta_search): removed code that depended on
	HAS_DEPOT.  It is known buggy code.  The whole DEPOT support needs
	to be rethought.
	(mapc_add_kv): ported code to use standard regular expression
	(regexp) library.

	* amd/{map.c,ops_sfs.c,ops_ufs.c}: removed all code dependent on
	FLUSH_KERNEL_NAME_CACHE and the macro itself.

Sat Jan  4 15:46:58 1997  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/map.c (exported_ap_alloc): removed all code triggered by
	SHRINK_EXPORTED_AP and the macro itself.

	* amd/info_nis.c: removed HAS_NIS_RELOAD macro, and left the code
	in all the time.  Assuming that there is always NIS realod
	available.
	(yp_all_fixed): removed code for BROKEN_YP_ALL.  If your yp_all()
	function is broken such that it does not release filedescriptors
	it created, then you are hosed.  Get a fix for yp_all from your
	vendor or switch operating systems.

Tue Dec 31 15:34:36 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/info_hesiod.c: renamed macro HAS_HESIOD_RELOAD to
	HAVE_HS_ZONE_TRANSFER.

Mon Dec 30 17:33:23 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/{nfs,host}_ops.cremoved INFORM_MOUNTD macro, so its code is
	always included.  We should always try to inform the remove mount
	daemon of mounts we performed.  If we want an option for this, it
	should be a run-time option.

	* amd/host_ops.c: removed all that optionally did not make the
	directory mount points for amd.

	* HOST_EXEC code removed from everywhere.  There is no indication
	that it was used anywhere.  If it needs to be used, then a
	run-time switch should control it.

Thu Dec 26 00:06:52 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amd/*_ops.c: removed all references to mntent_t's fields
	mnt_freq and mnt_passno, since they are no longe rused (and never
	have been).

	* amd/am_ops.c: removed function sunos4_match, which was off
	anyway.  This was one of the places where an '=' sign was allowed
	as an assignment operator (which is now ':=').

	* amd/afs_ops.c (afs_bgmount): removed SUNOS4_COMPAT code which
	was off anyway.  This was one of the places where an '=' sign was
	allowed as an assignment operator (which is now ':=').

Tue Dec 24 01:53:52 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* amq/amq.c: ported to am-utils.  Working.

	* conf/mount/mount_svr4.c (mount_svr4): changed mount type on svr4
	to be string, as it should be (rather than a string mapped to int
	and back mapped to string).

Sun Dec 22 13:26:05 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* lib/mount_fs.c (mount_fs): removed MNTINFO_PREF code.

	* lib/umount_fs.c: split this into three files: default, osf, and
	bsd44, that are in conf/umount/umount_*.c.

Thu Dec 19 17:33:46 1996  Erez "HWank1" Zadok  <ezk@lorien.cs.columbia.edu>

	* aux/configure.in, aux/aclocal.m4, aux/acconfig.h: added new
	macro to automatically figure out if an external definition for
	sys_errlist[] exists.

	* lib/xutil.c (xfree): removed "#undef free" because it's not
	needed there.  Any system that redefines free() needs help.

	* conf/mtab/mtab_file.c (REWRITE_MTAB_IN_PLACE): removed code that
	was dependent on REWRITE_MTAB_IN_PLACE.  It does not appear to be
	in active use anywhere.  If added later, it should be a run-time
	configuration option.

	* conf/mtab/mtab_mach3.c: removed code that was #ifdef'ed not to
	be MOUNT_TABLE_ON_FILE, since mach2 always stores its mount tables
	in a file in /etc.

	* lib/util.c (str3cat): removed _AIX code.  AIX should have a
	working realloc, or else find a cleaner solution to this.
	(mkdirs): removed SUNOS4_WORKAROUND code.  This was to do a sync()
	after immediately making directories so that fsck will be able to
	fix the filesystem in the event of an immediate crash.  This was
	because a bug in UFS which is fixed by now.

	* lib/hutil.c (domain_strip): removed PARTIAL_DOMAINS triggered
	code.  Does not appear to be on and used anywhere.
	(dofork): removed MACH3 code, b/c mach3 NFS bugs are fixed by now.

	* lib/resvport.c: split the binding of reserved ports code to a
	separate file.  A #define (HAVE_T_OPEN) separates the TLI (SVR4)
	from the BSD code.

Thu Dec 19 02:08:35 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* lib/Makefile.am (amu_LIBADD): includs @LIBOBJS@ now, auto-filled
	in by automake and configure, for optional sources that need to be
	built as part of libamu.a.

	* aux/aclocal.m4: Make sure AC_CHECK_MOUNT_STYLE adds mountutil.o
	to LIBOBJS.

	* lib/memcmp.c (memcmp): new file added to replace a possible bad
	implementation of memcmp.

Wed Dec 18 22:20:23 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* converted the sources to use memset/memmove/memcmp instead of
	bzero/becopy/bcmp.

	* ran all sources through gnu Indent w/ options specified in
	aux/amindent.

Wed Dec 11 22:19:29 1996  Erez "HWank1" Zadok  <ezk@shekel.mcl.cs.columbia.edu>

	* At this point the initial genration of config.h via autoconf and
	some preliminary makefiles via automake is done.  I will not begin
	modifying sources, so it's a good time to document from here.
